/*
 * CairoMatrix.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_freedesktop_cairo_CairoMatrix.h"

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoMatrix_cairo_1matrix_1rotate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _angle
)
{
	cairo_matrix_t* self;
	double angle;

	// convert parameter self
	self = (cairo_matrix_t*) _self;

	// convert parameter angle
	angle = (double) _angle;

	// call function
	cairo_matrix_rotate(self, angle);

	// cleanup parameter self

	// cleanup parameter angle
}

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoMatrix_cairo_1matrix_1translate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _tx,
	jdouble _ty
)
{
	cairo_matrix_t* self;
	double tx;
	double ty;

	// convert parameter self
	self = (cairo_matrix_t*) _self;

	// convert parameter tx
	tx = (double) _tx;

	// convert parameter ty
	ty = (double) _ty;

	// call function
	cairo_matrix_translate(self, tx, ty);

	// cleanup parameter self

	// cleanup parameter tx

	// cleanup parameter ty
}

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoMatrix_cairo_1matrix_1scale
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _sx,
	jdouble _sy
)
{
	cairo_matrix_t* self;
	double sx;
	double sy;

	// convert parameter self
	self = (cairo_matrix_t*) _self;

	// convert parameter sx
	sx = (double) _sx;

	// convert parameter sy
	sy = (double) _sy;

	// call function
	cairo_matrix_scale(self, sx, sy);

	// cleanup parameter self

	// cleanup parameter sx

	// cleanup parameter sy
}
