/*
 * CairoPattern.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_freedesktop_cairo_CairoPattern.h"

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1destroy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	cairo_pattern_t* self;

	// convert parameter self
	self = (cairo_pattern_t*) _self;

	// call function
	cairo_pattern_destroy(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1reference
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	cairo_pattern_t* result;
	jlong _result;
	cairo_pattern_t* self;

	// convert parameter self
	self = (cairo_pattern_t*) _self;

	// call function
	result = cairo_pattern_reference(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1create_1for_1surface
(
	JNIEnv* env,
	jclass cls,
	jlong _surface
)
{
	cairo_pattern_t* result;
	jlong _result;
	cairo_surface_t* surface;

	// convert parameter surface
	surface = (cairo_surface_t*) _surface;

	// call function
	result = cairo_pattern_create_for_surface(surface);

	// cleanup parameter surface

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1create_1rgba
(
	JNIEnv* env,
	jclass cls,
	jdouble _red,
	jdouble _green,
	jdouble _blue,
	jdouble _alpha
)
{
	cairo_pattern_t* result;
	jlong _result;
	double red;
	double green;
	double blue;
	double alpha;

	// convert parameter red
	red = (double) _red;

	// convert parameter green
	green = (double) _green;

	// convert parameter blue
	blue = (double) _blue;

	// convert parameter alpha
	alpha = (double) _alpha;

	// call function
	result = cairo_pattern_create_rgba(red, green, blue, alpha);

	// cleanup parameter red

	// cleanup parameter green

	// cleanup parameter blue

	// cleanup parameter alpha

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1create_1linear
(
	JNIEnv* env,
	jclass cls,
	jdouble _x0,
	jdouble _y0,
	jdouble _x1,
	jdouble _y1
)
{
	cairo_pattern_t* result;
	jlong _result;
	double x0;
	double y0;
	double x1;
	double y1;

	// convert parameter x0
	x0 = (double) _x0;

	// convert parameter y0
	y0 = (double) _y0;

	// convert parameter x1
	x1 = (double) _x1;

	// convert parameter y1
	y1 = (double) _y1;

	// call function
	result = cairo_pattern_create_linear(x0, y0, x1, y1);

	// cleanup parameter x0

	// cleanup parameter y0

	// cleanup parameter x1

	// cleanup parameter y1

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1create_1radial
(
	JNIEnv* env,
	jclass cls,
	jdouble _cx0,
	jdouble _cy0,
	jdouble _radius0,
	jdouble _cx1,
	jdouble _cy1,
	jdouble _radius1
)
{
	cairo_pattern_t* result;
	jlong _result;
	double cx0;
	double cy0;
	double radius0;
	double cx1;
	double cy1;
	double radius1;

	// convert parameter cx0
	cx0 = (double) _cx0;

	// convert parameter cy0
	cy0 = (double) _cy0;

	// convert parameter radius0
	radius0 = (double) _radius0;

	// convert parameter cx1
	cx1 = (double) _cx1;

	// convert parameter cy1
	cy1 = (double) _cy1;

	// convert parameter radius1
	radius1 = (double) _radius1;

	// call function
	result = cairo_pattern_create_radial(cx0, cy0, radius0, cx1, cy1, radius1);

	// cleanup parameter cx0

	// cleanup parameter cy0

	// cleanup parameter radius0

	// cleanup parameter cx1

	// cleanup parameter cy1

	// cleanup parameter radius1

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1add_1color_1stop_1rgb
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _offset,
	jdouble _red,
	jdouble _green,
	jdouble _blue
)
{
	cairo_pattern_t* self;
	double offset;
	double red;
	double green;
	double blue;

	// convert parameter self
	self = (cairo_pattern_t*) _self;

	// convert parameter offset
	offset = (double) _offset;

	// convert parameter red
	red = (double) _red;

	// convert parameter green
	green = (double) _green;

	// convert parameter blue
	blue = (double) _blue;

	// call function
	cairo_pattern_add_color_stop_rgb(self, offset, red, green, blue);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter red

	// cleanup parameter green

	// cleanup parameter blue
}

JNIEXPORT void JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1add_1color_1stop_1rgba
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _offset,
	jdouble _red,
	jdouble _green,
	jdouble _blue,
	jdouble _alpha
)
{
	cairo_pattern_t* self;
	double offset;
	double red;
	double green;
	double blue;
	double alpha;

	// convert parameter self
	self = (cairo_pattern_t*) _self;

	// convert parameter offset
	offset = (double) _offset;

	// convert parameter red
	red = (double) _red;

	// convert parameter green
	green = (double) _green;

	// convert parameter blue
	blue = (double) _blue;

	// convert parameter alpha
	alpha = (double) _alpha;

	// call function
	cairo_pattern_add_color_stop_rgba(self, offset, red, green, blue, alpha);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter red

	// cleanup parameter green

	// cleanup parameter blue

	// cleanup parameter alpha
}

JNIEXPORT jint JNICALL
Java_org_freedesktop_cairo_CairoPattern_cairo_1pattern_1status
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	cairo_status_t result;
	jint _result;
	cairo_pattern_t* self;

	// convert parameter self
	self = (cairo_pattern_t*) _self;

	// call function
	result = cairo_pattern_status(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
