/*
 * AtkDocument.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkDocument.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkDocument_atk_1document_1get_1document_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	AtkDocument* self;

	// convert parameter self
	self = (AtkDocument*) _self;

	// call function
	result = atk_document_get_document_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkDocument_atk_1document_1get_1attribute_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _attributeName
)
{
	const gchar* result;
	jstring _result;
	AtkDocument* self;
	const gchar* attributeName;

	// convert parameter self
	self = (AtkDocument*) _self;

	// convert parameter attributeName
	attributeName = (const gchar*) (*env)->GetStringUTFChars(env, _attributeName, NULL);
	if (attributeName == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = atk_document_get_attribute_value(self, attributeName);

	// cleanup parameter self

	// cleanup parameter attributeName
	(*env)->ReleaseStringUTFChars(env, _attributeName, attributeName);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkDocument_atk_1document_1set_1attribute_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _attributeName,
	jstring _attributeValue
)
{
	gboolean result;
	jboolean _result;
	AtkDocument* self;
	const gchar* attributeName;
	const gchar* attributeValue;

	// convert parameter self
	self = (AtkDocument*) _self;

	// convert parameter attributeName
	attributeName = (const gchar*) (*env)->GetStringUTFChars(env, _attributeName, NULL);
	if (attributeName == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter attributeValue
	attributeValue = (const gchar*) (*env)->GetStringUTFChars(env, _attributeValue, NULL);
	if (attributeValue == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = atk_document_set_attribute_value(self, attributeName, attributeValue);

	// cleanup parameter self

	// cleanup parameter attributeName
	(*env)->ReleaseStringUTFChars(env, _attributeName, attributeName);

	// cleanup parameter attributeValue
	(*env)->ReleaseStringUTFChars(env, _attributeValue, attributeValue);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
