/*
 * AtkEditableText.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkEditableText.h"

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1set_1text_1contents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string
)
{
	AtkEditableText* self;
	const gchar* string;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter string
	string = (const gchar*) (*env)->GetStringUTFChars(env, _string, NULL);
	if (string == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	atk_editable_text_set_text_contents(self, string);

	// cleanup parameter self

	// cleanup parameter string
	(*env)->ReleaseStringUTFChars(env, _string, string);
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1insert_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string,
	jint _length,
	jintArray _position
)
{
	AtkEditableText* self;
	const gchar* string;
	gint length;
	gint* position;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter string
	string = (const gchar*) (*env)->GetStringUTFChars(env, _string, NULL);
	if (string == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter length
	length = (gint) _length;

	// convert parameter position
	position = (gint*) (*env)->GetIntArrayElements(env, _position, NULL);
	if (position == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	atk_editable_text_insert_text(self, string, length, position);

	// cleanup parameter self

	// cleanup parameter string
	(*env)->ReleaseStringUTFChars(env, _string, string);

	// cleanup parameter length

	// cleanup parameter position
	(*env)->ReleaseIntArrayElements(env, _position, (jint*)position, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1copy_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_copy_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1cut_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_cut_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1delete_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startPos,
	jint _endPos
)
{
	AtkEditableText* self;
	gint startPos;
	gint endPos;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter startPos
	startPos = (gint) _startPos;

	// convert parameter endPos
	endPos = (gint) _endPos;

	// call function
	atk_editable_text_delete_text(self, startPos, endPos);

	// cleanup parameter self

	// cleanup parameter startPos

	// cleanup parameter endPos
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkEditableText_atk_1editable_1text_1paste_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position
)
{
	AtkEditableText* self;
	gint position;

	// convert parameter self
	self = (AtkEditableText*) _self;

	// convert parameter position
	position = (gint) _position;

	// call function
	atk_editable_text_paste_text(self, position);

	// cleanup parameter self

	// cleanup parameter position
}
