/*
 * AtkImage.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkImage.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkImage_atk_1image_1get_1image_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	AtkImage* self;

	// convert parameter self
	self = (AtkImage*) _self;

	// call function
	result = atk_image_get_image_description(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkImage_atk_1image_1get_1image_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	AtkImage* self;
	gint* width;
	gint* height;

	// convert parameter self
	self = (AtkImage*) _self;

	// convert parameter width
	width = (gint*) (*env)->GetIntArrayElements(env, _width, NULL);
	if (width == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter height
	height = (gint*) (*env)->GetIntArrayElements(env, _height, NULL);
	if (height == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	atk_image_get_image_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);

	// cleanup parameter height
	(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkImage_atk_1image_1set_1image_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _description
)
{
	gboolean result;
	jboolean _result;
	AtkImage* self;
	const gchar* description;

	// convert parameter self
	self = (AtkImage*) _self;

	// convert parameter description
	description = (const gchar*) (*env)->GetStringUTFChars(env, _description, NULL);
	if (description == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = atk_image_set_image_description(self, description);

	// cleanup parameter self

	// cleanup parameter description
	(*env)->ReleaseStringUTFChars(env, _description, description);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkImage_atk_1image_1get_1image_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y,
	jint _coordType
)
{
	AtkImage* self;
	gint* x;
	gint* y;
	AtkCoordType coordType;

	// convert parameter self
	self = (AtkImage*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter coordType
	coordType = (AtkCoordType) _coordType;

	// call function
	atk_image_get_image_position(self, x, y, coordType);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);

	// cleanup parameter coordType
}
