/*
 * AtkRelation.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkRelation.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_atk_AtkRelation_atk_1relation_1new
(
	JNIEnv* env,
	jclass cls,
	jlongArray _targets,
	jint _nTargets,
	jint _relationship
)
{
	AtkRelation* result;
	jlong _result;
	AtkObject** targets;
	gint nTargets;
	AtkRelationType relationship;

	// convert parameter targets
	targets = (AtkObject**) bindings_java_convert_jarray_to_gpointer(env, _targets);
	if (targets == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter nTargets
	nTargets = (gint) _nTargets;

	// convert parameter relationship
	relationship = (AtkRelationType) _relationship;

	// call function
	result = atk_relation_new(targets, nTargets, relationship);

	// cleanup parameter targets
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)targets, _targets);

	// cleanup parameter nTargets

	// cleanup parameter relationship

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkRelation_atk_1relation_1get_1relation_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	AtkRelationType result;
	jint _result;
	AtkRelation* self;

	// convert parameter self
	self = (AtkRelation*) _self;

	// call function
	result = atk_relation_get_relation_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkRelation_atk_1relation_1add_1target
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _target
)
{
	AtkRelation* self;
	AtkObject* target;

	// convert parameter self
	self = (AtkRelation*) _self;

	// convert parameter target
	target = (AtkObject*) _target;

	// call function
	atk_relation_add_target(self, target);

	// cleanup parameter self

	// cleanup parameter target
}
