/*
 * AtkText.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkText.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startOffset,
	jint _endOffset
)
{
	gchar* result;
	jstring _result;
	AtkText* self;
	gint startOffset;
	gint endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter startOffset
	startOffset = (gint) _startOffset;

	// convert parameter endOffset
	endOffset = (gint) _endOffset;

	// call function
	result = atk_text_get_text(self, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter startOffset

	// cleanup parameter endOffset

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jchar JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1character_1at_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset
)
{
	gunichar result;
	jchar _result;
	AtkText* self;
	gint offset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// call function
	result = atk_text_get_character_at_offset(self, offset);

	// cleanup parameter self

	// cleanup parameter offset

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1text_1after_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset,
	jint _boundaryType,
	jintArray _startOffset,
	jintArray _endOffset
)
{
	gchar* result;
	jstring _result;
	AtkText* self;
	gint offset;
	AtkTextBoundary boundaryType;
	gint* startOffset;
	gint* endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// convert parameter boundaryType
	boundaryType = (AtkTextBoundary) _boundaryType;

	// convert parameter startOffset
	startOffset = (gint*) (*env)->GetIntArrayElements(env, _startOffset, NULL);
	if (startOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// convert parameter endOffset
	endOffset = (gint*) (*env)->GetIntArrayElements(env, _endOffset, NULL);
	if (endOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = atk_text_get_text_after_offset(self, offset, boundaryType, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter boundaryType

	// cleanup parameter startOffset
	(*env)->ReleaseIntArrayElements(env, _startOffset, (jint*)startOffset, 0);

	// cleanup parameter endOffset
	(*env)->ReleaseIntArrayElements(env, _endOffset, (jint*)endOffset, 0);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1text_1at_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset,
	jint _boundaryType,
	jintArray _startOffset,
	jintArray _endOffset
)
{
	gchar* result;
	jstring _result;
	AtkText* self;
	gint offset;
	AtkTextBoundary boundaryType;
	gint* startOffset;
	gint* endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// convert parameter boundaryType
	boundaryType = (AtkTextBoundary) _boundaryType;

	// convert parameter startOffset
	startOffset = (gint*) (*env)->GetIntArrayElements(env, _startOffset, NULL);
	if (startOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// convert parameter endOffset
	endOffset = (gint*) (*env)->GetIntArrayElements(env, _endOffset, NULL);
	if (endOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = atk_text_get_text_at_offset(self, offset, boundaryType, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter boundaryType

	// cleanup parameter startOffset
	(*env)->ReleaseIntArrayElements(env, _startOffset, (jint*)startOffset, 0);

	// cleanup parameter endOffset
	(*env)->ReleaseIntArrayElements(env, _endOffset, (jint*)endOffset, 0);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1text_1before_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset,
	jint _boundaryType,
	jintArray _startOffset,
	jintArray _endOffset
)
{
	gchar* result;
	jstring _result;
	AtkText* self;
	gint offset;
	AtkTextBoundary boundaryType;
	gint* startOffset;
	gint* endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// convert parameter boundaryType
	boundaryType = (AtkTextBoundary) _boundaryType;

	// convert parameter startOffset
	startOffset = (gint*) (*env)->GetIntArrayElements(env, _startOffset, NULL);
	if (startOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// convert parameter endOffset
	endOffset = (gint*) (*env)->GetIntArrayElements(env, _endOffset, NULL);
	if (endOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = atk_text_get_text_before_offset(self, offset, boundaryType, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter boundaryType

	// cleanup parameter startOffset
	(*env)->ReleaseIntArrayElements(env, _startOffset, (jint*)startOffset, 0);

	// cleanup parameter endOffset
	(*env)->ReleaseIntArrayElements(env, _endOffset, (jint*)endOffset, 0);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1caret_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	AtkText* self;

	// convert parameter self
	self = (AtkText*) _self;

	// call function
	result = atk_text_get_caret_offset(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1character_1extents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset,
	jintArray _x,
	jintArray _y,
	jintArray _width,
	jintArray _height,
	jint _coords
)
{
	AtkText* self;
	gint offset;
	gint* x;
	gint* y;
	gint* width;
	gint* height;
	AtkCoordType coords;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter width
	width = (gint*) (*env)->GetIntArrayElements(env, _width, NULL);
	if (width == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter height
	height = (gint*) (*env)->GetIntArrayElements(env, _height, NULL);
	if (height == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter coords
	coords = (AtkCoordType) _coords;

	// call function
	atk_text_get_character_extents(self, offset, x, y, width, height, coords);

	// cleanup parameter self

	// cleanup parameter offset

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);

	// cleanup parameter width
	(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);

	// cleanup parameter height
	(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);

	// cleanup parameter coords
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1character_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	AtkText* self;

	// convert parameter self
	self = (AtkText*) _self;

	// call function
	result = atk_text_get_character_count(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1offset_1at_1point
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y,
	jint _coords
)
{
	gint result;
	jint _result;
	AtkText* self;
	gint x;
	gint y;
	AtkCoordType coords;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter coords
	coords = (AtkCoordType) _coords;

	// call function
	result = atk_text_get_offset_at_point(self, x, y, coords);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter coords

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1n_1selections
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	AtkText* self;

	// convert parameter self
	self = (AtkText*) _self;

	// call function
	result = atk_text_get_n_selections(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1selection
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _selectionNum,
	jintArray _startOffset,
	jintArray _endOffset
)
{
	gchar* result;
	jstring _result;
	AtkText* self;
	gint selectionNum;
	gint* startOffset;
	gint* endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter selectionNum
	selectionNum = (gint) _selectionNum;

	// convert parameter startOffset
	startOffset = (gint*) (*env)->GetIntArrayElements(env, _startOffset, NULL);
	if (startOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// convert parameter endOffset
	endOffset = (gint*) (*env)->GetIntArrayElements(env, _endOffset, NULL);
	if (endOffset == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = atk_text_get_selection(self, selectionNum, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter selectionNum

	// cleanup parameter startOffset
	(*env)->ReleaseIntArrayElements(env, _startOffset, (jint*)startOffset, 0);

	// cleanup parameter endOffset
	(*env)->ReleaseIntArrayElements(env, _endOffset, (jint*)endOffset, 0);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1add_1selection
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startOffset,
	jint _endOffset
)
{
	gboolean result;
	jboolean _result;
	AtkText* self;
	gint startOffset;
	gint endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter startOffset
	startOffset = (gint) _startOffset;

	// convert parameter endOffset
	endOffset = (gint) _endOffset;

	// call function
	result = atk_text_add_selection(self, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter startOffset

	// cleanup parameter endOffset

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1remove_1selection
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _selectionNum
)
{
	gboolean result;
	jboolean _result;
	AtkText* self;
	gint selectionNum;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter selectionNum
	selectionNum = (gint) _selectionNum;

	// call function
	result = atk_text_remove_selection(self, selectionNum);

	// cleanup parameter self

	// cleanup parameter selectionNum

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1set_1selection
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _selectionNum,
	jint _startOffset,
	jint _endOffset
)
{
	gboolean result;
	jboolean _result;
	AtkText* self;
	gint selectionNum;
	gint startOffset;
	gint endOffset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter selectionNum
	selectionNum = (gint) _selectionNum;

	// convert parameter startOffset
	startOffset = (gint) _startOffset;

	// convert parameter endOffset
	endOffset = (gint) _endOffset;

	// call function
	result = atk_text_set_selection(self, selectionNum, startOffset, endOffset);

	// cleanup parameter self

	// cleanup parameter selectionNum

	// cleanup parameter startOffset

	// cleanup parameter endOffset

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1set_1caret_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _offset
)
{
	gboolean result;
	jboolean _result;
	AtkText* self;
	gint offset;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter offset
	offset = (gint) _offset;

	// call function
	result = atk_text_set_caret_offset(self, offset);

	// cleanup parameter self

	// cleanup parameter offset

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1range_1extents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startOffset,
	jint _endOffset,
	jint _coordType,
	jlong _rect
)
{
	AtkText* self;
	gint startOffset;
	gint endOffset;
	AtkCoordType coordType;
	AtkTextRectangle* rect;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter startOffset
	startOffset = (gint) _startOffset;

	// convert parameter endOffset
	endOffset = (gint) _endOffset;

	// convert parameter coordType
	coordType = (AtkCoordType) _coordType;

	// convert parameter rect
	rect = (AtkTextRectangle*) _rect;

	// call function
	atk_text_get_range_extents(self, startOffset, endOffset, coordType, rect);

	// cleanup parameter self

	// cleanup parameter startOffset

	// cleanup parameter endOffset

	// cleanup parameter coordType

	// cleanup parameter rect
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_atk_AtkText_atk_1text_1get_1bounded_1ranges
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect,
	jint _coordType,
	jint _xClipType,
	jint _yClipType
)
{
	AtkTextRange** result;
	jlongArray _result;
	AtkText* self;
	AtkTextRectangle* rect;
	AtkCoordType coordType;
	AtkTextClipType xClipType;
	AtkTextClipType yClipType;

	// convert parameter self
	self = (AtkText*) _self;

	// convert parameter rect
	rect = (AtkTextRectangle*) _rect;

	// convert parameter coordType
	coordType = (AtkCoordType) _coordType;

	// convert parameter xClipType
	xClipType = (AtkTextClipType) _xClipType;

	// convert parameter yClipType
	yClipType = (AtkTextClipType) _yClipType;

	// call function
	result = atk_text_get_bounded_ranges(self, rect, coordType, xClipType, yClipType);

	// cleanup parameter self

	// cleanup parameter rect

	// cleanup parameter coordType

	// cleanup parameter xClipType

	// cleanup parameter yClipType

	// translate return value to JNI type
	_result = (jlongArray) NULL;

	// and finally
	return _result;
}
