/*
 * AtkTextRange.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_atk_AtkTextRange.h"

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1get_1start_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	AtkTextRange* self;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// get field value
	result = self->start_offset;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1set_1start_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startOffset
)
{
	AtkTextRange* self;
	gint startOffset;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// convert parameter startOffset
	startOffset = (gint) _startOffset;

	// set field value
	self->start_offset = startOffset;

	// cleanup parameter self

	// cleanup parameter startOffset
}

JNIEXPORT jint JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1get_1end_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	AtkTextRange* self;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// get field value
	result = self->end_offset;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1set_1end_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _endOffset
)
{
	AtkTextRange* self;
	gint endOffset;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// convert parameter endOffset
	endOffset = (gint) _endOffset;

	// set field value
	self->end_offset = endOffset;

	// cleanup parameter self

	// cleanup parameter endOffset
}

JNIEXPORT jstring JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1get_1content
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	AtkTextRange* self;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// get field value
	result = self->content;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_atk_AtkTextRange_atk_1text_1range_1set_1content
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _content
)
{
	AtkTextRange* self;
	gchar* content;

	// convert parameter self
	self = (AtkTextRange*) _self;

	// convert parameter content
	content = (gchar*) (*env)->GetStringUTFChars(env, _content, NULL);
	if (content == NULL) {
		return; // Java Exception already thrown
	}

	// set field value
	self->content = content;

	// cleanup parameter self

	// cleanup parameter content
	(*env)->ReleaseStringUTFChars(env, _content, content);
}
