/*
 * GdkColormap.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkColormap.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1alloc_1colors
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colors,
	jint _ncolors,
	jboolean _writeable,
	jboolean _bestMatch,
	jbooleanArray _success
)
{
	gint result;
	jint _result;
	GdkColormap* self;
	GdkColor* colors;
	gint ncolors;
	gboolean writeable;
	gboolean bestMatch;
	gboolean* success;

	// convert parameter self
	self = (GdkColormap*) _self;

	// convert parameter colors
	colors = (GdkColor*) _colors;

	// convert parameter ncolors
	ncolors = (gint) _ncolors;

	// convert parameter writeable
	writeable = (gboolean) _writeable;

	// convert parameter bestMatch
	bestMatch = (gboolean) _bestMatch;

	// convert parameter success
	success = (gboolean*) (*env)->GetBooleanArrayElements(env, _success, NULL);
	if (success == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gdk_colormap_alloc_colors(self, colors, ncolors, writeable, bestMatch, success);

	// cleanup parameter self

	// cleanup parameter colors

	// cleanup parameter ncolors

	// cleanup parameter writeable

	// cleanup parameter bestMatch

	// cleanup parameter success
	(*env)->ReleaseBooleanArrayElements(env, _success, (jboolean*)success, 0);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1free_1colors
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colors,
	jint _ncolors
)
{
	GdkColormap* self;
	GdkColor* colors;
	gint ncolors;

	// convert parameter self
	self = (GdkColormap*) _self;

	// convert parameter colors
	colors = (GdkColor*) _colors;

	// convert parameter ncolors
	ncolors = (gint) _ncolors;

	// call function
	gdk_colormap_free_colors(self, colors, ncolors);

	// cleanup parameter self

	// cleanup parameter colors

	// cleanup parameter ncolors
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _visual,
	jboolean _allocate
)
{
	GdkColormap* result;
	jlong _result;
	GdkVisual* visual;
	gboolean allocate;

	// convert parameter visual
	visual = (GdkVisual*) _visual;

	// convert parameter allocate
	allocate = (gboolean) _allocate;

	// call function
	result = gdk_colormap_new(visual, allocate);

	// cleanup parameter visual

	// cleanup parameter allocate

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1alloc_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color,
	jboolean _writeable,
	jboolean _bestMatch
)
{
	gboolean result;
	jboolean _result;
	GdkColormap* self;
	GdkColor* color;
	gboolean writeable;
	gboolean bestMatch;

	// convert parameter self
	self = (GdkColormap*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// convert parameter writeable
	writeable = (gboolean) _writeable;

	// convert parameter bestMatch
	bestMatch = (gboolean) _bestMatch;

	// call function
	result = gdk_colormap_alloc_color(self, color, writeable, bestMatch);

	// cleanup parameter self

	// cleanup parameter color

	// cleanup parameter writeable

	// cleanup parameter bestMatch

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1query_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixel,
	jlong _color
)
{
	GdkColormap* self;
	gulong pixel;
	GdkColor* color;

	// convert parameter self
	self = (GdkColormap*) _self;

	// convert parameter pixel
	pixel = (gulong) _pixel;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gdk_colormap_query_color(self, pixel, color);

	// cleanup parameter self

	// cleanup parameter pixel

	// cleanup parameter color
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1get_1visual
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkVisual* result;
	jlong _result;
	GdkColormap* self;

	// convert parameter self
	self = (GdkColormap*) _self;

	// call function
	result = gdk_colormap_get_visual(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkColormap_gdk_1colormap_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GdkColormap* self;

	// convert parameter self
	self = (GdkColormap*) _self;

	// call function
	result = gdk_colormap_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
