/*
 * GdkCursor.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkCursor.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1get_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkCursorType result;
	jint _result;
	GdkCursor* self;

	// convert parameter self
	self = (GdkCursor*) _self;

	// get field value
	result = self->type;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1set_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _type
)
{
	GdkCursor* self;
	GdkCursorType type;

	// convert parameter self
	self = (GdkCursor*) _self;

	// convert parameter type
	type = (GdkCursorType) _type;

	// set field value
	self->type = type;

	// cleanup parameter self

	// cleanup parameter type
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1ref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkCursor* result;
	jlong _result;
	GdkCursor* self;

	// convert parameter self
	self = (GdkCursor*) _self;

	// call function
	result = gdk_cursor_ref(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1unref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkCursor* self;

	// convert parameter self
	self = (GdkCursor*) _self;

	// call function
	gdk_cursor_unref(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1get_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GdkCursor* self;

	// convert parameter self
	self = (GdkCursor*) _self;

	// call function
	result = gdk_cursor_get_image(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1new
(
	JNIEnv* env,
	jclass cls,
	jint _cursorType
)
{
	GdkCursor* result;
	jlong _result;
	GdkCursorType cursorType;

	// convert parameter cursorType
	cursorType = (GdkCursorType) _cursorType;

	// call function
	result = gdk_cursor_new(cursorType);

	// cleanup parameter cursorType

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1new_1for_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _display,
	jint _cursorType
)
{
	GdkCursor* result;
	jlong _result;
	GdkDisplay* display;
	GdkCursorType cursorType;

	// convert parameter display
	display = (GdkDisplay*) _display;

	// convert parameter cursorType
	cursorType = (GdkCursorType) _cursorType;

	// call function
	result = gdk_cursor_new_for_display(display, cursorType);

	// cleanup parameter display

	// cleanup parameter cursorType

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1new_1from_1pixmap
(
	JNIEnv* env,
	jclass cls,
	jlong _source,
	jlong _mask,
	jlong _fg,
	jlong _bg,
	jint _x,
	jint _y
)
{
	GdkCursor* result;
	jlong _result;
	GdkPixmap* source;
	GdkPixmap* mask;
	GdkColor* fg;
	GdkColor* bg;
	gint x;
	gint y;

	// convert parameter source
	source = (GdkPixmap*) _source;

	// convert parameter mask
	mask = (GdkPixmap*) _mask;

	// convert parameter fg
	fg = (GdkColor*) _fg;

	// convert parameter bg
	bg = (GdkColor*) _bg;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	result = gdk_cursor_new_from_pixmap(source, mask, fg, bg, x, y);

	// cleanup parameter source

	// cleanup parameter mask

	// cleanup parameter fg

	// cleanup parameter bg

	// cleanup parameter x

	// cleanup parameter y

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1new_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _display,
	jlong _source,
	jint _x,
	jint _y
)
{
	GdkCursor* result;
	jlong _result;
	GdkDisplay* display;
	GdkPixbuf* source;
	gint x;
	gint y;

	// convert parameter display
	display = (GdkDisplay*) _display;

	// convert parameter source
	source = (GdkPixbuf*) _source;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	result = gdk_cursor_new_from_pixbuf(display, source, x, y);

	// cleanup parameter display

	// cleanup parameter source

	// cleanup parameter x

	// cleanup parameter y

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkCursor_gdk_1cursor_1get_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkDisplay* result;
	jlong _result;
	GdkCursor* self;

	// convert parameter self
	self = (GdkCursor*) _self;

	// call function
	result = gdk_cursor_get_display(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
