/*
 * GdkDevice.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkDevice.h"

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1set_1source
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _source
)
{
	GdkDevice* self;
	GdkInputSource source;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter source
	source = (GdkInputSource) _source;

	// call function
	gdk_device_set_source(self, source);

	// cleanup parameter self

	// cleanup parameter source
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1set_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _mode
)
{
	gboolean result;
	jboolean _result;
	GdkDevice* self;
	GdkInputMode mode;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter mode
	mode = (GdkInputMode) _mode;

	// call function
	result = gdk_device_set_mode(self, mode);

	// cleanup parameter self

	// cleanup parameter mode

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1set_1key
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index,
	jint _keyval,
	jint _modifiers
)
{
	GdkDevice* self;
	guint index;
	guint keyval;
	GdkModifierType modifiers;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter index
	index = (guint) _index;

	// convert parameter keyval
	keyval = (guint) _keyval;

	// convert parameter modifiers
	modifiers = (GdkModifierType) _modifiers;

	// call function
	gdk_device_set_key(self, index, keyval, modifiers);

	// cleanup parameter self

	// cleanup parameter index

	// cleanup parameter keyval

	// cleanup parameter modifiers
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1set_1axis_1use
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index,
	jint _use
)
{
	GdkDevice* self;
	guint index;
	GdkAxisUse use;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter index
	index = (guint) _index;

	// convert parameter use
	use = (GdkAxisUse) _use;

	// call function
	gdk_device_set_axis_use(self, index, use);

	// cleanup parameter self

	// cleanup parameter index

	// cleanup parameter use
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1get_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _window,
	jdoubleArray _axes,
	jintArray _mask
)
{
	GdkDevice* self;
	GdkWindow* window;
	gdouble* axes;
	GdkModifierType* mask;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter window
	window = (GdkWindow*) _window;

	// convert parameter axes
	axes = (gdouble*) (*env)->GetDoubleArrayElements(env, _axes, NULL);
	if (axes == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter mask
	mask = (GdkModifierType*) (*env)->GetIntArrayElements(env, _mask, NULL);
	if (mask == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_device_get_state(self, window, axes, mask);

	// cleanup parameter self

	// cleanup parameter window

	// cleanup parameter axes
	(*env)->ReleaseDoubleArrayElements(env, _axes, (jdouble*)axes, 0);

	// cleanup parameter mask
	(*env)->ReleaseIntArrayElements(env, _mask, (jint*)mask, 0);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkDevice_gdk_1device_1get_1axis
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdoubleArray _axes,
	jint _use,
	jdoubleArray _value
)
{
	gboolean result;
	jboolean _result;
	GdkDevice* self;
	gdouble* axes;
	GdkAxisUse use;
	gdouble* value;

	// convert parameter self
	self = (GdkDevice*) _self;

	// convert parameter axes
	axes = (gdouble*) (*env)->GetDoubleArrayElements(env, _axes, NULL);
	if (axes == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter use
	use = (GdkAxisUse) _use;

	// convert parameter value
	value = (gdouble*) (*env)->GetDoubleArrayElements(env, _value, NULL);
	if (value == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_device_get_axis(self, axes, use, value);

	// cleanup parameter self

	// cleanup parameter axes
	(*env)->ReleaseDoubleArrayElements(env, _axes, (jdouble*)axes, 0);

	// cleanup parameter use

	// cleanup parameter value
	(*env)->ReleaseDoubleArrayElements(env, _value, (jdouble*)value, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
