/*
 * GdkDisplayManager.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkDisplayManager.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDisplayManager_gdk_1display_1manager_1get_1default_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkDisplay* result;
	jlong _result;
	GdkDisplayManager* self;

	// convert parameter self
	self = (GdkDisplayManager*) _self;

	// call function
	result = gdk_display_manager_get_default_display(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDisplayManager_gdk_1display_1manager_1set_1default_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _display
)
{
	GdkDisplayManager* self;
	GdkDisplay* display;

	// convert parameter self
	self = (GdkDisplayManager*) _self;

	// convert parameter display
	display = (GdkDisplay*) _display;

	// call function
	gdk_display_manager_set_default_display(self, display);

	// cleanup parameter self

	// cleanup parameter display
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gdk_GdkDisplayManager_gdk_1display_1manager_1list_1displays
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	GdkDisplayManager* self;

	// convert parameter self
	self = (GdkDisplayManager*) _self;

	// call function
	result = gdk_display_manager_list_displays(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_slist_free(result);
	}

	// and finally
	return _result;
}
