/*
 * GdkDrawable.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkDrawable.h"

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	GdkDrawable* self;
	gint* width;
	gint* height;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter width
	if (_width == NULL) {
		width = NULL;
	} else {
		width = (gint*) (*env)->GetIntArrayElements(env, _width, NULL);
		if (width == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter height
	if (_height == NULL) {
		height = NULL;
	} else {
		height = (gint*) (*env)->GetIntArrayElements(env, _height, NULL);
		if (height == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gdk_drawable_get_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	if (width != NULL) {
		(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);
	}

	// cleanup parameter height
	if (height != NULL) {
		(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1set_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colormap
)
{
	GdkDrawable* self;
	GdkColormap* colormap;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter colormap
	colormap = (GdkColormap*) _colormap;

	// call function
	gdk_drawable_set_colormap(self, colormap);

	// cleanup parameter self

	// cleanup parameter colormap
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkColormap* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_colormap(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1visual
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkVisual* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_visual(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1depth
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_depth(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkDisplay* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_display(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1point
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jint _x,
	jint _y
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gint x;
	gint y;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gdk_draw_point(self, gc, x, y);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1line
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jint _x1,
	jint _y1,
	jint _x2,
	jint _y2
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gint x1;
	gint y1;
	gint x2;
	gint y2;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter x1
	x1 = (gint) _x1;

	// convert parameter y1
	y1 = (gint) _y1;

	// convert parameter x2
	x2 = (gint) _x2;

	// convert parameter y2
	y2 = (gint) _y2;

	// call function
	gdk_draw_line(self, gc, x1, y1, x2, y2);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter x1

	// cleanup parameter y1

	// cleanup parameter x2

	// cleanup parameter y2
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1rectangle
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jboolean _filled,
	jint _x,
	jint _y,
	jint _width,
	jint _height
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gboolean filled;
	gint x;
	gint y;
	gint width;
	gint height;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter filled
	filled = (gboolean) _filled;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gdk_draw_rectangle(self, gc, filled, x, y, width, height);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter filled

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1arc
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jboolean _filled,
	jint _x,
	jint _y,
	jint _width,
	jint _height,
	jint _angle1,
	jint _angle2
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gboolean filled;
	gint x;
	gint y;
	gint width;
	gint height;
	gint angle1;
	gint angle2;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter filled
	filled = (gboolean) _filled;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// convert parameter angle1
	angle1 = (gint) _angle1;

	// convert parameter angle2
	angle2 = (gint) _angle2;

	// call function
	gdk_draw_arc(self, gc, filled, x, y, width, height, angle1, angle2);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter filled

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter width

	// cleanup parameter height

	// cleanup parameter angle1

	// cleanup parameter angle2
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1polygon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jboolean _filled,
	jlong _points,
	jint _npoints
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gboolean filled;
	GdkPoint* points;
	gint npoints;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter filled
	filled = (gboolean) _filled;

	// convert parameter points
	points = (GdkPoint*) _points;

	// convert parameter npoints
	npoints = (gint) _npoints;

	// call function
	gdk_draw_polygon(self, gc, filled, points, npoints);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter filled

	// cleanup parameter points

	// cleanup parameter npoints
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1drawable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _src,
	jint _xsrc,
	jint _ysrc,
	jint _xdest,
	jint _ydest,
	jint _width,
	jint _height
)
{
	GdkDrawable* self;
	GdkGC* gc;
	GdkDrawable* src;
	gint xsrc;
	gint ysrc;
	gint xdest;
	gint ydest;
	gint width;
	gint height;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter src
	src = (GdkDrawable*) _src;

	// convert parameter xsrc
	xsrc = (gint) _xsrc;

	// convert parameter ysrc
	ysrc = (gint) _ysrc;

	// convert parameter xdest
	xdest = (gint) _xdest;

	// convert parameter ydest
	ydest = (gint) _ydest;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gdk_draw_drawable(self, gc, src, xsrc, ysrc, xdest, ydest, width, height);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter src

	// cleanup parameter xsrc

	// cleanup parameter ysrc

	// cleanup parameter xdest

	// cleanup parameter ydest

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1points
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _points,
	jint _npoints
)
{
	GdkDrawable* self;
	GdkGC* gc;
	GdkPoint* points;
	gint npoints;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter points
	points = (GdkPoint*) _points;

	// convert parameter npoints
	npoints = (gint) _npoints;

	// call function
	gdk_draw_points(self, gc, points, npoints);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter points

	// cleanup parameter npoints
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1segments
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _segs,
	jint _nsegs
)
{
	GdkDrawable* self;
	GdkGC* gc;
	GdkSegment* segs;
	gint nsegs;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter segs
	segs = (GdkSegment*) _segs;

	// convert parameter nsegs
	nsegs = (gint) _nsegs;

	// call function
	gdk_draw_segments(self, gc, segs, nsegs);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter segs

	// cleanup parameter nsegs
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1lines
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _points,
	jint _npoints
)
{
	GdkDrawable* self;
	GdkGC* gc;
	GdkPoint* points;
	gint npoints;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter points
	points = (GdkPoint*) _points;

	// convert parameter npoints
	npoints = (gint) _npoints;

	// call function
	gdk_draw_lines(self, gc, points, npoints);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter points

	// cleanup parameter npoints
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _pixbuf,
	jint _srcX,
	jint _srcY,
	jint _destX,
	jint _destY,
	jint _width,
	jint _height,
	jint _dither,
	jint _xDither,
	jint _yDither
)
{
	GdkDrawable* self;
	GdkGC* gc;
	GdkPixbuf* pixbuf;
	gint srcX;
	gint srcY;
	gint destX;
	gint destY;
	gint width;
	gint height;
	GdkRgbDither dither;
	gint xDither;
	gint yDither;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// convert parameter srcX
	srcX = (gint) _srcX;

	// convert parameter srcY
	srcY = (gint) _srcY;

	// convert parameter destX
	destX = (gint) _destX;

	// convert parameter destY
	destY = (gint) _destY;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// convert parameter dither
	dither = (GdkRgbDither) _dither;

	// convert parameter xDither
	xDither = (gint) _xDither;

	// convert parameter yDither
	yDither = (gint) _yDither;

	// call function
	gdk_draw_pixbuf(self, gc, pixbuf, srcX, srcY, destX, destY, width, height, dither, xDither, yDither);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter pixbuf

	// cleanup parameter srcX

	// cleanup parameter srcY

	// cleanup parameter destX

	// cleanup parameter destY

	// cleanup parameter width

	// cleanup parameter height

	// cleanup parameter dither

	// cleanup parameter xDither

	// cleanup parameter yDither
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1glyphs
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jlong _font,
	jint _x,
	jint _y,
	jlong _glyphs
)
{
	GdkDrawable* self;
	GdkGC* gc;
	PangoFont* font;
	gint x;
	gint y;
	PangoGlyphString* glyphs;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter font
	font = (PangoFont*) _font;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter glyphs
	glyphs = (PangoGlyphString*) _glyphs;

	// call function
	gdk_draw_glyphs(self, gc, font, x, y, glyphs);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter font

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter glyphs
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1layout_1line
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jint _x,
	jint _y,
	jlong _line
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gint x;
	gint y;
	PangoLayoutLine* line;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter line
	line = (PangoLayoutLine*) _line;

	// call function
	gdk_draw_layout_line(self, gc, x, y, line);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter line
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1draw_1layout
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc,
	jint _x,
	jint _y,
	jlong _layout
)
{
	GdkDrawable* self;
	GdkGC* gc;
	gint x;
	gint y;
	PangoLayout* layout;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter layout
	layout = (PangoLayout*) _layout;

	// call function
	gdk_draw_layout(self, gc, x, y, layout);

	// cleanup parameter self

	// cleanup parameter gc

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter layout
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1clip_1region
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkRegion* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_clip_region(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1drawable_1get_1visible_1region
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkRegion* result;
	jlong _result;
	GdkDrawable* self;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// call function
	result = gdk_drawable_get_visible_region(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkDrawable_gdk_1gc_1new_1with_1values
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _values,
	jint _valuesMask
)
{
	GdkGC* result;
	jlong _result;
	GdkDrawable* self;
	GdkGCValues* values;
	GdkGCValuesMask valuesMask;

	// convert parameter self
	self = (GdkDrawable*) _self;

	// convert parameter values
	values = (GdkGCValues*) _values;

	// convert parameter valuesMask
	valuesMask = (GdkGCValuesMask) _valuesMask;

	// call function
	result = gdk_gc_new_with_values(self, values, valuesMask);

	// cleanup parameter self

	// cleanup parameter values

	// cleanup parameter valuesMask

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
