/*
 * GdkEventExpose.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkEventExpose.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1get_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEventType result;
	jint _result;
	GdkEventExpose* self;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// get field value
	result = self->type;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1set_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _type
)
{
	GdkEventExpose* self;
	GdkEventType type;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// convert parameter type
	type = (GdkEventType) _type;

	// set field value
	self->type = type;

	// cleanup parameter self

	// cleanup parameter type
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1get_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GdkEventExpose* self;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// get field value
	result = self->window;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1set_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _window
)
{
	GdkEventExpose* self;
	GdkWindow* window;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// convert parameter window
	window = (GdkWindow*) _window;

	// set field value
	self->window = window;

	// cleanup parameter self

	// cleanup parameter window
}

JNIEXPORT jbyte JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1get_1send_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint8 result;
	jbyte _result;
	GdkEventExpose* self;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// get field value
	result = self->send_event;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jbyte) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1set_1send_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jbyte _sendEvent
)
{
	GdkEventExpose* self;
	gint8 sendEvent;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// convert parameter sendEvent
	sendEvent = (gint8) _sendEvent;

	// set field value
	self->send_event = sendEvent;

	// cleanup parameter self

	// cleanup parameter sendEvent
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1get_1region
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkRegion* result;
	jlong _result;
	GdkEventExpose* self;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// get field value
	result = self->region;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1set_1region
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _region
)
{
	GdkEventExpose* self;
	GdkRegion* region;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// convert parameter region
	region = (GdkRegion*) _region;

	// set field value
	self->region = region;

	// cleanup parameter self

	// cleanup parameter region
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1get_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkEventExpose* self;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// get field value
	result = self->count;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventExpose_gdk_1event_1expose_1set_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _count
)
{
	GdkEventExpose* self;
	gint count;

	// convert parameter self
	self = (GdkEventExpose*) _self;

	// convert parameter count
	count = (gint) _count;

	// set field value
	self->count = count;

	// cleanup parameter self

	// cleanup parameter count
}
