/*
 * GdkEventKey.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkEventKey.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkEventType result;
	jint _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->type;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _type
)
{
	GdkEventKey* self;
	GdkEventType type;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter type
	type = (GdkEventType) _type;

	// set field value
	self->type = type;

	// cleanup parameter self

	// cleanup parameter type
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->window;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _window
)
{
	GdkEventKey* self;
	GdkWindow* window;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter window
	window = (GdkWindow*) _window;

	// set field value
	self->window = window;

	// cleanup parameter self

	// cleanup parameter window
}

JNIEXPORT jbyte JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1send_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint8 result;
	jbyte _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->send_event;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jbyte) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1send_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jbyte _sendEvent
)
{
	GdkEventKey* self;
	gint8 sendEvent;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter sendEvent
	sendEvent = (gint8) _sendEvent;

	// set field value
	self->send_event = sendEvent;

	// cleanup parameter self

	// cleanup parameter sendEvent
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1time
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint32 result;
	jint _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->time;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1time
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _time
)
{
	GdkEventKey* self;
	guint32 time;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter time
	time = (guint32) _time;

	// set field value
	self->time = time;

	// cleanup parameter self

	// cleanup parameter time
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->state;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state
)
{
	GdkEventKey* self;
	guint state;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter state
	state = (guint) _state;

	// set field value
	self->state = state;

	// cleanup parameter self

	// cleanup parameter state
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1keyval
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->keyval;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1keyval
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _keyval
)
{
	GdkEventKey* self;
	guint keyval;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter keyval
	keyval = (guint) _keyval;

	// set field value
	self->keyval = keyval;

	// cleanup parameter self

	// cleanup parameter keyval
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->length;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _length
)
{
	GdkEventKey* self;
	gint length;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter length
	length = (gint) _length;

	// set field value
	self->length = length;

	// cleanup parameter self

	// cleanup parameter length
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->string;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string
)
{
	GdkEventKey* self;
	gchar* string;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter string
	string = (gchar*) (*env)->GetStringUTFChars(env, _string, NULL);
	if (string == NULL) {
		return; // Java Exception already thrown
	}

	// set field value
	self->string = string;

	// cleanup parameter self

	// cleanup parameter string
	(*env)->ReleaseStringUTFChars(env, _string, string);
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1hardware_1keycode
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->hardware_keycode;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1hardware_1keycode
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _hardwareKeycode
)
{
	GdkEventKey* self;
	guint16 hardwareKeycode;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter hardwareKeycode
	hardwareKeycode = (guint16) _hardwareKeycode;

	// set field value
	self->hardware_keycode = hardwareKeycode;

	// cleanup parameter self

	// cleanup parameter hardwareKeycode
}

JNIEXPORT jbyte JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint8 result;
	jbyte _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->group;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jbyte) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jbyte _group
)
{
	GdkEventKey* self;
	guint8 group;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter group
	group = (guint8) _group;

	// set field value
	self->group = group;

	// cleanup parameter self

	// cleanup parameter group
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1get_1is_1modifier
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkEventKey* self;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// get field value
	result = self->is_modifier;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkEventKey_gdk_1event_1key_1set_1is_1modifier
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _isModifier
)
{
	GdkEventKey* self;
	gboolean isModifier;

	// convert parameter self
	self = (GdkEventKey*) _self;

	// convert parameter isModifier
	isModifier = (gboolean) _isModifier;

	// set field value
	self->is_modifier = isModifier;

	// cleanup parameter self

	// cleanup parameter isModifier
}
