/*
 * GdkGC.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkGC.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _drawable
)
{
	GdkGC* result;
	jlong _result;
	GdkDrawable* drawable;

	// convert parameter drawable
	drawable = (GdkDrawable*) _drawable;

	// call function
	result = gdk_gc_new(drawable);

	// cleanup parameter drawable

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1get_1values
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _values
)
{
	GdkGC* self;
	GdkGCValues* values;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter values
	values = (GdkGCValues*) _values;

	// call function
	gdk_gc_get_values(self, values);

	// cleanup parameter self

	// cleanup parameter values
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1values
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _values,
	jint _valuesMask
)
{
	GdkGC* self;
	GdkGCValues* values;
	GdkGCValuesMask valuesMask;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter values
	values = (GdkGCValues*) _values;

	// convert parameter valuesMask
	valuesMask = (GdkGCValuesMask) _valuesMask;

	// call function
	gdk_gc_set_values(self, values, valuesMask);

	// cleanup parameter self

	// cleanup parameter values

	// cleanup parameter valuesMask
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1foreground
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GdkGC* self;
	GdkColor* color;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gdk_gc_set_foreground(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1background
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GdkGC* self;
	GdkColor* color;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gdk_gc_set_background(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1function
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _function
)
{
	GdkGC* self;
	GdkFunction function;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter function
	function = (GdkFunction) _function;

	// call function
	gdk_gc_set_function(self, function);

	// cleanup parameter self

	// cleanup parameter function
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1fill
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _fill
)
{
	GdkGC* self;
	GdkFill fill;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter fill
	fill = (GdkFill) _fill;

	// call function
	gdk_gc_set_fill(self, fill);

	// cleanup parameter self

	// cleanup parameter fill
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1tile
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _tile
)
{
	GdkGC* self;
	GdkPixmap* tile;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter tile
	tile = (GdkPixmap*) _tile;

	// call function
	gdk_gc_set_tile(self, tile);

	// cleanup parameter self

	// cleanup parameter tile
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1stipple
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _stipple
)
{
	GdkGC* self;
	GdkPixmap* stipple;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter stipple
	stipple = (GdkPixmap*) _stipple;

	// call function
	gdk_gc_set_stipple(self, stipple);

	// cleanup parameter self

	// cleanup parameter stipple
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1ts_1origin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y
)
{
	GdkGC* self;
	gint x;
	gint y;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gdk_gc_set_ts_origin(self, x, y);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1clip_1origin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y
)
{
	GdkGC* self;
	gint x;
	gint y;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gdk_gc_set_clip_origin(self, x, y);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1clip_1mask
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _mask
)
{
	GdkGC* self;
	GdkBitmap* mask;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter mask
	mask = (GdkBitmap*) _mask;

	// call function
	gdk_gc_set_clip_mask(self, mask);

	// cleanup parameter self

	// cleanup parameter mask
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1clip_1rectangle
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rectangle
)
{
	GdkGC* self;
	GdkRectangle* rectangle;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter rectangle
	rectangle = (GdkRectangle*) _rectangle;

	// call function
	gdk_gc_set_clip_rectangle(self, rectangle);

	// cleanup parameter self

	// cleanup parameter rectangle
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1clip_1region
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _region
)
{
	GdkGC* self;
	GdkRegion* region;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter region
	region = (GdkRegion*) _region;

	// call function
	gdk_gc_set_clip_region(self, region);

	// cleanup parameter self

	// cleanup parameter region
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1subwindow
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _mode
)
{
	GdkGC* self;
	GdkSubwindowMode mode;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter mode
	mode = (GdkSubwindowMode) _mode;

	// call function
	gdk_gc_set_subwindow(self, mode);

	// cleanup parameter self

	// cleanup parameter mode
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1exposures
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _exposures
)
{
	GdkGC* self;
	gboolean exposures;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter exposures
	exposures = (gboolean) _exposures;

	// call function
	gdk_gc_set_exposures(self, exposures);

	// cleanup parameter self

	// cleanup parameter exposures
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1line_1attributes
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _lineWidth,
	jint _lineStyle,
	jint _capStyle,
	jint _joinStyle
)
{
	GdkGC* self;
	gint lineWidth;
	GdkLineStyle lineStyle;
	GdkCapStyle capStyle;
	GdkJoinStyle joinStyle;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter lineWidth
	lineWidth = (gint) _lineWidth;

	// convert parameter lineStyle
	lineStyle = (GdkLineStyle) _lineStyle;

	// convert parameter capStyle
	capStyle = (GdkCapStyle) _capStyle;

	// convert parameter joinStyle
	joinStyle = (GdkJoinStyle) _joinStyle;

	// call function
	gdk_gc_set_line_attributes(self, lineWidth, lineStyle, capStyle, joinStyle);

	// cleanup parameter self

	// cleanup parameter lineWidth

	// cleanup parameter lineStyle

	// cleanup parameter capStyle

	// cleanup parameter joinStyle
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1dashes
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _dashOffset,
	jbyteArray _dashList,
	jint _n
)
{
	GdkGC* self;
	gint dashOffset;
	gint8* dashList;
	gint n;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter dashOffset
	dashOffset = (gint) _dashOffset;

	// convert parameter dashList
	dashList = (gint8*) (*env)->GetByteArrayElements(env, _dashList, NULL);
	if (dashList == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter n
	n = (gint) _n;

	// call function
	gdk_gc_set_dashes(self, dashOffset, dashList, n);

	// cleanup parameter self

	// cleanup parameter dashOffset

	// cleanup parameter dashList
	(*env)->ReleaseByteArrayElements(env, _dashList, (jbyte*)dashList, 0);

	// cleanup parameter n
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _xOffset,
	jint _yOffset
)
{
	GdkGC* self;
	gint xOffset;
	gint yOffset;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter xOffset
	xOffset = (gint) _xOffset;

	// convert parameter yOffset
	yOffset = (gint) _yOffset;

	// call function
	gdk_gc_offset(self, xOffset, yOffset);

	// cleanup parameter self

	// cleanup parameter xOffset

	// cleanup parameter yOffset
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _srcGc
)
{
	GdkGC* self;
	GdkGC* srcGc;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter srcGc
	srcGc = (GdkGC*) _srcGc;

	// call function
	gdk_gc_copy(self, srcGc);

	// cleanup parameter self

	// cleanup parameter srcGc
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colormap
)
{
	GdkGC* self;
	GdkColormap* colormap;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter colormap
	colormap = (GdkColormap*) _colormap;

	// call function
	gdk_gc_set_colormap(self, colormap);

	// cleanup parameter self

	// cleanup parameter colormap
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1get_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkColormap* result;
	jlong _result;
	GdkGC* self;

	// convert parameter self
	self = (GdkGC*) _self;

	// call function
	result = gdk_gc_get_colormap(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1rgb_1fg_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GdkGC* self;
	GdkColor* color;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gdk_gc_set_rgb_fg_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1set_1rgb_1bg_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GdkGC* self;
	GdkColor* color;

	// convert parameter self
	self = (GdkGC*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gdk_gc_set_rgb_bg_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkGC_gdk_1gc_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GdkGC* self;

	// convert parameter self
	self = (GdkGC*) _self;

	// call function
	result = gdk_gc_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
