/*
 * GdkKeymap.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkKeymap.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkKeymap_gdk_1keymap_1lookup_1key
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _key
)
{
	guint result;
	jint _result;
	GdkKeymap* self;
	const GdkKeymapKey* key;

	// convert parameter self
	self = (GdkKeymap*) _self;

	// convert parameter key
	key = (const GdkKeymapKey*) _key;

	// call function
	result = gdk_keymap_lookup_key(self, key);

	// cleanup parameter self

	// cleanup parameter key

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkKeymap_gdk_1keymap_1translate_1keyboard_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _hardwareKeycode,
	jint _state,
	jint _group,
	jintArray _keyval,
	jintArray _effectiveGroup,
	jintArray _level,
	jintArray _consumedModifiers
)
{
	gboolean result;
	jboolean _result;
	GdkKeymap* self;
	guint hardwareKeycode;
	GdkModifierType state;
	gint group;
	guint* keyval;
	gint* effectiveGroup;
	gint* level;
	GdkModifierType* consumedModifiers;

	// convert parameter self
	self = (GdkKeymap*) _self;

	// convert parameter hardwareKeycode
	hardwareKeycode = (guint) _hardwareKeycode;

	// convert parameter state
	state = (GdkModifierType) _state;

	// convert parameter group
	group = (gint) _group;

	// convert parameter keyval
	keyval = (guint*) (*env)->GetIntArrayElements(env, _keyval, NULL);
	if (keyval == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter effectiveGroup
	effectiveGroup = (gint*) (*env)->GetIntArrayElements(env, _effectiveGroup, NULL);
	if (effectiveGroup == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter level
	level = (gint*) (*env)->GetIntArrayElements(env, _level, NULL);
	if (level == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter consumedModifiers
	consumedModifiers = (GdkModifierType*) (*env)->GetIntArrayElements(env, _consumedModifiers, NULL);
	if (consumedModifiers == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_keymap_translate_keyboard_state(self, hardwareKeycode, state, group, keyval, effectiveGroup, level, consumedModifiers);

	// cleanup parameter self

	// cleanup parameter hardwareKeycode

	// cleanup parameter state

	// cleanup parameter group

	// cleanup parameter keyval
	(*env)->ReleaseIntArrayElements(env, _keyval, (jint*)keyval, 0);

	// cleanup parameter effectiveGroup
	(*env)->ReleaseIntArrayElements(env, _effectiveGroup, (jint*)effectiveGroup, 0);

	// cleanup parameter level
	(*env)->ReleaseIntArrayElements(env, _level, (jint*)level, 0);

	// cleanup parameter consumedModifiers
	(*env)->ReleaseIntArrayElements(env, _consumedModifiers, (jint*)consumedModifiers, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkKeymap_gdk_1keymap_1get_1entries_1for_1keyval
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _keyval,
	jlongArray _keys,
	jintArray _nKeys
)
{
	gboolean result;
	jboolean _result;
	GdkKeymap* self;
	guint keyval;
	GdkKeymapKey** keys;
	gint* nKeys;

	// convert parameter self
	self = (GdkKeymap*) _self;

	// convert parameter keyval
	keyval = (guint) _keyval;

	// convert parameter keys
	keys = (GdkKeymapKey**) bindings_java_convert_jarray_to_gpointer(env, _keys);
	if (keys == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter nKeys
	nKeys = (gint*) (*env)->GetIntArrayElements(env, _nKeys, NULL);
	if (nKeys == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gdk_keymap_get_entries_for_keyval(self, keyval, keys, nKeys);

	// cleanup parameter self

	// cleanup parameter keyval

	// cleanup parameter keys
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)keys, _keys);

	// cleanup parameter nKeys
	(*env)->ReleaseIntArrayElements(env, _nKeys, (jint*)nKeys, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkKeymap_gdk_1keymap_1get_1direction
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoDirection result;
	jint _result;
	GdkKeymap* self;

	// convert parameter self
	self = (GdkKeymap*) _self;

	// call function
	result = gdk_keymap_get_direction(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
