/*
 * GdkPangoRenderer.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkPangoRenderer.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPangoRenderer_gdk_1pango_1renderer_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _screen
)
{
	PangoRenderer* result;
	jlong _result;
	GdkScreen* screen;

	// convert parameter screen
	screen = (GdkScreen*) _screen;

	// call function
	result = gdk_pango_renderer_new(screen);

	// cleanup parameter screen

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkPangoRenderer_gdk_1pango_1renderer_1set_1drawable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _drawable
)
{
	GdkPangoRenderer* self;
	GdkDrawable* drawable;

	// convert parameter self
	self = (GdkPangoRenderer*) _self;

	// convert parameter drawable
	drawable = (GdkDrawable*) _drawable;

	// call function
	gdk_pango_renderer_set_drawable(self, drawable);

	// cleanup parameter self

	// cleanup parameter drawable
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkPangoRenderer_gdk_1pango_1renderer_1set_1gc
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _gc
)
{
	GdkPangoRenderer* self;
	GdkGC* gc;

	// convert parameter self
	self = (GdkPangoRenderer*) _self;

	// convert parameter gc
	gc = (GdkGC*) _gc;

	// call function
	gdk_pango_renderer_set_gc(self, gc);

	// cleanup parameter self

	// cleanup parameter gc
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkPangoRenderer_gdk_1pango_1renderer_1set_1stipple
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _part,
	jlong _stipple
)
{
	GdkPangoRenderer* self;
	PangoRenderPart part;
	GdkBitmap* stipple;

	// convert parameter self
	self = (GdkPangoRenderer*) _self;

	// convert parameter part
	part = (PangoRenderPart) _part;

	// convert parameter stipple
	stipple = (GdkBitmap*) _stipple;

	// call function
	gdk_pango_renderer_set_stipple(self, part, stipple);

	// cleanup parameter self

	// cleanup parameter part

	// cleanup parameter stipple
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkPangoRenderer_gdk_1pango_1renderer_1set_1override_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _part,
	jlong _color
)
{
	GdkPangoRenderer* self;
	PangoRenderPart part;
	const GdkColor* color;

	// convert parameter self
	self = (GdkPangoRenderer*) _self;

	// convert parameter part
	part = (PangoRenderPart) _part;

	// convert parameter color
	color = (const GdkColor*) _color;

	// call function
	gdk_pango_renderer_set_override_color(self, part, color);

	// cleanup parameter self

	// cleanup parameter part

	// cleanup parameter color
}
