/*
 * GdkPixbufAnimation.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkPixbufAnimation.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPixbufAnimation_gdk_1pixbuf_1animation_1new_1from_1file
(
	JNIEnv* env,
	jclass cls,
	jstring _filename
)
{
	GdkPixbufAnimation* result;
	jlong _result;
	const char* filename;
	GError* error = NULL;

	// convert parameter filename
	filename = (const char*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gdk_pixbuf_animation_new_from_file(filename, &error);

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  0L;
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkPixbufAnimation_gdk_1pixbuf_1animation_1get_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	GdkPixbufAnimation* self;

	// convert parameter self
	self = (GdkPixbufAnimation*) _self;

	// call function
	result = gdk_pixbuf_animation_get_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkPixbufAnimation_gdk_1pixbuf_1animation_1get_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	GdkPixbufAnimation* self;

	// convert parameter self
	self = (GdkPixbufAnimation*) _self;

	// call function
	result = gdk_pixbuf_animation_get_height(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkPixbufAnimation_gdk_1pixbuf_1animation_1is_1static_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkPixbufAnimation* self;

	// convert parameter self
	self = (GdkPixbufAnimation*) _self;

	// call function
	result = gdk_pixbuf_animation_is_static_image(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPixbufAnimation_gdk_1pixbuf_1animation_1get_1static_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GdkPixbufAnimation* self;

	// convert parameter self
	self = (GdkPixbufAnimation*) _self;

	// call function
	result = gdk_pixbuf_animation_get_static_image(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
