/*
 * GdkPixbufLoader.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkPixbufLoader.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPixbufLoader_gdk_1pixbuf_1loader_1new_1with_1type
(
	JNIEnv* env,
	jclass cls,
	jstring _imageType
)
{
	GdkPixbufLoader* result;
	jlong _result;
	const char* imageType;
	GError* error = NULL;

	// convert parameter imageType
	imageType = (const char*) (*env)->GetStringUTFChars(env, _imageType, NULL);
	if (imageType == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gdk_pixbuf_loader_new_with_type(imageType, &error);

	// cleanup parameter imageType
	(*env)->ReleaseStringUTFChars(env, _imageType, imageType);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  0L;
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPixbufLoader_gdk_1pixbuf_1loader_1get_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GdkPixbufLoader* self;

	// convert parameter self
	self = (GdkPixbufLoader*) _self;

	// call function
	result = gdk_pixbuf_loader_get_pixbuf(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkPixbufLoader_gdk_1pixbuf_1loader_1get_1animation
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbufAnimation* result;
	jlong _result;
	GdkPixbufLoader* self;

	// convert parameter self
	self = (GdkPixbufLoader*) _self;

	// call function
	result = gdk_pixbuf_loader_get_animation(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkPixbufLoader_gdk_1pixbuf_1loader_1close
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkPixbufLoader* self;
	GError* error = NULL;

	// convert parameter self
	self = (GdkPixbufLoader*) _self;

	// call function
	result = gdk_pixbuf_loader_close(self, &error);

	// cleanup parameter self

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkPixbufLoader_gdk_1pixbuf_1loader_1set_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width,
	jint _height
)
{
	GdkPixbufLoader* self;
	int width;
	int height;

	// convert parameter self
	self = (GdkPixbufLoader*) _self;

	// convert parameter width
	width = (int) _width;

	// convert parameter height
	height = (int) _height;

	// call function
	gdk_pixbuf_loader_set_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width

	// cleanup parameter height
}
