/*
 * GdkRectangle.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkRectangle.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1get_1x
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkRectangle* self;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// get field value
	result = self->x;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1set_1x
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x
)
{
	GdkRectangle* self;
	gint x;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter x
	x = (gint) _x;

	// set field value
	self->x = x;

	// cleanup parameter self

	// cleanup parameter x
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1get_1y
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkRectangle* self;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// get field value
	result = self->y;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1set_1y
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _y
)
{
	GdkRectangle* self;
	gint y;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter y
	y = (gint) _y;

	// set field value
	self->y = y;

	// cleanup parameter self

	// cleanup parameter y
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1get_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkRectangle* self;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// get field value
	result = self->width;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1set_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width
)
{
	GdkRectangle* self;
	gint width;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter width
	width = (gint) _width;

	// set field value
	self->width = width;

	// cleanup parameter self

	// cleanup parameter width
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1get_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GdkRectangle* self;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// get field value
	result = self->height;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1set_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _height
)
{
	GdkRectangle* self;
	gint height;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter height
	height = (gint) _height;

	// set field value
	self->height = height;

	// cleanup parameter self

	// cleanup parameter height
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1intersect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _src2,
	jlong _dest
)
{
	gboolean result;
	jboolean _result;
	GdkRectangle* self;
	GdkRectangle* src2;
	GdkRectangle* dest;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter src2
	src2 = (GdkRectangle*) _src2;

	// convert parameter dest
	dest = (GdkRectangle*) _dest;

	// call function
	result = gdk_rectangle_intersect(self, src2, dest);

	// cleanup parameter self

	// cleanup parameter src2

	// cleanup parameter dest

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRectangle_gdk_1rectangle_1union
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _src2,
	jlong _dest
)
{
	GdkRectangle* self;
	GdkRectangle* src2;
	GdkRectangle* dest;

	// convert parameter self
	self = (GdkRectangle*) _self;

	// convert parameter src2
	src2 = (GdkRectangle*) _src2;

	// convert parameter dest
	dest = (GdkRectangle*) _dest;

	// call function
	gdk_rectangle_union(self, src2, dest);

	// cleanup parameter self

	// cleanup parameter src2

	// cleanup parameter dest
}
