/*
 * GdkRegion.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkRegion.h"

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1get_1clipbox
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect
)
{
	GdkRegion* self;
	GdkRectangle* rect;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// call function
	gdk_region_get_clipbox(self, rect);

	// cleanup parameter self

	// cleanup parameter rect
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1empty
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GdkRegion* self;

	// convert parameter self
	self = (GdkRegion*) _self;

	// call function
	result = gdk_region_empty(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1equal
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _other
)
{
	gboolean result;
	jboolean _result;
	GdkRegion* self;
	GdkRegion* other;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter other
	other = (GdkRegion*) _other;

	// call function
	result = gdk_region_equal(self, other);

	// cleanup parameter self

	// cleanup parameter other

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1point_1in
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y
)
{
	gboolean result;
	jboolean _result;
	GdkRegion* self;
	int x;
	int y;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter x
	x = (int) _x;

	// convert parameter y
	y = (int) _y;

	// call function
	result = gdk_region_point_in(self, x, y);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1rect_1in
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect
)
{
	GdkOverlapType result;
	jint _result;
	GdkRegion* self;
	GdkRectangle* rect;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// call function
	result = gdk_region_rect_in(self, rect);

	// cleanup parameter self

	// cleanup parameter rect

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GdkRegion* result;
	jlong _result;

	// call function
	result = gdk_region_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkRegion* result;
	jlong _result;
	GdkRegion* self;

	// convert parameter self
	self = (GdkRegion*) _self;

	// call function
	result = gdk_region_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1destroy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkRegion* self;

	// convert parameter self
	self = (GdkRegion*) _self;

	// call function
	gdk_region_destroy(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1get_1rectangles
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _rectangles,
	jintArray _nRectangles
)
{
	GdkRegion* self;
	GdkRectangle** rectangles;
	gint* nRectangles;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter rectangles
	rectangles = (GdkRectangle**) bindings_java_convert_jarray_to_gpointer(env, _rectangles);
	if (rectangles == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter nRectangles
	nRectangles = (gint*) (*env)->GetIntArrayElements(env, _nRectangles, NULL);
	if (nRectangles == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gdk_region_get_rectangles(self, rectangles, nRectangles);

	// cleanup parameter self

	// cleanup parameter rectangles
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)rectangles, _rectangles);

	// cleanup parameter nRectangles
	(*env)->ReleaseIntArrayElements(env, _nRectangles, (jint*)nRectangles, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1offset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _dx,
	jint _dy
)
{
	GdkRegion* self;
	gint dx;
	gint dy;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter dx
	dx = (gint) _dx;

	// convert parameter dy
	dy = (gint) _dy;

	// call function
	gdk_region_offset(self, dx, dy);

	// cleanup parameter self

	// cleanup parameter dx

	// cleanup parameter dy
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1shrink
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _dx,
	jint _dy
)
{
	GdkRegion* self;
	gint dx;
	gint dy;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter dx
	dx = (gint) _dx;

	// convert parameter dy
	dy = (gint) _dy;

	// call function
	gdk_region_shrink(self, dx, dy);

	// cleanup parameter self

	// cleanup parameter dx

	// cleanup parameter dy
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1union_1with_1rect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect
)
{
	GdkRegion* self;
	GdkRectangle* rect;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// call function
	gdk_region_union_with_rect(self, rect);

	// cleanup parameter self

	// cleanup parameter rect
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1intersect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _source2
)
{
	GdkRegion* self;
	GdkRegion* source2;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter source2
	source2 = (GdkRegion*) _source2;

	// call function
	gdk_region_intersect(self, source2);

	// cleanup parameter self

	// cleanup parameter source2
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1union
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _source2
)
{
	GdkRegion* self;
	GdkRegion* source2;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter source2
	source2 = (GdkRegion*) _source2;

	// call function
	gdk_region_union(self, source2);

	// cleanup parameter self

	// cleanup parameter source2
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1subtract
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _source2
)
{
	GdkRegion* self;
	GdkRegion* source2;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter source2
	source2 = (GdkRegion*) _source2;

	// call function
	gdk_region_subtract(self, source2);

	// cleanup parameter self

	// cleanup parameter source2
}

JNIEXPORT void JNICALL
Java_org_gnome_gdk_GdkRegion_gdk_1region_1xor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _source2
)
{
	GdkRegion* self;
	GdkRegion* source2;

	// convert parameter self
	self = (GdkRegion*) _self;

	// convert parameter source2
	source2 = (GdkRegion*) _source2;

	// call function
	gdk_region_xor(self, source2);

	// cleanup parameter self

	// cleanup parameter source2
}
