/*
 * GdkVisual.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gdk_GdkVisual.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkVisual_gdk_1visual_1get_1best_1with_1both
(
	JNIEnv* env,
	jclass cls,
	jint _depth,
	jint _visualType
)
{
	GdkVisual* result;
	jlong _result;
	gint depth;
	GdkVisualType visualType;

	// convert parameter depth
	depth = (gint) _depth;

	// convert parameter visualType
	visualType = (GdkVisualType) _visualType;

	// call function
	result = gdk_visual_get_best_with_both(depth, visualType);

	// cleanup parameter depth

	// cleanup parameter visualType

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gdk_GdkVisual_gdk_1visual_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GdkVisual* self;

	// convert parameter self
	self = (GdkVisual*) _self;

	// call function
	result = gdk_visual_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gdk_GdkVisual_gdk_1visual_1get_1best_1depth
(
	JNIEnv* env,
	jclass cls
)
{
	gint result;
	jint _result;

	// call function
	result = gdk_visual_get_best_depth();

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
