/*
 * GladeXML.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <glade/glade-xml.h>
#include "bindings_java.h"
#include "org_gnome_glade_GladeXML.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _fname,
	jstring _root,
	jstring _domain
)
{
	GladeXML* result;
	jlong _result;
	const char* fname;
	const char* root;
	const char* domain;

	// convert parameter fname
	fname = (const char*) (*env)->GetStringUTFChars(env, _fname, NULL);
	if (fname == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter root
	if (_root == NULL) {
		root = NULL;
	} else {
		root = (const char*) (*env)->GetStringUTFChars(env, _root, NULL);
		if (root == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter domain
	if (_domain == NULL) {
		domain = NULL;
	} else {
		domain = (const char*) (*env)->GetStringUTFChars(env, _domain, NULL);
		if (domain == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = glade_xml_new(fname, root, domain);

	// cleanup parameter fname
	(*env)->ReleaseStringUTFChars(env, _fname, fname);

	// cleanup parameter root
	if (root != NULL) {
		(*env)->ReleaseStringUTFChars(env, _root, root);
	}

	// cleanup parameter domain
	if (domain != NULL) {
		(*env)->ReleaseStringUTFChars(env, _domain, domain);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1construct
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _fname,
	jstring _root,
	jstring _domain
)
{
	gboolean result;
	jboolean _result;
	GladeXML* self;
	const char* fname;
	const char* root;
	const char* domain;

	// convert parameter self
	self = (GladeXML*) _self;

	// convert parameter fname
	fname = (const char*) (*env)->GetStringUTFChars(env, _fname, NULL);
	if (fname == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter root
	if (_root == NULL) {
		root = NULL;
	} else {
		root = (const char*) (*env)->GetStringUTFChars(env, _root, NULL);
		if (root == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// convert parameter domain
	if (_domain == NULL) {
		domain = NULL;
	} else {
		domain = (const char*) (*env)->GetStringUTFChars(env, _domain, NULL);
		if (domain == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// call function
	result = glade_xml_construct(self, fname, root, domain);

	// cleanup parameter self

	// cleanup parameter fname
	(*env)->ReleaseStringUTFChars(env, _fname, fname);

	// cleanup parameter root
	if (root != NULL) {
		(*env)->ReleaseStringUTFChars(env, _root, root);
	}

	// cleanup parameter domain
	if (domain != NULL) {
		(*env)->ReleaseStringUTFChars(env, _domain, domain);
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1signal_1autoconnect
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GladeXML* self;

	// convert parameter self
	self = (GladeXML*) _self;

	// call function
	glade_xml_signal_autoconnect(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1get_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GtkWidget* result;
	jlong _result;
	GladeXML* self;
	const char* name;

	// convert parameter self
	self = (GladeXML*) _self;

	// convert parameter name
	name = (const char*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = glade_xml_get_widget(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1get_1widget_1prefix
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GList* result;
	jlongArray _result;
	GladeXML* self;
	const char* name;

	// convert parameter self
	self = (GladeXML*) _self;

	// convert parameter name
	name = (const char*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = glade_xml_get_widget_prefix(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_glade_GladeXML_glade_1xml_1relative_1file
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _filename
)
{
	gchar* result;
	jstring _result;
	GladeXML* self;
	const gchar* filename;

	// convert parameter self
	self = (GladeXML*) _self;

	// convert parameter filename
	filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = glade_xml_relative_file(self, filename);

	// cleanup parameter self

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}
