/*
 * GtkAccelKey.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAccelKey.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1get_1accel_1key
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkAccelKey* self;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// get field value
	result = self->accel_key;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1set_1accel_1key
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _accelKey
)
{
	GtkAccelKey* self;
	guint accelKey;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// convert parameter accelKey
	accelKey = (guint) _accelKey;

	// set field value
	self->accel_key = accelKey;

	// cleanup parameter self

	// cleanup parameter accelKey
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1get_1accel_1mods
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkModifierType result;
	jint _result;
	GtkAccelKey* self;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// get field value
	result = self->accel_mods;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1set_1accel_1mods
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _accelMods
)
{
	GtkAccelKey* self;
	GdkModifierType accelMods;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// convert parameter accelMods
	accelMods = (GdkModifierType) _accelMods;

	// set field value
	self->accel_mods = accelMods;

	// cleanup parameter self

	// cleanup parameter accelMods
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1get_1accel_1flags
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkAccelKey* self;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// get field value
	result = self->accel_flags;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accel_1key_1set_1accel_1flags
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _accelFlags
)
{
	GtkAccelKey* self;
	guint accelFlags;

	// convert parameter self
	self = (GtkAccelKey*) _self;

	// convert parameter accelFlags
	accelFlags = (guint) _accelFlags;

	// set field value
	self->accel_flags = accelFlags;

	// cleanup parameter self

	// cleanup parameter accelFlags
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1valid
(
	JNIEnv* env,
	jclass cls,
	jint _keyval,
	jint _modifiers
)
{
	gboolean result;
	jboolean _result;
	guint keyval;
	GdkModifierType modifiers;

	// convert parameter keyval
	keyval = (guint) _keyval;

	// convert parameter modifiers
	modifiers = (GdkModifierType) _modifiers;

	// call function
	result = gtk_accelerator_valid(keyval, modifiers);

	// cleanup parameter keyval

	// cleanup parameter modifiers

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1parse
(
	JNIEnv* env,
	jclass cls,
	jstring _accelerator,
	jintArray _acceleratorKey,
	jintArray _acceleratorMods
)
{
	const gchar* accelerator;
	guint* acceleratorKey;
	GdkModifierType* acceleratorMods;

	// convert parameter accelerator
	accelerator = (const gchar*) (*env)->GetStringUTFChars(env, _accelerator, NULL);
	if (accelerator == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter acceleratorKey
	acceleratorKey = (guint*) (*env)->GetIntArrayElements(env, _acceleratorKey, NULL);
	if (acceleratorKey == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter acceleratorMods
	acceleratorMods = (GdkModifierType*) (*env)->GetIntArrayElements(env, _acceleratorMods, NULL);
	if (acceleratorMods == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accelerator_parse(accelerator, acceleratorKey, acceleratorMods);

	// cleanup parameter accelerator
	(*env)->ReleaseStringUTFChars(env, _accelerator, accelerator);

	// cleanup parameter acceleratorKey
	(*env)->ReleaseIntArrayElements(env, _acceleratorKey, (jint*)acceleratorKey, 0);

	// cleanup parameter acceleratorMods
	(*env)->ReleaseIntArrayElements(env, _acceleratorMods, (jint*)acceleratorMods, 0);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1name
(
	JNIEnv* env,
	jclass cls,
	jint _acceleratorKey,
	jint _acceleratorMods
)
{
	gchar* result;
	jstring _result;
	guint acceleratorKey;
	GdkModifierType acceleratorMods;

	// convert parameter acceleratorKey
	acceleratorKey = (guint) _acceleratorKey;

	// convert parameter acceleratorMods
	acceleratorMods = (GdkModifierType) _acceleratorMods;

	// call function
	result = gtk_accelerator_name(acceleratorKey, acceleratorMods);

	// cleanup parameter acceleratorKey

	// cleanup parameter acceleratorMods

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1set_1default_1mod_1mask
(
	JNIEnv* env,
	jclass cls,
	jint _defaultModMask
)
{
	GdkModifierType defaultModMask;

	// convert parameter defaultModMask
	defaultModMask = (GdkModifierType) _defaultModMask;

	// call function
	gtk_accelerator_set_default_mod_mask(defaultModMask);

	// cleanup parameter defaultModMask
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1get_1default_1mod_1mask
(
	JNIEnv* env,
	jclass cls
)
{
	GdkModifierType result;
	jint _result;

	// call function
	result = gtk_accelerator_get_default_mod_mask();

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkAccelKey_gtk_1accelerator_1get_1label
(
	JNIEnv* env,
	jclass cls,
	jint _acceleratorKey,
	jint _acceleratorMods
)
{
	gchar* result;
	jstring _result;
	guint acceleratorKey;
	GdkModifierType acceleratorMods;

	// convert parameter acceleratorKey
	acceleratorKey = (guint) _acceleratorKey;

	// convert parameter acceleratorMods
	acceleratorMods = (GdkModifierType) _acceleratorMods;

	// call function
	result = gtk_accelerator_get_label(acceleratorKey, acceleratorMods);

	// cleanup parameter acceleratorKey

	// cleanup parameter acceleratorMods

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}
