/*
 * GtkAccelLabel.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAccelLabel.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAccelLabel_gtk_1accel_1label_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_accel_label_new(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAccelLabel_gtk_1accel_1label_1get_1accel_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkAccelLabel* self;

	// convert parameter self
	self = (GtkAccelLabel*) _self;

	// call function
	result = gtk_accel_label_get_accel_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAccelLabel_gtk_1accel_1label_1get_1accel_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkAccelLabel* self;

	// convert parameter self
	self = (GtkAccelLabel*) _self;

	// call function
	result = gtk_accel_label_get_accel_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelLabel_gtk_1accel_1label_1set_1accel_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _accelWidget
)
{
	GtkAccelLabel* self;
	GtkWidget* accelWidget;

	// convert parameter self
	self = (GtkAccelLabel*) _self;

	// convert parameter accelWidget
	accelWidget = (GtkWidget*) _accelWidget;

	// call function
	gtk_accel_label_set_accel_widget(self, accelWidget);

	// cleanup parameter self

	// cleanup parameter accelWidget
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAccelLabel_gtk_1accel_1label_1refetch
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkAccelLabel* self;

	// convert parameter self
	self = (GtkAccelLabel*) _self;

	// call function
	result = gtk_accel_label_refetch(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
