/*
 * GtkAccelMap.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAccelMap.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1add_1entry
(
	JNIEnv* env,
	jclass cls,
	jstring _accelPath,
	jint _accelKey,
	jint _accelMods
)
{
	const gchar* accelPath;
	guint accelKey;
	GdkModifierType accelMods;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter accelKey
	accelKey = (guint) _accelKey;

	// convert parameter accelMods
	accelMods = (GdkModifierType) _accelMods;

	// call function
	gtk_accel_map_add_entry(accelPath, accelKey, accelMods);

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);

	// cleanup parameter accelKey

	// cleanup parameter accelMods
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1lookup_1entry
(
	JNIEnv* env,
	jclass cls,
	jstring _accelPath,
	jlong _key
)
{
	gboolean result;
	jboolean _result;
	const gchar* accelPath;
	GtkAccelKey* key;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter key
	key = (GtkAccelKey*) _key;

	// call function
	result = gtk_accel_map_lookup_entry(accelPath, key);

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);

	// cleanup parameter key

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1change_1entry
(
	JNIEnv* env,
	jclass cls,
	jstring _accelPath,
	jint _accelKey,
	jint _accelMods,
	jboolean _replace
)
{
	gboolean result;
	jboolean _result;
	const gchar* accelPath;
	guint accelKey;
	GdkModifierType accelMods;
	gboolean replace;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter accelKey
	accelKey = (guint) _accelKey;

	// convert parameter accelMods
	accelMods = (GdkModifierType) _accelMods;

	// convert parameter replace
	replace = (gboolean) _replace;

	// call function
	result = gtk_accel_map_change_entry(accelPath, accelKey, accelMods, replace);

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);

	// cleanup parameter accelKey

	// cleanup parameter accelMods

	// cleanup parameter replace

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1load
(
	JNIEnv* env,
	jclass cls,
	jstring _fileName
)
{
	const gchar* fileName;

	// convert parameter fileName
	fileName = (const gchar*) (*env)->GetStringUTFChars(env, _fileName, NULL);
	if (fileName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accel_map_load(fileName);

	// cleanup parameter fileName
	(*env)->ReleaseStringUTFChars(env, _fileName, fileName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1save
(
	JNIEnv* env,
	jclass cls,
	jstring _fileName
)
{
	const gchar* fileName;

	// convert parameter fileName
	fileName = (const gchar*) (*env)->GetStringUTFChars(env, _fileName, NULL);
	if (fileName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accel_map_save(fileName);

	// cleanup parameter fileName
	(*env)->ReleaseStringUTFChars(env, _fileName, fileName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1load_1fd
(
	JNIEnv* env,
	jclass cls,
	jint _fd
)
{
	gint fd;

	// convert parameter fd
	fd = (gint) _fd;

	// call function
	gtk_accel_map_load_fd(fd);

	// cleanup parameter fd
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1save_1fd
(
	JNIEnv* env,
	jclass cls,
	jint _fd
)
{
	gint fd;

	// convert parameter fd
	fd = (gint) _fd;

	// call function
	gtk_accel_map_save_fd(fd);

	// cleanup parameter fd
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1lock_1path
(
	JNIEnv* env,
	jclass cls,
	jstring _accelPath
)
{
	const gchar* accelPath;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accel_map_lock_path(accelPath);

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1unlock_1path
(
	JNIEnv* env,
	jclass cls,
	jstring _accelPath
)
{
	const gchar* accelPath;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accel_map_unlock_path(accelPath);

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1add_1filter
(
	JNIEnv* env,
	jclass cls,
	jstring _filterPattern
)
{
	const gchar* filterPattern;

	// convert parameter filterPattern
	filterPattern = (const gchar*) (*env)->GetStringUTFChars(env, _filterPattern, NULL);
	if (filterPattern == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_accel_map_add_filter(filterPattern);

	// cleanup parameter filterPattern
	(*env)->ReleaseStringUTFChars(env, _filterPattern, filterPattern);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAccelMap_gtk_1accel_1map_1get
(
	JNIEnv* env,
	jclass cls
)
{
	GtkAccelMap* result;
	jlong _result;

	// call function
	result = gtk_accel_map_get();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
