/*
 * GtkAction.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAction.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _label,
	jstring _tooltip,
	jstring _stockId
)
{
	GtkAction* result;
	jlong _result;
	const gchar* name;
	const gchar* label;
	const gchar* tooltip;
	const gchar* stockId;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter tooltip
	if (_tooltip == NULL) {
		tooltip = NULL;
	} else {
		tooltip = (const gchar*) (*env)->GetStringUTFChars(env, _tooltip, NULL);
		if (tooltip == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter stockId
	if (_stockId == NULL) {
		stockId = NULL;
	} else {
		stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
		if (stockId == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_action_new(name, label, tooltip, stockId);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// cleanup parameter tooltip
	if (tooltip != NULL) {
		(*env)->ReleaseStringUTFChars(env, _tooltip, tooltip);
	}

	// cleanup parameter stockId
	if (stockId != NULL) {
		(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1is_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_is_sensitive(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1get_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_get_sensitive(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1is_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_is_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1get_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_get_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1activate
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	gtk_action_activate(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1create_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _iconSize
)
{
	GtkWidget* result;
	jlong _result;
	GtkAction* self;
	GtkIconSize iconSize;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter iconSize
	iconSize = (GtkIconSize) _iconSize;

	// call function
	result = gtk_action_create_icon(self, iconSize);

	// cleanup parameter self

	// cleanup parameter iconSize

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1create_1menu_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_create_menu_item(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1create_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_create_menu(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1create_1tool_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_create_tool_item(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1connect_1proxy
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _proxy
)
{
	GtkAction* self;
	GtkWidget* proxy;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter proxy
	proxy = (GtkWidget*) _proxy;

	// call function
	gtk_action_connect_proxy(self, proxy);

	// cleanup parameter self

	// cleanup parameter proxy
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1disconnect_1proxy
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _proxy
)
{
	GtkAction* self;
	GtkWidget* proxy;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter proxy
	proxy = (GtkWidget*) _proxy;

	// call function
	gtk_action_disconnect_proxy(self, proxy);

	// cleanup parameter self

	// cleanup parameter proxy
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1get_1proxies
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_get_proxies(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1connect_1accelerator
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	gtk_action_connect_accelerator(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1disconnect_1accelerator
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	gtk_action_disconnect_accelerator(self);

	// cleanup parameter self
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1get_1accel_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkAction* self;

	// convert parameter self
	self = (GtkAction*) _self;

	// call function
	result = gtk_action_get_accel_path(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1block_1activate_1from
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _proxy
)
{
	GtkAction* self;
	GtkWidget* proxy;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter proxy
	proxy = (GtkWidget*) _proxy;

	// call function
	gtk_action_block_activate_from(self, proxy);

	// cleanup parameter self

	// cleanup parameter proxy
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1unblock_1activate_1from
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _proxy
)
{
	GtkAction* self;
	GtkWidget* proxy;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter proxy
	proxy = (GtkWidget*) _proxy;

	// call function
	gtk_action_unblock_activate_from(self, proxy);

	// cleanup parameter self

	// cleanup parameter proxy
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1set_1accel_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _accelPath
)
{
	GtkAction* self;
	const gchar* accelPath;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter accelPath
	accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
	if (accelPath == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_action_set_accel_path(self, accelPath);

	// cleanup parameter self

	// cleanup parameter accelPath
	(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1set_1accel_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _accelGroup
)
{
	GtkAction* self;
	GtkAccelGroup* accelGroup;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter accelGroup
	accelGroup = (GtkAccelGroup*) _accelGroup;

	// call function
	gtk_action_set_accel_group(self, accelGroup);

	// cleanup parameter self

	// cleanup parameter accelGroup
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1set_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _sensitive
)
{
	GtkAction* self;
	gboolean sensitive;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter sensitive
	sensitive = (gboolean) _sensitive;

	// call function
	gtk_action_set_sensitive(self, sensitive);

	// cleanup parameter self

	// cleanup parameter sensitive
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAction_gtk_1action_1set_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _visible
)
{
	GtkAction* self;
	gboolean visible;

	// convert parameter self
	self = (GtkAction*) _self;

	// convert parameter visible
	visible = (gboolean) _visible;

	// call function
	gtk_action_set_visible(self, visible);

	// cleanup parameter self

	// cleanup parameter visible
}
