/*
 * GtkActionGroup.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkActionGroup.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name
)
{
	GtkActionGroup* result;
	jlong _result;
	const gchar* name;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_action_group_new(name);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkActionGroup* self;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// call function
	result = gtk_action_group_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1get_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkActionGroup* self;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// call function
	result = gtk_action_group_get_sensitive(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1set_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _sensitive
)
{
	GtkActionGroup* self;
	gboolean sensitive;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter sensitive
	sensitive = (gboolean) _sensitive;

	// call function
	gtk_action_group_set_sensitive(self, sensitive);

	// cleanup parameter self

	// cleanup parameter sensitive
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1get_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkActionGroup* self;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// call function
	result = gtk_action_group_get_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1set_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _visible
)
{
	GtkActionGroup* self;
	gboolean visible;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter visible
	visible = (gboolean) _visible;

	// call function
	gtk_action_group_set_visible(self, visible);

	// cleanup parameter self

	// cleanup parameter visible
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1get_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _actionName
)
{
	GtkAction* result;
	jlong _result;
	GtkActionGroup* self;
	const gchar* actionName;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter actionName
	actionName = (const gchar*) (*env)->GetStringUTFChars(env, _actionName, NULL);
	if (actionName == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_action_group_get_action(self, actionName);

	// cleanup parameter self

	// cleanup parameter actionName
	(*env)->ReleaseStringUTFChars(env, _actionName, actionName);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1list_1actions
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GtkActionGroup* self;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// call function
	result = gtk_action_group_list_actions(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_list_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1add_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _action
)
{
	GtkActionGroup* self;
	GtkAction* action;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter action
	action = (GtkAction*) _action;

	// call function
	gtk_action_group_add_action(self, action);

	// cleanup parameter self

	// cleanup parameter action
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1add_1action_1with_1accel
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _action,
	jstring _accelerator
)
{
	GtkActionGroup* self;
	GtkAction* action;
	const gchar* accelerator;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter action
	action = (GtkAction*) _action;

	// convert parameter accelerator
	if (_accelerator == NULL) {
		accelerator = NULL;
	} else {
		accelerator = (const gchar*) (*env)->GetStringUTFChars(env, _accelerator, NULL);
		if (accelerator == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_action_group_add_action_with_accel(self, action, accelerator);

	// cleanup parameter self

	// cleanup parameter action

	// cleanup parameter accelerator
	if (accelerator != NULL) {
		(*env)->ReleaseStringUTFChars(env, _accelerator, accelerator);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1remove_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _action
)
{
	GtkActionGroup* self;
	GtkAction* action;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter action
	action = (GtkAction*) _action;

	// call function
	gtk_action_group_remove_action(self, action);

	// cleanup parameter self

	// cleanup parameter action
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1set_1translation_1domain
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _domain
)
{
	GtkActionGroup* self;
	const gchar* domain;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter domain
	domain = (const gchar*) (*env)->GetStringUTFChars(env, _domain, NULL);
	if (domain == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_action_group_set_translation_domain(self, domain);

	// cleanup parameter self

	// cleanup parameter domain
	(*env)->ReleaseStringUTFChars(env, _domain, domain);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkActionGroup_gtk_1action_1group_1translate_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _string
)
{
	const gchar* result;
	jstring _result;
	GtkActionGroup* self;
	const gchar* string;

	// convert parameter self
	self = (GtkActionGroup*) _self;

	// convert parameter string
	string = (const gchar*) (*env)->GetStringUTFChars(env, _string, NULL);
	if (string == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = gtk_action_group_translate_string(self, string);

	// cleanup parameter self

	// cleanup parameter string
	(*env)->ReleaseStringUTFChars(env, _string, string);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}
