/*
 * GtkAdjustment.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAdjustment.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1new
(
	JNIEnv* env,
	jclass cls,
	jdouble _value,
	jdouble _lower,
	jdouble _upper,
	jdouble _stepIncrement,
	jdouble _pageIncrement,
	jdouble _pageSize
)
{
	GtkObject* result;
	jlong _result;
	gdouble value;
	gdouble lower;
	gdouble upper;
	gdouble stepIncrement;
	gdouble pageIncrement;
	gdouble pageSize;

	// convert parameter value
	value = (gdouble) _value;

	// convert parameter lower
	lower = (gdouble) _lower;

	// convert parameter upper
	upper = (gdouble) _upper;

	// convert parameter stepIncrement
	stepIncrement = (gdouble) _stepIncrement;

	// convert parameter pageIncrement
	pageIncrement = (gdouble) _pageIncrement;

	// convert parameter pageSize
	pageSize = (gdouble) _pageSize;

	// call function
	result = gtk_adjustment_new(value, lower, upper, stepIncrement, pageIncrement, pageSize);

	// cleanup parameter value

	// cleanup parameter lower

	// cleanup parameter upper

	// cleanup parameter stepIncrement

	// cleanup parameter pageIncrement

	// cleanup parameter pageSize

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1changed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	gtk_adjustment_changed(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1value_1changed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	gtk_adjustment_value_changed(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1clamp_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _lower,
	jdouble _upper
)
{
	GtkAdjustment* self;
	gdouble lower;
	gdouble upper;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter lower
	lower = (gdouble) _lower;

	// convert parameter upper
	upper = (gdouble) _upper;

	// call function
	gtk_adjustment_clamp_page(self, lower, upper);

	// cleanup parameter self

	// cleanup parameter lower

	// cleanup parameter upper
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_value(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_value(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1page_1increment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_page_increment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1page_1increment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_page_increment(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1step_1increment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_step_increment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1step_1increment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_step_increment(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1upper
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_upper(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1upper
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_upper(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1lower
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_lower(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1lower
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_lower(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1get_1page_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkAdjustment* self;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// call function
	result = gtk_adjustment_get_page_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAdjustment_gtk_1adjustment_1set_1page_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkAdjustment* self;
	gdouble value;

	// convert parameter self
	self = (GtkAdjustment*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_adjustment_set_page_size(self, value);

	// cleanup parameter self

	// cleanup parameter value
}
