/*
 * GtkAspectFrame.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAspectFrame.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAspectFrame_gtk_1aspect_1frame_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _label,
	jfloat _xalign,
	jfloat _yalign,
	jfloat _ratio,
	jboolean _obeyChild
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;
	gfloat xalign;
	gfloat yalign;
	gfloat ratio;
	gboolean obeyChild;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter xalign
	xalign = (gfloat) _xalign;

	// convert parameter yalign
	yalign = (gfloat) _yalign;

	// convert parameter ratio
	ratio = (gfloat) _ratio;

	// convert parameter obeyChild
	obeyChild = (gboolean) _obeyChild;

	// call function
	result = gtk_aspect_frame_new(label, xalign, yalign, ratio, obeyChild);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// cleanup parameter xalign

	// cleanup parameter yalign

	// cleanup parameter ratio

	// cleanup parameter obeyChild

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAspectFrame_gtk_1aspect_1frame_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _xalign,
	jfloat _yalign,
	jfloat _ratio,
	jboolean _obeyChild
)
{
	GtkAspectFrame* self;
	gfloat xalign;
	gfloat yalign;
	gfloat ratio;
	gboolean obeyChild;

	// convert parameter self
	self = (GtkAspectFrame*) _self;

	// convert parameter xalign
	xalign = (gfloat) _xalign;

	// convert parameter yalign
	yalign = (gfloat) _yalign;

	// convert parameter ratio
	ratio = (gfloat) _ratio;

	// convert parameter obeyChild
	obeyChild = (gboolean) _obeyChild;

	// call function
	gtk_aspect_frame_set(self, xalign, yalign, ratio, obeyChild);

	// cleanup parameter self

	// cleanup parameter xalign

	// cleanup parameter yalign

	// cleanup parameter ratio

	// cleanup parameter obeyChild
}
