/*
 * GtkAssistant.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkAssistant.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_assistant_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1current_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkAssistant* self;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// call function
	result = gtk_assistant_get_current_page(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1current_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageNum
)
{
	GtkAssistant* self;
	gint pageNum;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter pageNum
	pageNum = (gint) _pageNum;

	// call function
	gtk_assistant_set_current_page(self, pageNum);

	// cleanup parameter self

	// cleanup parameter pageNum
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1n_1pages
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkAssistant* self;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// call function
	result = gtk_assistant_get_n_pages(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1nth_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageNum
)
{
	GtkWidget* result;
	jlong _result;
	GtkAssistant* self;
	gint pageNum;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter pageNum
	pageNum = (gint) _pageNum;

	// call function
	result = gtk_assistant_get_nth_page(self, pageNum);

	// cleanup parameter self

	// cleanup parameter pageNum

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1prepend_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	gint result;
	jint _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_prepend_page(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1append_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	gint result;
	jint _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_append_page(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1insert_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jint _position
)
{
	gint result;
	jint _result;
	GtkAssistant* self;
	GtkWidget* page;
	gint position;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter position
	position = (gint) _position;

	// call function
	result = gtk_assistant_insert_page(self, page, position);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter position

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1page_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jint _type
)
{
	GtkAssistant* self;
	GtkWidget* page;
	GtkAssistantPageType type;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter type
	type = (GtkAssistantPageType) _type;

	// call function
	gtk_assistant_set_page_type(self, page, type);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter type
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1page_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	GtkAssistantPageType result;
	jint _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_get_page_type(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1page_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jstring _title
)
{
	GtkAssistant* self;
	GtkWidget* page;
	const gchar* title;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_assistant_set_page_title(self, page, title);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1page_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	const gchar* result;
	jstring _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_get_page_title(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1page_1header_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jlong _pixbuf
)
{
	GtkAssistant* self;
	GtkWidget* page;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_assistant_set_page_header_image(self, page, pixbuf);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter pixbuf
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1page_1header_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_get_page_header_image(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1page_1side_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jlong _pixbuf
)
{
	GtkAssistant* self;
	GtkWidget* page;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_assistant_set_page_side_image(self, page, pixbuf);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter pixbuf
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1page_1side_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_get_page_side_image(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1set_1page_1complete
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page,
	jboolean _complete
)
{
	GtkAssistant* self;
	GtkWidget* page;
	gboolean complete;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// convert parameter complete
	complete = (gboolean) _complete;

	// call function
	gtk_assistant_set_page_complete(self, page, complete);

	// cleanup parameter self

	// cleanup parameter page

	// cleanup parameter complete
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1get_1page_1complete
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _page
)
{
	gboolean result;
	jboolean _result;
	GtkAssistant* self;
	GtkWidget* page;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter page
	page = (GtkWidget*) _page;

	// call function
	result = gtk_assistant_get_page_complete(self, page);

	// cleanup parameter self

	// cleanup parameter page

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1add_1action_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkAssistant* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	gtk_assistant_add_action_widget(self, child);

	// cleanup parameter self

	// cleanup parameter child
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1remove_1action_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkAssistant* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	gtk_assistant_remove_action_widget(self, child);

	// cleanup parameter self

	// cleanup parameter child
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkAssistant_gtk_1assistant_1update_1buttons_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAssistant* self;

	// convert parameter self
	self = (GtkAssistant*) _self;

	// call function
	gtk_assistant_update_buttons_state(self);

	// cleanup parameter self
}
