/*
 * GtkBox.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkBox.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1pack_1start
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _expand,
	jboolean _fill,
	jint _padding
)
{
	GtkBox* self;
	GtkWidget* child;
	gboolean expand;
	gboolean fill;
	guint padding;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean) _expand;

	// convert parameter fill
	fill = (gboolean) _fill;

	// convert parameter padding
	padding = (guint) _padding;

	// call function
	gtk_box_pack_start(self, child, expand, fill, padding);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand

	// cleanup parameter fill

	// cleanup parameter padding
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1pack_1end
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _expand,
	jboolean _fill,
	jint _padding
)
{
	GtkBox* self;
	GtkWidget* child;
	gboolean expand;
	gboolean fill;
	guint padding;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean) _expand;

	// convert parameter fill
	fill = (gboolean) _fill;

	// convert parameter padding
	padding = (guint) _padding;

	// call function
	gtk_box_pack_end(self, child, expand, fill, padding);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand

	// cleanup parameter fill

	// cleanup parameter padding
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1set_1homogeneous
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _homogeneous
)
{
	GtkBox* self;
	gboolean homogeneous;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter homogeneous
	homogeneous = (gboolean) _homogeneous;

	// call function
	gtk_box_set_homogeneous(self, homogeneous);

	// cleanup parameter self

	// cleanup parameter homogeneous
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1get_1homogeneous
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkBox* self;

	// convert parameter self
	self = (GtkBox*) _self;

	// call function
	result = gtk_box_get_homogeneous(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1set_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _spacing
)
{
	GtkBox* self;
	gint spacing;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter spacing
	spacing = (gint) _spacing;

	// call function
	gtk_box_set_spacing(self, spacing);

	// cleanup parameter self

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1get_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkBox* self;

	// convert parameter self
	self = (GtkBox*) _self;

	// call function
	result = gtk_box_get_spacing(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1reorder_1child
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _position
)
{
	GtkBox* self;
	GtkWidget* child;
	gint position;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_box_reorder_child(self, child, position);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1query_1child_1packing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jbooleanArray _expand,
	jbooleanArray _fill,
	jintArray _padding,
	jintArray _packType
)
{
	GtkBox* self;
	GtkWidget* child;
	gboolean* expand;
	gboolean* fill;
	guint* padding;
	GtkPackType* packType;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean*) (*env)->GetBooleanArrayElements(env, _expand, NULL);
	if (expand == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter fill
	fill = (gboolean*) (*env)->GetBooleanArrayElements(env, _fill, NULL);
	if (fill == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter padding
	padding = (guint*) (*env)->GetIntArrayElements(env, _padding, NULL);
	if (padding == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter packType
	packType = (GtkPackType*) (*env)->GetIntArrayElements(env, _packType, NULL);
	if (packType == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_box_query_child_packing(self, child, expand, fill, padding, packType);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand
	(*env)->ReleaseBooleanArrayElements(env, _expand, (jboolean*)expand, 0);

	// cleanup parameter fill
	(*env)->ReleaseBooleanArrayElements(env, _fill, (jboolean*)fill, 0);

	// cleanup parameter padding
	(*env)->ReleaseIntArrayElements(env, _padding, (jint*)padding, 0);

	// cleanup parameter packType
	(*env)->ReleaseIntArrayElements(env, _packType, (jint*)packType, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkBox_gtk_1box_1set_1child_1packing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _expand,
	jboolean _fill,
	jint _padding,
	jint _packType
)
{
	GtkBox* self;
	GtkWidget* child;
	gboolean expand;
	gboolean fill;
	guint padding;
	GtkPackType packType;

	// convert parameter self
	self = (GtkBox*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean) _expand;

	// convert parameter fill
	fill = (gboolean) _fill;

	// convert parameter padding
	padding = (guint) _padding;

	// convert parameter packType
	packType = (GtkPackType) _packType;

	// call function
	gtk_box_set_child_packing(self, child, expand, fill, padding, packType);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand

	// cleanup parameter fill

	// cleanup parameter padding

	// cleanup parameter packType
}
