/*
 * GtkButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_button_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1new_1with_1label
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_button_new_with_label(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1new_1with_1mnemonic
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_button_new_with_mnemonic(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jstring _stockId
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* stockId;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_button_new_from_stock(stockId);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1pressed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	gtk_button_pressed(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1released
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	gtk_button_released(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1clicked
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	gtk_button_clicked(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1enter
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	gtk_button_enter(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1leave
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	gtk_button_leave(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1relief
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _newstyle
)
{
	GtkButton* self;
	GtkReliefStyle newstyle;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter newstyle
	newstyle = (GtkReliefStyle) _newstyle;

	// call function
	gtk_button_set_relief(self, newstyle);

	// cleanup parameter self

	// cleanup parameter newstyle
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1relief
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkReliefStyle result;
	jint _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_relief(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _label
)
{
	GtkButton* self;
	const gchar* label;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_button_set_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_label(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useUnderline
)
{
	GtkButton* self;
	gboolean useUnderline;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter useUnderline
	useUnderline = (gboolean) _useUnderline;

	// call function
	gtk_button_set_use_underline(self, useUnderline);

	// cleanup parameter self

	// cleanup parameter useUnderline
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_use_underline(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1use_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useStock
)
{
	GtkButton* self;
	gboolean useStock;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter useStock
	useStock = (gboolean) _useStock;

	// call function
	gtk_button_set_use_stock(self, useStock);

	// cleanup parameter self

	// cleanup parameter useStock
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1use_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_use_stock(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _focusOnClick
)
{
	GtkButton* self;
	gboolean focusOnClick;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter focusOnClick
	focusOnClick = (gboolean) _focusOnClick;

	// call function
	gtk_button_set_focus_on_click(self, focusOnClick);

	// cleanup parameter self

	// cleanup parameter focusOnClick
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_focus_on_click(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _xalign,
	jfloat _yalign
)
{
	GtkButton* self;
	gfloat xalign;
	gfloat yalign;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter xalign
	xalign = (gfloat) _xalign;

	// convert parameter yalign
	yalign = (gfloat) _yalign;

	// call function
	gtk_button_set_alignment(self, xalign, yalign);

	// cleanup parameter self

	// cleanup parameter xalign

	// cleanup parameter yalign
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloatArray _xalign,
	jfloatArray _yalign
)
{
	GtkButton* self;
	gfloat* xalign;
	gfloat* yalign;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter xalign
	xalign = (gfloat*) (*env)->GetFloatArrayElements(env, _xalign, NULL);
	if (xalign == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter yalign
	yalign = (gfloat*) (*env)->GetFloatArrayElements(env, _yalign, NULL);
	if (yalign == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_button_get_alignment(self, xalign, yalign);

	// cleanup parameter self

	// cleanup parameter xalign
	(*env)->ReleaseFloatArrayElements(env, _xalign, (jfloat*)xalign, 0);

	// cleanup parameter yalign
	(*env)->ReleaseFloatArrayElements(env, _yalign, (jfloat*)yalign, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _image
)
{
	GtkButton* self;
	GtkWidget* image;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter image
	image = (GtkWidget*) _image;

	// call function
	gtk_button_set_image(self, image);

	// cleanup parameter self

	// cleanup parameter image
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_image(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1set_1image_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position
)
{
	GtkButton* self;
	GtkPositionType position;

	// convert parameter self
	self = (GtkButton*) _self;

	// convert parameter position
	position = (GtkPositionType) _position;

	// call function
	gtk_button_set_image_position(self, position);

	// cleanup parameter self

	// cleanup parameter position
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkButton_gtk_1button_1get_1image_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPositionType result;
	jint _result;
	GtkButton* self;

	// convert parameter self
	self = (GtkButton*) _self;

	// call function
	result = gtk_button_get_image_position(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
