/*
 * GtkCalendar.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkCalendar.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_calendar_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1select_1month
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _month,
	jint _year
)
{
	gboolean result;
	jboolean _result;
	GtkCalendar* self;
	guint month;
	guint year;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter month
	month = (guint) _month;

	// convert parameter year
	year = (guint) _year;

	// call function
	result = gtk_calendar_select_month(self, month, year);

	// cleanup parameter self

	// cleanup parameter month

	// cleanup parameter year

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1select_1day
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _day
)
{
	GtkCalendar* self;
	guint day;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter day
	day = (guint) _day;

	// call function
	gtk_calendar_select_day(self, day);

	// cleanup parameter self

	// cleanup parameter day
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1mark_1day
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _day
)
{
	gboolean result;
	jboolean _result;
	GtkCalendar* self;
	guint day;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter day
	day = (guint) _day;

	// call function
	result = gtk_calendar_mark_day(self, day);

	// cleanup parameter self

	// cleanup parameter day

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1unmark_1day
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _day
)
{
	gboolean result;
	jboolean _result;
	GtkCalendar* self;
	guint day;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter day
	day = (guint) _day;

	// call function
	result = gtk_calendar_unmark_day(self, day);

	// cleanup parameter self

	// cleanup parameter day

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1clear_1marks
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkCalendar* self;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// call function
	gtk_calendar_clear_marks(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1set_1display_1options
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _flags
)
{
	GtkCalendar* self;
	GtkCalendarDisplayOptions flags;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter flags
	flags = (GtkCalendarDisplayOptions) _flags;

	// call function
	gtk_calendar_set_display_options(self, flags);

	// cleanup parameter self

	// cleanup parameter flags
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1get_1display_1options
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkCalendarDisplayOptions result;
	jint _result;
	GtkCalendar* self;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// call function
	result = gtk_calendar_get_display_options(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCalendar_gtk_1calendar_1get_1date
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _year,
	jintArray _month,
	jintArray _day
)
{
	GtkCalendar* self;
	guint* year;
	guint* month;
	guint* day;

	// convert parameter self
	self = (GtkCalendar*) _self;

	// convert parameter year
	if (_year == NULL) {
		year = NULL;
	} else {
		year = (guint*) (*env)->GetIntArrayElements(env, _year, NULL);
		if (year == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter month
	if (_month == NULL) {
		month = NULL;
	} else {
		month = (guint*) (*env)->GetIntArrayElements(env, _month, NULL);
		if (month == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter day
	if (_day == NULL) {
		day = NULL;
	} else {
		day = (guint*) (*env)->GetIntArrayElements(env, _day, NULL);
		if (day == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_calendar_get_date(self, year, month, day);

	// cleanup parameter self

	// cleanup parameter year
	if (year != NULL) {
		(*env)->ReleaseIntArrayElements(env, _year, (jint*)year, 0);
	}

	// cleanup parameter month
	if (month != NULL) {
		(*env)->ReleaseIntArrayElements(env, _month, (jint*)month, 0);
	}

	// cleanup parameter day
	if (day != NULL) {
		(*env)->ReleaseIntArrayElements(env, _day, (jint*)day, 0);
	}
}
