/*
 * GtkCellLayout.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkCellLayout.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1pack_1start
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell,
	jboolean _expand
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;
	gboolean expand;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// convert parameter expand
	expand = (gboolean) _expand;

	// call function
	gtk_cell_layout_pack_start(self, cell, expand);

	// cleanup parameter self

	// cleanup parameter cell

	// cleanup parameter expand
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1pack_1end
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell,
	jboolean _expand
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;
	gboolean expand;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// convert parameter expand
	expand = (gboolean) _expand;

	// call function
	gtk_cell_layout_pack_end(self, cell, expand);

	// cleanup parameter self

	// cleanup parameter cell

	// cleanup parameter expand
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1clear
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkCellLayout* self;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// call function
	gtk_cell_layout_clear(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1set_1attributes
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// call function
	gtk_cell_layout_set_attributes(self, cell, NULL);

	// cleanup parameter self

	// cleanup parameter cell
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1add_1attribute
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell,
	jstring _attribute,
	jint _column
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;
	const gchar* attribute;
	gint column;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// convert parameter attribute
	attribute = (const gchar*) (*env)->GetStringUTFChars(env, _attribute, NULL);
	if (attribute == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter column
	column = (gint) _column;

	// call function
	gtk_cell_layout_add_attribute(self, cell, attribute, column);

	// cleanup parameter self

	// cleanup parameter cell

	// cleanup parameter attribute
	(*env)->ReleaseStringUTFChars(env, _attribute, attribute);

	// cleanup parameter column
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1clear_1attributes
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// call function
	gtk_cell_layout_clear_attributes(self, cell);

	// cleanup parameter self

	// cleanup parameter cell
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1reorder
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _cell,
	jint _position
)
{
	GtkCellLayout* self;
	GtkCellRenderer* cell;
	gint position;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// convert parameter cell
	cell = (GtkCellRenderer*) _cell;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_cell_layout_reorder(self, cell, position);

	// cleanup parameter self

	// cleanup parameter cell

	// cleanup parameter position
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkCellLayout_gtk_1cell_1layout_1get_1cells
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GtkCellLayout* self;

	// convert parameter self
	self = (GtkCellLayout*) _self;

	// call function
	result = gtk_cell_layout_get_cells(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_list_free(result);
	}

	// and finally
	return _result;
}
