/*
 * GtkCellView.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkCellView.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_cell_view_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _model
)
{
	GtkCellView* self;
	GtkTreeModel* model;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// call function
	gtk_cell_view_set_model(self, model);

	// cleanup parameter self

	// cleanup parameter model
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1displayed_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _path
)
{
	GtkCellView* self;
	GtkTreePath* path;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// call function
	gtk_cell_view_set_displayed_row(self, path);

	// cleanup parameter self

	// cleanup parameter path
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1get_1displayed_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* result;
	jlong _result;
	GtkCellView* self;

	// convert parameter self
	self = (GtkCellView*) _self;

	// call function
	result = gtk_cell_view_get_displayed_row(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1get_1size_1of_1row
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _path,
	jlong _requisition
)
{
	gboolean result;
	jboolean _result;
	GtkCellView* self;
	GtkTreePath* path;
	GtkRequisition* requisition;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// convert parameter requisition
	requisition = (GtkRequisition*) _requisition;

	// call function
	result = gtk_cell_view_get_size_of_row(self, path, requisition);

	// cleanup parameter self

	// cleanup parameter path

	// cleanup parameter requisition

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1set_1background_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkCellView* self;
	const GdkColor* color;

	// convert parameter self
	self = (GtkCellView*) _self;

	// convert parameter color
	color = (const GdkColor*) _color;

	// call function
	gtk_cell_view_set_background_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkCellView_gtk_1cell_1view_1get_1cell_1renderers
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GtkCellView* self;

	// convert parameter self
	self = (GtkCellView*) _self;

	// call function
	result = gtk_cell_view_get_cell_renderers(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_list_free(result);
	}

	// and finally
	return _result;
}
