/*
 * GtkClipboard.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkClipboard.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1store
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	gtk_clipboard_store(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1get_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkDisplay* result;
	jlong _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_get_display(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1get_1owner
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GObject* result;
	jlong _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_get_owner(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1clear
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	gtk_clipboard_clear(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text,
	jint _len
)
{
	GtkClipboard* self;
	const gchar* text;
	gint len;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter len
	len = (gint) _len;

	// call function
	gtk_clipboard_set_text(self, text, len);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);

	// cleanup parameter len
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1wait_1for_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_wait_for_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1wait_1is_1text_1available
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_wait_is_text_available(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1wait_1for_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_wait_for_image(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1set_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	GtkClipboard* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_clipboard_set_image(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1wait_1is_1image_1available
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkClipboard* self;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// call function
	result = gtk_clipboard_wait_is_image_available(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkClipboard_gtk_1clipboard_1wait_1is_1rich_1text_1available
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _buffer
)
{
	gboolean result;
	jboolean _result;
	GtkClipboard* self;
	GtkTextBuffer* buffer;

	// convert parameter self
	self = (GtkClipboard*) _self;

	// convert parameter buffer
	buffer = (GtkTextBuffer*) _buffer;

	// call function
	result = gtk_clipboard_wait_is_rich_text_available(self, buffer);

	// cleanup parameter self

	// cleanup parameter buffer

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
