/*
 * GtkColorButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkColorButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_color_button_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1new_1with_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _color
)
{
	GtkWidget* result;
	jlong _result;
	const GdkColor* color;

	// convert parameter color
	color = (const GdkColor*) _color;

	// call function
	result = gtk_color_button_new_with_color(color);

	// cleanup parameter color

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorButton* self;
	const GdkColor* color;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter color
	color = (const GdkColor*) _color;

	// call function
	gtk_color_button_set_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _alpha
)
{
	GtkColorButton* self;
	guint16 alpha;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter alpha
	alpha = (guint16) _alpha;

	// call function
	gtk_color_button_set_alpha(self, alpha);

	// cleanup parameter self

	// cleanup parameter alpha
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorButton* self;
	GdkColor* color;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_color_button_get_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1use_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useAlpha
)
{
	GtkColorButton* self;
	gboolean useAlpha;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter useAlpha
	useAlpha = (gboolean) _useAlpha;

	// call function
	gtk_color_button_set_use_alpha(self, useAlpha);

	// cleanup parameter self

	// cleanup parameter useAlpha
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1use_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_use_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkColorButton* self;
	const gchar* title;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_color_button_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkColorButton_gtk_1color_1button_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkColorButton* self;

	// convert parameter self
	self = (GtkColorButton*) _self;

	// call function
	result = gtk_color_button_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}
