/*
 * GtkColorSelection.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkColorSelection.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_color_selection_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1has_1opacity_1control
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkColorSelection* self;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// call function
	result = gtk_color_selection_get_has_opacity_control(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1has_1opacity_1control
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _hasOpacity
)
{
	GtkColorSelection* self;
	gboolean hasOpacity;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter hasOpacity
	hasOpacity = (gboolean) _hasOpacity;

	// call function
	gtk_color_selection_set_has_opacity_control(self, hasOpacity);

	// cleanup parameter self

	// cleanup parameter hasOpacity
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1has_1palette
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkColorSelection* self;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// call function
	result = gtk_color_selection_get_has_palette(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1has_1palette
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _hasPalette
)
{
	GtkColorSelection* self;
	gboolean hasPalette;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter hasPalette
	hasPalette = (gboolean) _hasPalette;

	// call function
	gtk_color_selection_set_has_palette(self, hasPalette);

	// cleanup parameter self

	// cleanup parameter hasPalette
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1current_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorSelection* self;
	GdkColor* color;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_color_selection_set_current_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1current_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _alpha
)
{
	GtkColorSelection* self;
	guint16 alpha;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter alpha
	alpha = (guint16) _alpha;

	// call function
	gtk_color_selection_set_current_alpha(self, alpha);

	// cleanup parameter self

	// cleanup parameter alpha
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1current_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorSelection* self;
	GdkColor* color;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_color_selection_get_current_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1current_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	GtkColorSelection* self;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// call function
	result = gtk_color_selection_get_current_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1previous_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorSelection* self;
	GdkColor* color;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_color_selection_set_previous_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1set_1previous_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _alpha
)
{
	GtkColorSelection* self;
	guint16 alpha;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter alpha
	alpha = (guint16) _alpha;

	// call function
	gtk_color_selection_set_previous_alpha(self, alpha);

	// cleanup parameter self

	// cleanup parameter alpha
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1previous_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _color
)
{
	GtkColorSelection* self;
	GdkColor* color;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_color_selection_get_previous_color(self, color);

	// cleanup parameter self

	// cleanup parameter color
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1get_1previous_1alpha
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	GtkColorSelection* self;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// call function
	result = gtk_color_selection_get_previous_alpha(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkColorSelection_gtk_1color_1selection_1is_1adjusting
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkColorSelection* self;

	// convert parameter self
	self = (GtkColorSelection*) _self;

	// call function
	result = gtk_color_selection_is_adjusting(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
