/*
 * GtkComboBox.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkComboBox.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_combo_box_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1new_1text
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_combo_box_new_text();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1new_1with_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _model
)
{
	GtkWidget* result;
	jlong _result;
	GtkTreeModel* model;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// call function
	result = gtk_combo_box_new_with_model(model);

	// cleanup parameter model

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1wrap_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width
)
{
	GtkComboBox* self;
	gint width;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter width
	width = (gint) _width;

	// call function
	gtk_combo_box_set_wrap_width(self, width);

	// cleanup parameter self

	// cleanup parameter width
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1row_1span_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _rowSpan
)
{
	GtkComboBox* self;
	gint rowSpan;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter rowSpan
	rowSpan = (gint) _rowSpan;

	// call function
	gtk_combo_box_set_row_span_column(self, rowSpan);

	// cleanup parameter self

	// cleanup parameter rowSpan
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1column_1span_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _columnSpan
)
{
	GtkComboBox* self;
	gint columnSpan;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter columnSpan
	columnSpan = (gint) _columnSpan;

	// call function
	gtk_combo_box_set_column_span_column(self, columnSpan);

	// cleanup parameter self

	// cleanup parameter columnSpan
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_active(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index
)
{
	GtkComboBox* self;
	gint index;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter index
	index = (gint) _index;

	// call function
	gtk_combo_box_set_active(self, index);

	// cleanup parameter self

	// cleanup parameter index
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1active_1iter
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	gboolean result;
	jboolean _result;
	GtkComboBox* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	result = gtk_combo_box_get_active_iter(self, iter);

	// cleanup parameter self

	// cleanup parameter iter

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1active_1iter
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	GtkComboBox* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	gtk_combo_box_set_active_iter(self, iter);

	// cleanup parameter self

	// cleanup parameter iter
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _model
)
{
	GtkComboBox* self;
	GtkTreeModel* model;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// call function
	gtk_combo_box_set_model(self, model);

	// cleanup parameter self

	// cleanup parameter model
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeModel* result;
	jlong _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_model(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1append_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkComboBox* self;
	const gchar* text;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_combo_box_append_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1insert_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position,
	jstring _text
)
{
	GtkComboBox* self;
	gint position;
	const gchar* text;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter position
	position = (gint) _position;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_combo_box_insert_text(self, position, text);

	// cleanup parameter self

	// cleanup parameter position

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1prepend_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkComboBox* self;
	const gchar* text;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_combo_box_prepend_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1remove_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position
)
{
	GtkComboBox* self;
	gint position;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_combo_box_remove_text(self, position);

	// cleanup parameter self

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1popup
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	gtk_combo_box_popup(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1popdown
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	gtk_combo_box_popdown(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1wrap_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_wrap_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1row_1span_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_row_span_column(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1column_1span_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_column_span_column(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1add_1tearoffs
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_add_tearoffs(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1add_1tearoffs
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _addTearoffs
)
{
	GtkComboBox* self;
	gboolean addTearoffs;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter addTearoffs
	addTearoffs = (gboolean) _addTearoffs;

	// call function
	gtk_combo_box_set_add_tearoffs(self, addTearoffs);

	// cleanup parameter self

	// cleanup parameter addTearoffs
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_focus_on_click(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _focusOnClick
)
{
	GtkComboBox* self;
	gboolean focusOnClick;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter focusOnClick
	focusOnClick = (gboolean) _focusOnClick;

	// call function
	gtk_combo_box_set_focus_on_click(self, focusOnClick);

	// cleanup parameter self

	// cleanup parameter focusOnClick
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1active_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_active_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1popup_1accessible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	AtkObject* result;
	jlong _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_popup_accessible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkComboBox* self;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// call function
	result = gtk_combo_box_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBox_gtk_1combo_1box_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkComboBox* self;
	const gchar* title;

	// convert parameter self
	self = (GtkComboBox*) _self;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_combo_box_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}
