/*
 * GtkComboBoxEntry.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkComboBoxEntry.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBoxEntry_gtk_1combo_1box_1entry_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_combo_box_entry_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBoxEntry_gtk_1combo_1box_1entry_1new_1with_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _model,
	jint _textColumn
)
{
	GtkWidget* result;
	jlong _result;
	GtkTreeModel* model;
	gint textColumn;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// convert parameter textColumn
	textColumn = (gint) _textColumn;

	// call function
	result = gtk_combo_box_entry_new_with_model(model, textColumn);

	// cleanup parameter model

	// cleanup parameter textColumn

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkComboBoxEntry_gtk_1combo_1box_1entry_1new_1text
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_combo_box_entry_new_text();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkComboBoxEntry_gtk_1combo_1box_1entry_1set_1text_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _textColumn
)
{
	GtkComboBoxEntry* self;
	gint textColumn;

	// convert parameter self
	self = (GtkComboBoxEntry*) _self;

	// convert parameter textColumn
	textColumn = (gint) _textColumn;

	// call function
	gtk_combo_box_entry_set_text_column(self, textColumn);

	// cleanup parameter self

	// cleanup parameter textColumn
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkComboBoxEntry_gtk_1combo_1box_1entry_1get_1text_1column
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkComboBoxEntry* self;

	// convert parameter self
	self = (GtkComboBoxEntry*) _self;

	// call function
	result = gtk_combo_box_entry_get_text_column(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
