/*
 * GtkContainer.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkContainer.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1border_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _borderWidth
)
{
	GtkContainer* self;
	guint borderWidth;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter borderWidth
	borderWidth = (guint) _borderWidth;

	// call function
	gtk_container_set_border_width(self, borderWidth);

	// cleanup parameter self

	// cleanup parameter borderWidth
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1get_1border_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	result = gtk_container_get_border_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1add
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _widget
)
{
	GtkContainer* self;
	GtkWidget* widget;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// call function
	gtk_container_add(self, widget);

	// cleanup parameter self

	// cleanup parameter widget
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1remove
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _widget
)
{
	GtkContainer* self;
	GtkWidget* widget;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// call function
	gtk_container_remove(self, widget);

	// cleanup parameter self

	// cleanup parameter widget
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1resize_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _resizeMode
)
{
	GtkContainer* self;
	GtkResizeMode resizeMode;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter resizeMode
	resizeMode = (GtkResizeMode) _resizeMode;

	// call function
	gtk_container_set_resize_mode(self, resizeMode);

	// cleanup parameter self

	// cleanup parameter resizeMode
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1get_1resize_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkResizeMode result;
	jint _result;
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	result = gtk_container_get_resize_mode(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1check_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	gtk_container_check_resize(self);

	// cleanup parameter self
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1get_1children
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	result = gtk_container_get_children(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// cleanup return value
	if (result != NULL) {
		g_list_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1propagate_1expose
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _event
)
{
	GtkContainer* self;
	GtkWidget* child;
	GdkEventExpose* event;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter event
	event = (GdkEventExpose*) _event;

	// call function
	gtk_container_propagate_expose(self, child, event);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter event
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1focus_1chain
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _focusableWidgets
)
{
	GtkContainer* self;
	GList* focusableWidgets;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter focusableWidgets
	focusableWidgets = (GList*) bindings_java_convert_jarray_to_glist(env, _focusableWidgets);
	if (focusableWidgets == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_container_set_focus_chain(self, focusableWidgets);

	// cleanup parameter self

	// cleanup parameter focusableWidgets
	g_list_free(focusableWidgets);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1unset_1focus_1chain
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	gtk_container_unset_focus_chain(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1reallocate_1redraws
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _needsRedraws
)
{
	GtkContainer* self;
	gboolean needsRedraws;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter needsRedraws
	needsRedraws = (gboolean) _needsRedraws;

	// call function
	gtk_container_set_reallocate_redraws(self, needsRedraws);

	// cleanup parameter self

	// cleanup parameter needsRedraws
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1focus_1child
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkContainer* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	gtk_container_set_focus_child(self, child);

	// cleanup parameter self

	// cleanup parameter child
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1focus_1vadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkContainer* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_container_set_focus_vadjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1get_1focus_1vadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	result = gtk_container_get_focus_vadjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1set_1focus_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkContainer* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_container_set_focus_hadjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1get_1focus_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	result = gtk_container_get_focus_hadjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1resize_1children
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkContainer* self;

	// convert parameter self
	self = (GtkContainer*) _self;

	// call function
	gtk_container_resize_children(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1add_1with_1properties
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _widget,
	jstring _firstPropName
)
{
	GtkContainer* self;
	GtkWidget* widget;
	const gchar* firstPropName;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// convert parameter firstPropName
	firstPropName = (const gchar*) (*env)->GetStringUTFChars(env, _firstPropName, NULL);
	if (firstPropName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_container_add_with_properties(self, widget, firstPropName, NULL);

	// cleanup parameter self

	// cleanup parameter widget

	// cleanup parameter firstPropName
	(*env)->ReleaseStringUTFChars(env, _firstPropName, firstPropName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1child_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _firstPropName
)
{
	GtkContainer* self;
	GtkWidget* child;
	const gchar* firstPropName;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter firstPropName
	firstPropName = (const gchar*) (*env)->GetStringUTFChars(env, _firstPropName, NULL);
	if (firstPropName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_container_child_set(self, child, firstPropName, NULL);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter firstPropName
	(*env)->ReleaseStringUTFChars(env, _firstPropName, firstPropName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1child_1get
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _firstPropName
)
{
	GtkContainer* self;
	GtkWidget* child;
	const gchar* firstPropName;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter firstPropName
	firstPropName = (const gchar*) (*env)->GetStringUTFChars(env, _firstPropName, NULL);
	if (firstPropName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_container_child_get(self, child, firstPropName, NULL);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter firstPropName
	(*env)->ReleaseStringUTFChars(env, _firstPropName, firstPropName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1child_1set_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _propertyName,
	jlong _value
)
{
	GtkContainer* self;
	GtkWidget* child;
	const gchar* propertyName;
	const GValue* value;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter propertyName
	propertyName = (const gchar*) (*env)->GetStringUTFChars(env, _propertyName, NULL);
	if (propertyName == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (const GValue*) _value;

	// call function
	gtk_container_child_set_property(self, child, propertyName, value);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter propertyName
	(*env)->ReleaseStringUTFChars(env, _propertyName, propertyName);

	// cleanup parameter value
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkContainer_gtk_1container_1child_1get_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _propertyName,
	jlong _value
)
{
	GtkContainer* self;
	GtkWidget* child;
	const gchar* propertyName;
	GValue* value;

	// convert parameter self
	self = (GtkContainer*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter propertyName
	propertyName = (const gchar*) (*env)->GetStringUTFChars(env, _propertyName, NULL);
	if (propertyName == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (GValue*) _value;

	// call function
	gtk_container_child_get_property(self, child, propertyName, value);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter propertyName
	(*env)->ReleaseStringUTFChars(env, _propertyName, propertyName);

	// cleanup parameter value
}
