/*
 * GtkCurve.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkCurve.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_curve_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1reset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkCurve* self;

	// convert parameter self
	self = (GtkCurve*) _self;

	// call function
	gtk_curve_reset(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1set_1gamma
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _gamma
)
{
	GtkCurve* self;
	gfloat gamma;

	// convert parameter self
	self = (GtkCurve*) _self;

	// convert parameter gamma
	gamma = (gfloat) _gamma;

	// call function
	gtk_curve_set_gamma(self, gamma);

	// cleanup parameter self

	// cleanup parameter gamma
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1set_1range
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _minX,
	jfloat _maxX,
	jfloat _minY,
	jfloat _maxY
)
{
	GtkCurve* self;
	gfloat minX;
	gfloat maxX;
	gfloat minY;
	gfloat maxY;

	// convert parameter self
	self = (GtkCurve*) _self;

	// convert parameter minX
	minX = (gfloat) _minX;

	// convert parameter maxX
	maxX = (gfloat) _maxX;

	// convert parameter minY
	minY = (gfloat) _minY;

	// convert parameter maxY
	maxY = (gfloat) _maxY;

	// call function
	gtk_curve_set_range(self, minX, maxX, minY, maxY);

	// cleanup parameter self

	// cleanup parameter minX

	// cleanup parameter maxX

	// cleanup parameter minY

	// cleanup parameter maxY
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1get_1vector
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _veclen,
	jfloatArray _vector
)
{
	GtkCurve* self;
	int veclen;
	gfloat* vector;

	// convert parameter self
	self = (GtkCurve*) _self;

	// convert parameter veclen
	veclen = (int) _veclen;

	// convert parameter vector
	vector = (gfloat*) (*env)->GetFloatArrayElements(env, _vector, NULL);
	if (vector == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_curve_get_vector(self, veclen, vector);

	// cleanup parameter self

	// cleanup parameter veclen

	// cleanup parameter vector
	(*env)->ReleaseFloatArrayElements(env, _vector, (jfloat*)vector, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1set_1vector
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _veclen,
	jfloatArray _vector
)
{
	GtkCurve* self;
	int veclen;
	gfloat* vector;

	// convert parameter self
	self = (GtkCurve*) _self;

	// convert parameter veclen
	veclen = (int) _veclen;

	// convert parameter vector
	vector = (gfloat*) (*env)->GetFloatArrayElements(env, _vector, NULL);
	if (vector == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_curve_set_vector(self, veclen, vector);

	// cleanup parameter self

	// cleanup parameter veclen

	// cleanup parameter vector
	(*env)->ReleaseFloatArrayElements(env, _vector, (jfloat*)vector, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkCurve_gtk_1curve_1set_1curve_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _type
)
{
	GtkCurve* self;
	GtkCurveType type;

	// convert parameter self
	self = (GtkCurve*) _self;

	// convert parameter type
	type = (GtkCurveType) _type;

	// call function
	gtk_curve_set_curve_type(self, type);

	// cleanup parameter self

	// cleanup parameter type
}
