/*
 * GtkDialog.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkDialog.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_dialog_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1new_1with_1buttons
(
	JNIEnv* env,
	jclass cls,
	jstring _title,
	jlong _parent,
	jint _flags,
	jstring _firstButtonText
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* title;
	GtkWindow* parent;
	GtkDialogFlags flags;
	const gchar* firstButtonText;

	// convert parameter title
	if (_title == NULL) {
		title = NULL;
	} else {
		title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
		if (title == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter parent
	parent = (GtkWindow*) _parent;

	// convert parameter flags
	flags = (GtkDialogFlags) _flags;

	// convert parameter firstButtonText
	if (_firstButtonText == NULL) {
		firstButtonText = NULL;
	} else {
		firstButtonText = (const gchar*) (*env)->GetStringUTFChars(env, _firstButtonText, NULL);
		if (firstButtonText == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_dialog_new_with_buttons(title, parent, flags, firstButtonText, NULL);

	// cleanup parameter title
	if (title != NULL) {
		(*env)->ReleaseStringUTFChars(env, _title, title);
	}

	// cleanup parameter parent

	// cleanup parameter flags

	// cleanup parameter firstButtonText
	if (firstButtonText != NULL) {
		(*env)->ReleaseStringUTFChars(env, _firstButtonText, firstButtonText);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1add_1action_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _responseId
)
{
	GtkDialog* self;
	GtkWidget* child;
	gint responseId;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter responseId
	responseId = (gint) _responseId;

	// call function
	gtk_dialog_add_action_widget(self, child, responseId);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter responseId
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1add_1button
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _buttonText,
	jint _responseId
)
{
	GtkWidget* result;
	jlong _result;
	GtkDialog* self;
	const gchar* buttonText;
	gint responseId;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter buttonText
	buttonText = (const gchar*) (*env)->GetStringUTFChars(env, _buttonText, NULL);
	if (buttonText == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter responseId
	responseId = (gint) _responseId;

	// call function
	result = gtk_dialog_add_button(self, buttonText, responseId);

	// cleanup parameter self

	// cleanup parameter buttonText
	(*env)->ReleaseStringUTFChars(env, _buttonText, buttonText);

	// cleanup parameter responseId

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1add_1buttons
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _firstButtonText
)
{
	GtkDialog* self;
	const gchar* firstButtonText;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter firstButtonText
	firstButtonText = (const gchar*) (*env)->GetStringUTFChars(env, _firstButtonText, NULL);
	if (firstButtonText == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_dialog_add_buttons(self, firstButtonText, NULL);

	// cleanup parameter self

	// cleanup parameter firstButtonText
	(*env)->ReleaseStringUTFChars(env, _firstButtonText, firstButtonText);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1set_1response_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _responseId,
	jboolean _setting
)
{
	GtkDialog* self;
	gint responseId;
	gboolean setting;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter responseId
	responseId = (gint) _responseId;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_dialog_set_response_sensitive(self, responseId, setting);

	// cleanup parameter self

	// cleanup parameter responseId

	// cleanup parameter setting
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1set_1default_1response
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _responseId
)
{
	GtkDialog* self;
	gint responseId;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter responseId
	responseId = (gint) _responseId;

	// call function
	gtk_dialog_set_default_response(self, responseId);

	// cleanup parameter self

	// cleanup parameter responseId
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1get_1response_1for_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _widget
)
{
	gint result;
	jint _result;
	GtkDialog* self;
	GtkWidget* widget;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// call function
	result = gtk_dialog_get_response_for_widget(self, widget);

	// cleanup parameter self

	// cleanup parameter widget

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1set_1has_1separator
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkDialog* self;
	gboolean setting;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_dialog_set_has_separator(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1get_1has_1separator
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkDialog* self;

	// convert parameter self
	self = (GtkDialog*) _self;

	// call function
	result = gtk_dialog_get_has_separator(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1response
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _responseId
)
{
	GtkDialog* self;
	gint responseId;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter responseId
	responseId = (gint) _responseId;

	// call function
	gtk_dialog_response(self, responseId);

	// cleanup parameter self

	// cleanup parameter responseId
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1run
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkDialog* self;

	// convert parameter self
	self = (GtkDialog*) _self;

	// call function
	result = gtk_dialog_run(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1set_1alternative_1button_1order
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _firstResponseId
)
{
	GtkDialog* self;
	gint firstResponseId;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter firstResponseId
	firstResponseId = (gint) _firstResponseId;

	// call function
	gtk_dialog_set_alternative_button_order(self, firstResponseId, NULL);

	// cleanup parameter self

	// cleanup parameter firstResponseId
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkDialog_gtk_1dialog_1set_1alternative_1button_1order_1from_1array
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _nParams,
	jintArray _newOrder
)
{
	GtkDialog* self;
	gint nParams;
	gint* newOrder;

	// convert parameter self
	self = (GtkDialog*) _self;

	// convert parameter nParams
	nParams = (gint) _nParams;

	// convert parameter newOrder
	newOrder = (gint*) (*env)->GetIntArrayElements(env, _newOrder, NULL);
	if (newOrder == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_dialog_set_alternative_button_order_from_array(self, nParams, newOrder);

	// cleanup parameter self

	// cleanup parameter nParams

	// cleanup parameter newOrder
	(*env)->ReleaseIntArrayElements(env, _newOrder, (jint*)newOrder, 0);
}
