/*
 * GtkEntry.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkEntry.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_entry_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1visibility
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _visible
)
{
	GtkEntry* self;
	gboolean visible;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter visible
	visible = (gboolean) _visible;

	// call function
	gtk_entry_set_visibility(self, visible);

	// cleanup parameter self

	// cleanup parameter visible
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1visibility
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_visibility(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1invisible_1char
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _ch
)
{
	GtkEntry* self;
	gunichar ch;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter ch
	ch = (gunichar) _ch;

	// call function
	gtk_entry_set_invisible_char(self, ch);

	// cleanup parameter self

	// cleanup parameter ch
}

JNIEXPORT jchar JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1invisible_1char
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gunichar result;
	jchar _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_invisible_char(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1has_1frame
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkEntry* self;
	gboolean setting;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_entry_set_has_frame(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1has_1frame
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_has_frame(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1max_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _max
)
{
	GtkEntry* self;
	gint max;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter max
	max = (gint) _max;

	// call function
	gtk_entry_set_max_length(self, max);

	// cleanup parameter self

	// cleanup parameter max
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1max_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_max_length(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1activates_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkEntry* self;
	gboolean setting;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_entry_set_activates_default(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1activates_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_activates_default(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1width_1chars
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _nChars
)
{
	GtkEntry* self;
	gint nChars;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter nChars
	nChars = (gint) _nChars;

	// call function
	gtk_entry_set_width_chars(self, nChars);

	// cleanup parameter self

	// cleanup parameter nChars
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1width_1chars
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_width_chars(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkEntry* self;
	const gchar* text;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_entry_set_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1layout
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoLayout* result;
	jlong _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_layout(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1layout_1offsets
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y
)
{
	GtkEntry* self;
	gint* x;
	gint* y;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_entry_get_layout_offsets(self, x, y);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _xalign
)
{
	GtkEntry* self;
	gfloat xalign;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter xalign
	xalign = (gfloat) _xalign;

	// call function
	gtk_entry_set_alignment(self, xalign);

	// cleanup parameter self

	// cleanup parameter xalign
}

JNIEXPORT jfloat JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gfloat result;
	jfloat _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_alignment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jfloat) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1completion
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _completion
)
{
	GtkEntry* self;
	GtkEntryCompletion* completion;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter completion
	completion = (GtkEntryCompletion*) _completion;

	// call function
	gtk_entry_set_completion(self, completion);

	// cleanup parameter self

	// cleanup parameter completion
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1completion
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkEntryCompletion* result;
	jlong _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_completion(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1layout_1index_1to_1text_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _layoutIndex
)
{
	gint result;
	jint _result;
	GtkEntry* self;
	gint layoutIndex;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter layoutIndex
	layoutIndex = (gint) _layoutIndex;

	// call function
	result = gtk_entry_layout_index_to_text_index(self, layoutIndex);

	// cleanup parameter self

	// cleanup parameter layoutIndex

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1text_1index_1to_1layout_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _textIndex
)
{
	gint result;
	jint _result;
	GtkEntry* self;
	gint textIndex;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter textIndex
	textIndex = (gint) _textIndex;

	// call function
	result = gtk_entry_text_index_to_layout_index(self, textIndex);

	// cleanup parameter self

	// cleanup parameter textIndex

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1inner_1border
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _border
)
{
	GtkEntry* self;
	const GtkBorder* border;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter border
	border = (const GtkBorder*) _border;

	// call function
	gtk_entry_set_inner_border(self, border);

	// cleanup parameter self

	// cleanup parameter border
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1inner_1border
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const GtkBorder* result;
	jlong _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_inner_border(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1set_1cursor_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkEntry* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkEntry*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_entry_set_cursor_hadjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkEntry_gtk_1entry_1get_1cursor_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkEntry* self;

	// convert parameter self
	self = (GtkEntry*) _self;

	// call function
	result = gtk_entry_get_cursor_hadjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
