/*
 * GtkExpander.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkExpander.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_expander_new(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1new_1with_1mnemonic
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_expander_new_with_mnemonic(label);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1expanded
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _expanded
)
{
	GtkExpander* self;
	gboolean expanded;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter expanded
	expanded = (gboolean) _expanded;

	// call function
	gtk_expander_set_expanded(self, expanded);

	// cleanup parameter self

	// cleanup parameter expanded
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1expanded
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_expanded(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _spacing
)
{
	GtkExpander* self;
	gint spacing;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter spacing
	spacing = (gint) _spacing;

	// call function
	gtk_expander_set_spacing(self, spacing);

	// cleanup parameter self

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_spacing(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _label
)
{
	GtkExpander* self;
	const gchar* label;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_expander_set_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_label(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useUnderline
)
{
	GtkExpander* self;
	gboolean useUnderline;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter useUnderline
	useUnderline = (gboolean) _useUnderline;

	// call function
	gtk_expander_set_use_underline(self, useUnderline);

	// cleanup parameter self

	// cleanup parameter useUnderline
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_use_underline(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1use_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useMarkup
)
{
	GtkExpander* self;
	gboolean useMarkup;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter useMarkup
	useMarkup = (gboolean) _useMarkup;

	// call function
	gtk_expander_set_use_markup(self, useMarkup);

	// cleanup parameter self

	// cleanup parameter useMarkup
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1use_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_use_markup(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1set_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _labelWidget
)
{
	GtkExpander* self;
	GtkWidget* labelWidget;

	// convert parameter self
	self = (GtkExpander*) _self;

	// convert parameter labelWidget
	labelWidget = (GtkWidget*) _labelWidget;

	// call function
	gtk_expander_set_label_widget(self, labelWidget);

	// cleanup parameter self

	// cleanup parameter labelWidget
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkExpander_gtk_1expander_1get_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkExpander* self;

	// convert parameter self
	self = (GtkExpander*) _self;

	// call function
	result = gtk_expander_get_label_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
