/*
 * GtkFileChooserButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkFileChooserButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _title,
	jint _action
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* title;
	GtkFileChooserAction action;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter action
	action = (GtkFileChooserAction) _action;

	// call function
	result = gtk_file_chooser_button_new(title, action);

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);

	// cleanup parameter action

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkFileChooserButton* self;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// call function
	result = gtk_file_chooser_button_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkFileChooserButton* self;
	const gchar* title;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_file_chooser_button_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1get_1width_1chars
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkFileChooserButton* self;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// call function
	result = gtk_file_chooser_button_get_width_chars(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1set_1width_1chars
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _nChars
)
{
	GtkFileChooserButton* self;
	gint nChars;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// convert parameter nChars
	nChars = (gint) _nChars;

	// call function
	gtk_file_chooser_button_set_width_chars(self, nChars);

	// cleanup parameter self

	// cleanup parameter nChars
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1get_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkFileChooserButton* self;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// call function
	result = gtk_file_chooser_button_get_focus_on_click(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFileChooserButton_gtk_1file_1chooser_1button_1set_1focus_1on_1click
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _focusOnClick
)
{
	GtkFileChooserButton* self;
	gboolean focusOnClick;

	// convert parameter self
	self = (GtkFileChooserButton*) _self;

	// convert parameter focusOnClick
	focusOnClick = (gboolean) _focusOnClick;

	// call function
	gtk_file_chooser_button_set_focus_on_click(self, focusOnClick);

	// cleanup parameter self

	// cleanup parameter focusOnClick
}
