/*
 * GtkFontButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkFontButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_font_button_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkFontButton* self;
	const gchar* title;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_font_button_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1use_1font
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_use_font(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1use_1font
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useFont
)
{
	GtkFontButton* self;
	gboolean useFont;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter useFont
	useFont = (gboolean) _useFont;

	// call function
	gtk_font_button_set_use_font(self, useFont);

	// cleanup parameter self

	// cleanup parameter useFont
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1use_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_use_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1use_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useSize
)
{
	GtkFontButton* self;
	gboolean useSize;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter useSize
	useSize = (gboolean) _useSize;

	// call function
	gtk_font_button_set_use_size(self, useSize);

	// cleanup parameter self

	// cleanup parameter useSize
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1font_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_font_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1font_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _fontname
)
{
	gboolean result;
	jboolean _result;
	GtkFontButton* self;
	const gchar* fontname;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter fontname
	fontname = (const gchar*) (*env)->GetStringUTFChars(env, _fontname, NULL);
	if (fontname == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_font_button_set_font_name(self, fontname);

	// cleanup parameter self

	// cleanup parameter fontname
	(*env)->ReleaseStringUTFChars(env, _fontname, fontname);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1show_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_show_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1show_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showStyle
)
{
	GtkFontButton* self;
	gboolean showStyle;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter showStyle
	showStyle = (gboolean) _showStyle;

	// call function
	gtk_font_button_set_show_style(self, showStyle);

	// cleanup parameter self

	// cleanup parameter showStyle
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1get_1show_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkFontButton* self;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// call function
	result = gtk_font_button_get_show_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontButton_gtk_1font_1button_1set_1show_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showSize
)
{
	GtkFontButton* self;
	gboolean showSize;

	// convert parameter self
	self = (GtkFontButton*) _self;

	// convert parameter showSize
	showSize = (gboolean) _showSize;

	// call function
	gtk_font_button_set_show_size(self, showSize);

	// cleanup parameter self

	// cleanup parameter showSize
}
