/*
 * GtkFontSelectionDialog.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkFontSelectionDialog.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkFontSelectionDialog_gtk_1font_1selection_1dialog_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _title
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* title;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_font_selection_dialog_new(title);

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFontSelectionDialog_gtk_1font_1selection_1dialog_1get_1font_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkFontSelectionDialog* self;

	// convert parameter self
	self = (GtkFontSelectionDialog*) _self;

	// call function
	result = gtk_font_selection_dialog_get_font_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkFontSelectionDialog_gtk_1font_1selection_1dialog_1set_1font_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _fontname
)
{
	gboolean result;
	jboolean _result;
	GtkFontSelectionDialog* self;
	const gchar* fontname;

	// convert parameter self
	self = (GtkFontSelectionDialog*) _self;

	// convert parameter fontname
	fontname = (const gchar*) (*env)->GetStringUTFChars(env, _fontname, NULL);
	if (fontname == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_font_selection_dialog_set_font_name(self, fontname);

	// cleanup parameter self

	// cleanup parameter fontname
	(*env)->ReleaseStringUTFChars(env, _fontname, fontname);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFontSelectionDialog_gtk_1font_1selection_1dialog_1get_1preview_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkFontSelectionDialog* self;

	// convert parameter self
	self = (GtkFontSelectionDialog*) _self;

	// call function
	result = gtk_font_selection_dialog_get_preview_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFontSelectionDialog_gtk_1font_1selection_1dialog_1set_1preview_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkFontSelectionDialog* self;
	const gchar* text;

	// convert parameter self
	self = (GtkFontSelectionDialog*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_font_selection_dialog_set_preview_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}
