/*
 * GtkFrame.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkFrame.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_frame_new(label);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1set_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _label
)
{
	GtkFrame* self;
	const gchar* label;

	// convert parameter self
	self = (GtkFrame*) _self;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_frame_set_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1get_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkFrame* self;

	// convert parameter self
	self = (GtkFrame*) _self;

	// call function
	result = gtk_frame_get_label(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1set_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _labelWidget
)
{
	GtkFrame* self;
	GtkWidget* labelWidget;

	// convert parameter self
	self = (GtkFrame*) _self;

	// convert parameter labelWidget
	labelWidget = (GtkWidget*) _labelWidget;

	// call function
	gtk_frame_set_label_widget(self, labelWidget);

	// cleanup parameter self

	// cleanup parameter labelWidget
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1get_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkFrame* self;

	// convert parameter self
	self = (GtkFrame*) _self;

	// call function
	result = gtk_frame_get_label_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1set_1label_1align
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloat _xalign,
	jfloat _yalign
)
{
	GtkFrame* self;
	gfloat xalign;
	gfloat yalign;

	// convert parameter self
	self = (GtkFrame*) _self;

	// convert parameter xalign
	xalign = (gfloat) _xalign;

	// convert parameter yalign
	yalign = (gfloat) _yalign;

	// call function
	gtk_frame_set_label_align(self, xalign, yalign);

	// cleanup parameter self

	// cleanup parameter xalign

	// cleanup parameter yalign
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1get_1label_1align
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jfloatArray _xalign,
	jfloatArray _yalign
)
{
	GtkFrame* self;
	gfloat* xalign;
	gfloat* yalign;

	// convert parameter self
	self = (GtkFrame*) _self;

	// convert parameter xalign
	xalign = (gfloat*) (*env)->GetFloatArrayElements(env, _xalign, NULL);
	if (xalign == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter yalign
	yalign = (gfloat*) (*env)->GetFloatArrayElements(env, _yalign, NULL);
	if (yalign == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_frame_get_label_align(self, xalign, yalign);

	// cleanup parameter self

	// cleanup parameter xalign
	(*env)->ReleaseFloatArrayElements(env, _xalign, (jfloat*)xalign, 0);

	// cleanup parameter yalign
	(*env)->ReleaseFloatArrayElements(env, _yalign, (jfloat*)yalign, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1set_1shadow_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _type
)
{
	GtkFrame* self;
	GtkShadowType type;

	// convert parameter self
	self = (GtkFrame*) _self;

	// convert parameter type
	type = (GtkShadowType) _type;

	// call function
	gtk_frame_set_shadow_type(self, type);

	// cleanup parameter self

	// cleanup parameter type
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkFrame_gtk_1frame_1get_1shadow_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkShadowType result;
	jint _result;
	GtkFrame* self;

	// convert parameter self
	self = (GtkFrame*) _self;

	// call function
	result = gtk_frame_get_shadow_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
