/*
 * GtkIconFactory.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkIconFactory.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconFactory_gtk_1icon_1factory_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkIconFactory* result;
	jlong _result;

	// call function
	result = gtk_icon_factory_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkIconFactory_gtk_1icon_1factory_1add
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId,
	jlong _iconSet
)
{
	GtkIconFactory* self;
	const gchar* stockId;
	GtkIconSet* iconSet;

	// convert parameter self
	self = (GtkIconFactory*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter iconSet
	iconSet = (GtkIconSet*) _iconSet;

	// call function
	gtk_icon_factory_add(self, stockId, iconSet);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// cleanup parameter iconSet
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconFactory_gtk_1icon_1factory_1lookup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId
)
{
	GtkIconSet* result;
	jlong _result;
	GtkIconFactory* self;
	const gchar* stockId;

	// convert parameter self
	self = (GtkIconFactory*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_icon_factory_lookup(self, stockId);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkIconFactory_gtk_1icon_1factory_1add_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconFactory* self;

	// convert parameter self
	self = (GtkIconFactory*) _self;

	// call function
	gtk_icon_factory_add_default(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkIconFactory_gtk_1icon_1factory_1remove_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconFactory* self;

	// convert parameter self
	self = (GtkIconFactory*) _self;

	// call function
	gtk_icon_factory_remove_default(self);

	// cleanup parameter self
}
