/*
 * GtkIconSet.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkIconSet.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1new_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _pixbuf
)
{
	GtkIconSet* result;
	jlong _result;
	GdkPixbuf* pixbuf;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	result = gtk_icon_set_new_from_pixbuf(pixbuf);

	// cleanup parameter pixbuf

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1ref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconSet* result;
	jlong _result;
	GtkIconSet* self;

	// convert parameter self
	self = (GtkIconSet*) _self;

	// call function
	result = gtk_icon_set_ref(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1unref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconSet* self;

	// convert parameter self
	self = (GtkIconSet*) _self;

	// call function
	gtk_icon_set_unref(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconSet* result;
	jlong _result;
	GtkIconSet* self;

	// convert parameter self
	self = (GtkIconSet*) _self;

	// call function
	result = gtk_icon_set_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1render_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _style,
	jint _direction,
	jint _state,
	jint _size,
	jlong _widget,
	jstring _detail
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkIconSet* self;
	GtkStyle* style;
	GtkTextDirection direction;
	GtkStateType state;
	GtkIconSize size;
	GtkWidget* widget;
	const char* detail;

	// convert parameter self
	self = (GtkIconSet*) _self;

	// convert parameter style
	style = (GtkStyle*) _style;

	// convert parameter direction
	direction = (GtkTextDirection) _direction;

	// convert parameter state
	state = (GtkStateType) _state;

	// convert parameter size
	size = (GtkIconSize) _size;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// convert parameter detail
	if (_detail == NULL) {
		detail = NULL;
	} else {
		detail = (const char*) (*env)->GetStringUTFChars(env, _detail, NULL);
		if (detail == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_icon_set_render_icon(self, style, direction, state, size, widget, detail);

	// cleanup parameter self

	// cleanup parameter style

	// cleanup parameter direction

	// cleanup parameter state

	// cleanup parameter size

	// cleanup parameter widget

	// cleanup parameter detail
	if (detail != NULL) {
		(*env)->ReleaseStringUTFChars(env, _detail, detail);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkIconSet_gtk_1icon_1set_1add_1source
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _source
)
{
	GtkIconSet* self;
	const GtkIconSource* source;

	// convert parameter self
	self = (GtkIconSet*) _self;

	// convert parameter source
	source = (const GtkIconSource*) _source;

	// call function
	gtk_icon_set_add_source(self, source);

	// cleanup parameter self

	// cleanup parameter source
}
