/*
 * GtkImage.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkImage.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_image_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1pixmap
(
	JNIEnv* env,
	jclass cls,
	jlong _pixmap,
	jlong _mask
)
{
	GtkWidget* result;
	jlong _result;
	GdkPixmap* pixmap;
	GdkBitmap* mask;

	// convert parameter pixmap
	pixmap = (GdkPixmap*) _pixmap;

	// convert parameter mask
	mask = (GdkBitmap*) _mask;

	// call function
	result = gtk_image_new_from_pixmap(pixmap, mask);

	// cleanup parameter pixmap

	// cleanup parameter mask

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1file
(
	JNIEnv* env,
	jclass cls,
	jstring _filename
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* filename;

	// convert parameter filename
	filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_image_new_from_file(filename);

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _pixbuf
)
{
	GtkWidget* result;
	jlong _result;
	GdkPixbuf* pixbuf;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	result = gtk_image_new_from_pixbuf(pixbuf);

	// cleanup parameter pixbuf

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jstring _stockId,
	jint _size
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* stockId;
	GtkIconSize size;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	result = gtk_image_new_from_stock(stockId, size);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// cleanup parameter size

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1icon_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _iconSet,
	jint _size
)
{
	GtkWidget* result;
	jlong _result;
	GtkIconSet* iconSet;
	GtkIconSize size;

	// convert parameter iconSet
	iconSet = (GtkIconSet*) _iconSet;

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	result = gtk_image_new_from_icon_set(iconSet, size);

	// cleanup parameter iconSet

	// cleanup parameter size

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1animation
(
	JNIEnv* env,
	jclass cls,
	jlong _animation
)
{
	GtkWidget* result;
	jlong _result;
	GdkPixbufAnimation* animation;

	// convert parameter animation
	animation = (GdkPixbufAnimation*) _animation;

	// call function
	result = gtk_image_new_from_animation(animation);

	// cleanup parameter animation

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1new_1from_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jstring _iconName,
	jint _size
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* iconName;
	GtkIconSize size;

	// convert parameter iconName
	iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
	if (iconName == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	result = gtk_image_new_from_icon_name(iconName, size);

	// cleanup parameter iconName
	(*env)->ReleaseStringUTFChars(env, _iconName, iconName);

	// cleanup parameter size

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1clear
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkImage* self;

	// convert parameter self
	self = (GtkImage*) _self;

	// call function
	gtk_image_clear(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1pixmap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixmap,
	jlong _mask
)
{
	GtkImage* self;
	GdkPixmap* pixmap;
	GdkBitmap* mask;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter pixmap
	pixmap = (GdkPixmap*) _pixmap;

	// convert parameter mask
	mask = (GdkBitmap*) _mask;

	// call function
	gtk_image_set_from_pixmap(self, pixmap, mask);

	// cleanup parameter self

	// cleanup parameter pixmap

	// cleanup parameter mask
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1file
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _filename
)
{
	GtkImage* self;
	const gchar* filename;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter filename
	if (_filename == NULL) {
		filename = NULL;
	} else {
		filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
		if (filename == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_image_set_from_file(self, filename);

	// cleanup parameter self

	// cleanup parameter filename
	if (filename != NULL) {
		(*env)->ReleaseStringUTFChars(env, _filename, filename);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	GtkImage* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_image_set_from_pixbuf(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId,
	jint _size
)
{
	GtkImage* self;
	const gchar* stockId;
	GtkIconSize size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	gtk_image_set_from_stock(self, stockId, size);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// cleanup parameter size
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1icon_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iconSet,
	jint _size
)
{
	GtkImage* self;
	GtkIconSet* iconSet;
	GtkIconSize size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter iconSet
	iconSet = (GtkIconSet*) _iconSet;

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	gtk_image_set_from_icon_set(self, iconSet, size);

	// cleanup parameter self

	// cleanup parameter iconSet

	// cleanup parameter size
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1animation
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _animation
)
{
	GtkImage* self;
	GdkPixbufAnimation* animation;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter animation
	animation = (GdkPixbufAnimation*) _animation;

	// call function
	gtk_image_set_from_animation(self, animation);

	// cleanup parameter self

	// cleanup parameter animation
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1storage_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkImageType result;
	jint _result;
	GtkImage* self;

	// convert parameter self
	self = (GtkImage*) _self;

	// call function
	result = gtk_image_get_storage_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1pixmap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _pixmap,
	jlongArray _mask
)
{
	GtkImage* self;
	GdkPixmap** pixmap;
	GdkBitmap** mask;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter pixmap
	pixmap = (GdkPixmap**) bindings_java_convert_jarray_to_gpointer(env, _pixmap);
	if (pixmap == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter mask
	mask = (GdkBitmap**) bindings_java_convert_jarray_to_gpointer(env, _mask);
	if (mask == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_image_get_pixmap(self, pixmap, mask);

	// cleanup parameter self

	// cleanup parameter pixmap
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)pixmap, _pixmap);

	// cleanup parameter mask
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)mask, _mask);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkImage* self;

	// convert parameter self
	self = (GtkImage*) _self;

	// call function
	result = gtk_image_get_pixbuf(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _stockId,
	jintArray _size
)
{
	GtkImage* self;
	gchar** stockId;
	GtkIconSize* size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter stockId
	stockId = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _stockId);
	if (stockId == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize*) (*env)->GetIntArrayElements(env, _size, NULL);
	if (size == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_image_get_stock(self, stockId, size);

	// cleanup parameter self

	// cleanup parameter stockId
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)stockId, _stockId);

	// cleanup parameter size
	(*env)->ReleaseIntArrayElements(env, _size, (jint*)size, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1icon_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _iconSet,
	jintArray _size
)
{
	GtkImage* self;
	GtkIconSet** iconSet;
	GtkIconSize* size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter iconSet
	iconSet = (GtkIconSet**) bindings_java_convert_jarray_to_gpointer(env, _iconSet);
	if (iconSet == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize*) (*env)->GetIntArrayElements(env, _size, NULL);
	if (size == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_image_get_icon_set(self, iconSet, size);

	// cleanup parameter self

	// cleanup parameter iconSet
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)iconSet, _iconSet);

	// cleanup parameter size
	(*env)->ReleaseIntArrayElements(env, _size, (jint*)size, 0);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1animation
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbufAnimation* result;
	jlong _result;
	GtkImage* self;

	// convert parameter self
	self = (GtkImage*) _self;

	// call function
	result = gtk_image_get_animation(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1from_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _iconName,
	jint _size
)
{
	GtkImage* self;
	const gchar* iconName;
	GtkIconSize size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter iconName
	iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
	if (iconName == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	gtk_image_set_from_icon_name(self, iconName, size);

	// cleanup parameter self

	// cleanup parameter iconName
	(*env)->ReleaseStringUTFChars(env, _iconName, iconName);

	// cleanup parameter size
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1set_1pixel_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pixelSize
)
{
	GtkImage* self;
	gint pixelSize;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter pixelSize
	pixelSize = (gint) _pixelSize;

	// call function
	gtk_image_set_pixel_size(self, pixelSize);

	// cleanup parameter self

	// cleanup parameter pixelSize
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _iconName,
	jintArray _size
)
{
	GtkImage* self;
	const gchar** iconName;
	GtkIconSize* size;

	// convert parameter self
	self = (GtkImage*) _self;

	// convert parameter iconName
	iconName = (const gchar**) bindings_java_convert_strarray_to_gchararray(env, _iconName);
	if (iconName == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize*) (*env)->GetIntArrayElements(env, _size, NULL);
	if (size == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_image_get_icon_name(self, iconName, size);

	// cleanup parameter self

	// cleanup parameter iconName
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)iconName, _iconName);

	// cleanup parameter size
	(*env)->ReleaseIntArrayElements(env, _size, (jint*)size, 0);
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkImage_gtk_1image_1get_1pixel_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkImage* self;

	// convert parameter self
	self = (GtkImage*) _self;

	// call function
	result = gtk_image_get_pixel_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
