/*
 * GtkLayout.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkLayout.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _hadjustment,
	jlong _vadjustment
)
{
	GtkWidget* result;
	jlong _result;
	GtkAdjustment* hadjustment;
	GtkAdjustment* vadjustment;

	// convert parameter hadjustment
	hadjustment = (GtkAdjustment*) _hadjustment;

	// convert parameter vadjustment
	vadjustment = (GtkAdjustment*) _vadjustment;

	// call function
	result = gtk_layout_new(hadjustment, vadjustment);

	// cleanup parameter hadjustment

	// cleanup parameter vadjustment

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1put
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _childWidget,
	jint _x,
	jint _y
)
{
	GtkLayout* self;
	GtkWidget* childWidget;
	gint x;
	gint y;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter childWidget
	childWidget = (GtkWidget*) _childWidget;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gtk_layout_put(self, childWidget, x, y);

	// cleanup parameter self

	// cleanup parameter childWidget

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1move
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _childWidget,
	jint _x,
	jint _y
)
{
	GtkLayout* self;
	GtkWidget* childWidget;
	gint x;
	gint y;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter childWidget
	childWidget = (GtkWidget*) _childWidget;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	gtk_layout_move(self, childWidget, x, y);

	// cleanup parameter self

	// cleanup parameter childWidget

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1set_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width,
	jint _height
)
{
	GtkLayout* self;
	guint width;
	guint height;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter width
	width = (guint) _width;

	// convert parameter height
	height = (guint) _height;

	// call function
	gtk_layout_set_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	GtkLayout* self;
	guint* width;
	guint* height;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter width
	width = (guint*) (*env)->GetIntArrayElements(env, _width, NULL);
	if (width == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter height
	height = (guint*) (*env)->GetIntArrayElements(env, _height, NULL);
	if (height == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_layout_get_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);

	// cleanup parameter height
	(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1get_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkLayout* self;

	// convert parameter self
	self = (GtkLayout*) _self;

	// call function
	result = gtk_layout_get_hadjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1get_1vadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkLayout* self;

	// convert parameter self
	self = (GtkLayout*) _self;

	// call function
	result = gtk_layout_get_vadjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1set_1hadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkLayout* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_layout_set_hadjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLayout_gtk_1layout_1set_1vadjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkLayout* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkLayout*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_layout_set_vadjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}
