/*
 * GtkLinkButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkLinkButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkLinkButton_gtk_1link_1button_1new_1with_1label
(
	JNIEnv* env,
	jclass cls,
	jstring _uri,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	gchar* uri;
	gchar* label;

	// convert parameter uri
	uri = (gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_link_button_new_with_label(uri, label);

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkLinkButton_gtk_1link_1button_1get_1uri
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkLinkButton* self;

	// convert parameter self
	self = (GtkLinkButton*) _self;

	// call function
	result = gtk_link_button_get_uri(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkLinkButton_gtk_1link_1button_1set_1uri
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri
)
{
	GtkLinkButton* self;
	const gchar* uri;

	// convert parameter self
	self = (GtkLinkButton*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_link_button_set_uri(self, uri);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);
}
