/*
 * GtkListStore.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkListStore.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1set_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jint _column,
	jlong _value
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	gint column;
	GValue* value;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter column
	column = (gint) _column;

	// convert parameter value
	value = (GValue*) _value;

	// call function
	gtk_list_store_set_value(self, iter, column, value);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter column

	// cleanup parameter value
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1remove
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	gboolean result;
	jboolean _result;
	GtkListStore* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	result = gtk_list_store_remove(self, iter);

	// cleanup parameter self

	// cleanup parameter iter

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1insert
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jint _position
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	gint position;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_list_store_insert(self, iter, position);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1insert_1before
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jlong _sibling
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	GtkTreeIter* sibling;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter sibling
	sibling = (GtkTreeIter*) _sibling;

	// call function
	gtk_list_store_insert_before(self, iter, sibling);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter sibling
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1insert_1after
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jlong _sibling
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	GtkTreeIter* sibling;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter sibling
	sibling = (GtkTreeIter*) _sibling;

	// call function
	gtk_list_store_insert_after(self, iter, sibling);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter sibling
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1insert_1with_1values
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jint _position
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	gint position;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_list_store_insert_with_values(self, iter, position, NULL);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1insert_1with_1valuesv
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jint _position,
	jintArray _columns,
	jlong _values,
	jint _nValues
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	gint position;
	gint* columns;
	GValue* values;
	gint nValues;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter position
	position = (gint) _position;

	// convert parameter columns
	columns = (gint*) (*env)->GetIntArrayElements(env, _columns, NULL);
	if (columns == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter values
	values = (GValue*) _values;

	// convert parameter nValues
	nValues = (gint) _nValues;

	// call function
	gtk_list_store_insert_with_valuesv(self, iter, position, columns, values, nValues);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter position

	// cleanup parameter columns
	(*env)->ReleaseIntArrayElements(env, _columns, (jint*)columns, 0);

	// cleanup parameter values

	// cleanup parameter nValues
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1prepend
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	GtkListStore* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	gtk_list_store_prepend(self, iter);

	// cleanup parameter self

	// cleanup parameter iter
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1append
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	GtkListStore* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	gtk_list_store_append(self, iter);

	// cleanup parameter self

	// cleanup parameter iter
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1clear
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkListStore* self;

	// convert parameter self
	self = (GtkListStore*) _self;

	// call function
	gtk_list_store_clear(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1iter_1is_1valid
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	gboolean result;
	jboolean _result;
	GtkListStore* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	result = gtk_list_store_iter_is_valid(self, iter);

	// cleanup parameter self

	// cleanup parameter iter

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1reorder
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _newOrder
)
{
	GtkListStore* self;
	gint* newOrder;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter newOrder
	newOrder = (gint*) (*env)->GetIntArrayElements(env, _newOrder, NULL);
	if (newOrder == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_list_store_reorder(self, newOrder);

	// cleanup parameter self

	// cleanup parameter newOrder
	(*env)->ReleaseIntArrayElements(env, _newOrder, (jint*)newOrder, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1swap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _a,
	jlong _b
)
{
	GtkListStore* self;
	GtkTreeIter* a;
	GtkTreeIter* b;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter a
	a = (GtkTreeIter*) _a;

	// convert parameter b
	b = (GtkTreeIter*) _b;

	// call function
	gtk_list_store_swap(self, a, b);

	// cleanup parameter self

	// cleanup parameter a

	// cleanup parameter b
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1move_1after
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jlong _position
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	GtkTreeIter* position;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter position
	position = (GtkTreeIter*) _position;

	// call function
	gtk_list_store_move_after(self, iter, position);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkListStore_gtk_1list_1store_1move_1before
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jlong _position
)
{
	GtkListStore* self;
	GtkTreeIter* iter;
	GtkTreeIter* position;

	// convert parameter self
	self = (GtkListStore*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// convert parameter position
	position = (GtkTreeIter*) _position;

	// call function
	gtk_list_store_move_before(self, iter, position);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter position
}
