/*
 * GtkMenu.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkMenu.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_menu_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1reposition
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	gtk_menu_reposition(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1popdown
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	gtk_menu_popdown(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1get_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	result = gtk_menu_get_active(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index
)
{
	GtkMenu* self;
	guint index;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter index
	index = (guint) _index;

	// call function
	gtk_menu_set_active(self, index);

	// cleanup parameter self

	// cleanup parameter index
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1accel_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _accelGroup
)
{
	GtkMenu* self;
	GtkAccelGroup* accelGroup;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter accelGroup
	accelGroup = (GtkAccelGroup*) _accelGroup;

	// call function
	gtk_menu_set_accel_group(self, accelGroup);

	// cleanup parameter self

	// cleanup parameter accelGroup
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1get_1accel_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAccelGroup* result;
	jlong _result;
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	result = gtk_menu_get_accel_group(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1accel_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _accelPath
)
{
	GtkMenu* self;
	const gchar* accelPath;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter accelPath
	if (_accelPath == NULL) {
		accelPath = NULL;
	} else {
		accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
		if (accelPath == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_menu_set_accel_path(self, accelPath);

	// cleanup parameter self

	// cleanup parameter accelPath
	if (accelPath != NULL) {
		(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1detach
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	gtk_menu_detach(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1get_1attach_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	result = gtk_menu_get_attach_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1tearoff_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _tornOff
)
{
	GtkMenu* self;
	gboolean tornOff;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter tornOff
	tornOff = (gboolean) _tornOff;

	// call function
	gtk_menu_set_tearoff_state(self, tornOff);

	// cleanup parameter self

	// cleanup parameter tornOff
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1get_1tearoff_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	result = gtk_menu_get_tearoff_state(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _title
)
{
	GtkMenu* self;
	const gchar* title;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_menu_set_title(self, title);

	// cleanup parameter self

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkMenu* self;

	// convert parameter self
	self = (GtkMenu*) _self;

	// call function
	result = gtk_menu_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1reorder_1child
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _position
)
{
	GtkMenu* self;
	GtkWidget* child;
	gint position;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_menu_reorder_child(self, child, position);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter position
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _screen
)
{
	GtkMenu* self;
	GdkScreen* screen;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter screen
	screen = (GdkScreen*) _screen;

	// call function
	gtk_menu_set_screen(self, screen);

	// cleanup parameter self

	// cleanup parameter screen
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1attach
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _leftAttach,
	jint _rightAttach,
	jint _topAttach,
	jint _bottomAttach
)
{
	GtkMenu* self;
	GtkWidget* child;
	guint leftAttach;
	guint rightAttach;
	guint topAttach;
	guint bottomAttach;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter leftAttach
	leftAttach = (guint) _leftAttach;

	// convert parameter rightAttach
	rightAttach = (guint) _rightAttach;

	// convert parameter topAttach
	topAttach = (guint) _topAttach;

	// convert parameter bottomAttach
	bottomAttach = (guint) _bottomAttach;

	// call function
	gtk_menu_attach(self, child, leftAttach, rightAttach, topAttach, bottomAttach);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter leftAttach

	// cleanup parameter rightAttach

	// cleanup parameter topAttach

	// cleanup parameter bottomAttach
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenu_gtk_1menu_1set_1monitor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _monitorNum
)
{
	GtkMenu* self;
	gint monitorNum;

	// convert parameter self
	self = (GtkMenu*) _self;

	// convert parameter monitorNum
	monitorNum = (gint) _monitorNum;

	// call function
	gtk_menu_set_monitor(self, monitorNum);

	// cleanup parameter self

	// cleanup parameter monitorNum
}
