/*
 * GtkMenuItem.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkMenuItem.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_menu_item_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1new_1with_1label
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_menu_item_new_with_label(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1new_1with_1mnemonic
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_menu_item_new_with_mnemonic(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1set_1submenu
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _submenu
)
{
	GtkMenuItem* self;
	GtkWidget* submenu;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// convert parameter submenu
	submenu = (GtkWidget*) _submenu;

	// call function
	gtk_menu_item_set_submenu(self, submenu);

	// cleanup parameter self

	// cleanup parameter submenu
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1get_1submenu
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkMenuItem* self;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// call function
	result = gtk_menu_item_get_submenu(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1select
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenuItem* self;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// call function
	gtk_menu_item_select(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1deselect
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenuItem* self;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// call function
	gtk_menu_item_deselect(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1activate
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMenuItem* self;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// call function
	gtk_menu_item_activate(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1toggle_1size_1request
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _requisition
)
{
	GtkMenuItem* self;
	gint* requisition;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// convert parameter requisition
	requisition = (gint*) (*env)->GetIntArrayElements(env, _requisition, NULL);
	if (requisition == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_menu_item_toggle_size_request(self, requisition);

	// cleanup parameter self

	// cleanup parameter requisition
	(*env)->ReleaseIntArrayElements(env, _requisition, (jint*)requisition, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1toggle_1size_1allocate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _allocation
)
{
	GtkMenuItem* self;
	gint allocation;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// convert parameter allocation
	allocation = (gint) _allocation;

	// call function
	gtk_menu_item_toggle_size_allocate(self, allocation);

	// cleanup parameter self

	// cleanup parameter allocation
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1set_1right_1justified
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _rightJustified
)
{
	GtkMenuItem* self;
	gboolean rightJustified;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// convert parameter rightJustified
	rightJustified = (gboolean) _rightJustified;

	// call function
	gtk_menu_item_set_right_justified(self, rightJustified);

	// cleanup parameter self

	// cleanup parameter rightJustified
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1get_1right_1justified
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkMenuItem* self;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// call function
	result = gtk_menu_item_get_right_justified(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuItem_gtk_1menu_1item_1set_1accel_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _accelPath
)
{
	GtkMenuItem* self;
	const gchar* accelPath;

	// convert parameter self
	self = (GtkMenuItem*) _self;

	// convert parameter accelPath
	if (_accelPath == NULL) {
		accelPath = NULL;
	} else {
		accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
		if (accelPath == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_menu_item_set_accel_path(self, accelPath);

	// cleanup parameter self

	// cleanup parameter accelPath
	if (accelPath != NULL) {
		(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
	}
}
