/*
 * GtkMenuToolButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkMenuToolButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuToolButton_gtk_1menu_1tool_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _iconWidget,
	jstring _label
)
{
	GtkToolItem* result;
	jlong _result;
	GtkWidget* iconWidget;
	const gchar* label;

	// convert parameter iconWidget
	iconWidget = (GtkWidget*) _iconWidget;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_menu_tool_button_new(iconWidget, label);

	// cleanup parameter iconWidget

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuToolButton_gtk_1menu_1tool_1button_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jstring _stockId
)
{
	GtkToolItem* result;
	jlong _result;
	const gchar* stockId;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_menu_tool_button_new_from_stock(stockId);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMenuToolButton_gtk_1menu_1tool_1button_1set_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _menu
)
{
	GtkMenuToolButton* self;
	GtkWidget* menu;

	// convert parameter self
	self = (GtkMenuToolButton*) _self;

	// convert parameter menu
	menu = (GtkWidget*) _menu;

	// call function
	gtk_menu_tool_button_set_menu(self, menu);

	// cleanup parameter self

	// cleanup parameter menu
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMenuToolButton_gtk_1menu_1tool_1button_1get_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkMenuToolButton* self;

	// convert parameter self
	self = (GtkMenuToolButton*) _self;

	// call function
	result = gtk_menu_tool_button_get_menu(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
