/*
 * GtkMessageDialog.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkMessageDialog.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _parent,
	jint _flags,
	jint _type,
	jint _buttons,
	jstring _messageFormat
)
{
	GtkWidget* result;
	jlong _result;
	GtkWindow* parent;
	GtkDialogFlags flags;
	GtkMessageType type;
	GtkButtonsType buttons;
	const gchar* messageFormat;

	// convert parameter parent
	parent = (GtkWindow*) _parent;

	// convert parameter flags
	flags = (GtkDialogFlags) _flags;

	// convert parameter type
	type = (GtkMessageType) _type;

	// convert parameter buttons
	buttons = (GtkButtonsType) _buttons;

	// convert parameter messageFormat
	if (_messageFormat == NULL) {
		messageFormat = NULL;
	} else {
		messageFormat = (const gchar*) (*env)->GetStringUTFChars(env, _messageFormat, NULL);
		if (messageFormat == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_message_dialog_new(parent, flags, type, buttons, messageFormat, NULL);

	// cleanup parameter parent

	// cleanup parameter flags

	// cleanup parameter type

	// cleanup parameter buttons

	// cleanup parameter messageFormat
	if (messageFormat != NULL) {
		(*env)->ReleaseStringUTFChars(env, _messageFormat, messageFormat);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1new_1with_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _parent,
	jint _flags,
	jint _type,
	jint _buttons,
	jstring _messageFormat
)
{
	GtkWidget* result;
	jlong _result;
	GtkWindow* parent;
	GtkDialogFlags flags;
	GtkMessageType type;
	GtkButtonsType buttons;
	const gchar* messageFormat;

	// convert parameter parent
	parent = (GtkWindow*) _parent;

	// convert parameter flags
	flags = (GtkDialogFlags) _flags;

	// convert parameter type
	type = (GtkMessageType) _type;

	// convert parameter buttons
	buttons = (GtkButtonsType) _buttons;

	// convert parameter messageFormat
	messageFormat = (const gchar*) (*env)->GetStringUTFChars(env, _messageFormat, NULL);
	if (messageFormat == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_message_dialog_new_with_markup(parent, flags, type, buttons, messageFormat, NULL);

	// cleanup parameter parent

	// cleanup parameter flags

	// cleanup parameter type

	// cleanup parameter buttons

	// cleanup parameter messageFormat
	(*env)->ReleaseStringUTFChars(env, _messageFormat, messageFormat);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1set_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _str
)
{
	GtkMessageDialog* self;
	const gchar* str;

	// convert parameter self
	self = (GtkMessageDialog*) _self;

	// convert parameter str
	str = (const gchar*) (*env)->GetStringUTFChars(env, _str, NULL);
	if (str == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_message_dialog_set_markup(self, str);

	// cleanup parameter self

	// cleanup parameter str
	(*env)->ReleaseStringUTFChars(env, _str, str);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1format_1secondary_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _messageFormat
)
{
	GtkMessageDialog* self;
	const gchar* messageFormat;

	// convert parameter self
	self = (GtkMessageDialog*) _self;

	// convert parameter messageFormat
	messageFormat = (const gchar*) (*env)->GetStringUTFChars(env, _messageFormat, NULL);
	if (messageFormat == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_message_dialog_format_secondary_text(self, messageFormat, NULL);

	// cleanup parameter self

	// cleanup parameter messageFormat
	(*env)->ReleaseStringUTFChars(env, _messageFormat, messageFormat);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1format_1secondary_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _messageFormat
)
{
	GtkMessageDialog* self;
	const gchar* messageFormat;

	// convert parameter self
	self = (GtkMessageDialog*) _self;

	// convert parameter messageFormat
	messageFormat = (const gchar*) (*env)->GetStringUTFChars(env, _messageFormat, NULL);
	if (messageFormat == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_message_dialog_format_secondary_markup(self, messageFormat, NULL);

	// cleanup parameter self

	// cleanup parameter messageFormat
	(*env)->ReleaseStringUTFChars(env, _messageFormat, messageFormat);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkMessageDialog_gtk_1message_1dialog_1set_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _image
)
{
	GtkMessageDialog* self;
	GtkWidget* image;

	// convert parameter self
	self = (GtkMessageDialog*) _self;

	// convert parameter image
	image = (GtkWidget*) _image;

	// call function
	gtk_message_dialog_set_image(self, image);

	// cleanup parameter self

	// cleanup parameter image
}
