/*
 * GtkNotebook.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkNotebook.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_notebook_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1append_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// call function
	result = gtk_notebook_append_page(self, child, tabLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1append_1page_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel,
	jlong _menuLabel
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;
	GtkWidget* menuLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// convert parameter menuLabel
	menuLabel = (GtkWidget*) _menuLabel;

	// call function
	result = gtk_notebook_append_page_menu(self, child, tabLabel, menuLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// cleanup parameter menuLabel

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1prepend_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// call function
	result = gtk_notebook_prepend_page(self, child, tabLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1prepend_1page_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel,
	jlong _menuLabel
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;
	GtkWidget* menuLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// convert parameter menuLabel
	menuLabel = (GtkWidget*) _menuLabel;

	// call function
	result = gtk_notebook_prepend_page_menu(self, child, tabLabel, menuLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// cleanup parameter menuLabel

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1insert_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel,
	jint _position
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;
	gint position;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// convert parameter position
	position = (gint) _position;

	// call function
	result = gtk_notebook_insert_page(self, child, tabLabel, position);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// cleanup parameter position

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1insert_1page_1menu
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel,
	jlong _menuLabel,
	jint _position
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;
	GtkWidget* menuLabel;
	gint position;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// convert parameter menuLabel
	menuLabel = (GtkWidget*) _menuLabel;

	// convert parameter position
	position = (gint) _position;

	// call function
	result = gtk_notebook_insert_page_menu(self, child, tabLabel, menuLabel, position);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel

	// cleanup parameter menuLabel

	// cleanup parameter position

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1remove_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageNum
)
{
	GtkNotebook* self;
	gint pageNum;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter pageNum
	pageNum = (gint) _pageNum;

	// call function
	gtk_notebook_remove_page(self, pageNum);

	// cleanup parameter self

	// cleanup parameter pageNum
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1current_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_current_page(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1nth_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageNum
)
{
	GtkWidget* result;
	jlong _result;
	GtkNotebook* self;
	gint pageNum;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter pageNum
	pageNum = (gint) _pageNum;

	// call function
	result = gtk_notebook_get_nth_page(self, pageNum);

	// cleanup parameter self

	// cleanup parameter pageNum

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1n_1pages
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_n_pages(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1page_1num
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	gint result;
	jint _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_page_num(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1current_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageNum
)
{
	GtkNotebook* self;
	gint pageNum;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter pageNum
	pageNum = (gint) _pageNum;

	// call function
	gtk_notebook_set_current_page(self, pageNum);

	// cleanup parameter self

	// cleanup parameter pageNum
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1next_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	gtk_notebook_next_page(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1prev_1page
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	gtk_notebook_prev_page(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1show_1border
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showBorder
)
{
	GtkNotebook* self;
	gboolean showBorder;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter showBorder
	showBorder = (gboolean) _showBorder;

	// call function
	gtk_notebook_set_show_border(self, showBorder);

	// cleanup parameter self

	// cleanup parameter showBorder
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1show_1border
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_show_border(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1show_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showTabs
)
{
	GtkNotebook* self;
	gboolean showTabs;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter showTabs
	showTabs = (gboolean) _showTabs;

	// call function
	gtk_notebook_set_show_tabs(self, showTabs);

	// cleanup parameter self

	// cleanup parameter showTabs
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1show_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_show_tabs(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1pos
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pos
)
{
	GtkNotebook* self;
	GtkPositionType pos;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter pos
	pos = (GtkPositionType) _pos;

	// call function
	gtk_notebook_set_tab_pos(self, pos);

	// cleanup parameter self

	// cleanup parameter pos
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1tab_1pos
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPositionType result;
	jint _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_tab_pos(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1scrollable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _scrollable
)
{
	GtkNotebook* self;
	gboolean scrollable;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter scrollable
	scrollable = (gboolean) _scrollable;

	// call function
	gtk_notebook_set_scrollable(self, scrollable);

	// cleanup parameter self

	// cleanup parameter scrollable
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1scrollable
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	result = gtk_notebook_get_scrollable(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1popup_1enable
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	gtk_notebook_popup_enable(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1popup_1disable
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkNotebook* self;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// call function
	gtk_notebook_popup_disable(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1tab_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkWidget* result;
	jlong _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_tab_label(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _tabLabel
)
{
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* tabLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabLabel
	tabLabel = (GtkWidget*) _tabLabel;

	// call function
	gtk_notebook_set_tab_label(self, child, tabLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabLabel
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1label_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _tabText
)
{
	GtkNotebook* self;
	GtkWidget* child;
	const gchar* tabText;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter tabText
	tabText = (const gchar*) (*env)->GetStringUTFChars(env, _tabText, NULL);
	if (tabText == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_notebook_set_tab_label_text(self, child, tabText);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter tabText
	(*env)->ReleaseStringUTFChars(env, _tabText, tabText);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1tab_1label_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	const gchar* result;
	jstring _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_tab_label_text(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1menu_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkWidget* result;
	jlong _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_menu_label(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1menu_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jlong _menuLabel
)
{
	GtkNotebook* self;
	GtkWidget* child;
	GtkWidget* menuLabel;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter menuLabel
	menuLabel = (GtkWidget*) _menuLabel;

	// call function
	gtk_notebook_set_menu_label(self, child, menuLabel);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter menuLabel
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1menu_1label_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jstring _menuText
)
{
	GtkNotebook* self;
	GtkWidget* child;
	const gchar* menuText;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter menuText
	menuText = (const gchar*) (*env)->GetStringUTFChars(env, _menuText, NULL);
	if (menuText == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_notebook_set_menu_label_text(self, child, menuText);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter menuText
	(*env)->ReleaseStringUTFChars(env, _menuText, menuText);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1menu_1label_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	const gchar* result;
	jstring _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_menu_label_text(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1query_1tab_1label_1packing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jbooleanArray _expand,
	jbooleanArray _fill,
	jintArray _packType
)
{
	GtkNotebook* self;
	GtkWidget* child;
	gboolean* expand;
	gboolean* fill;
	GtkPackType* packType;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean*) (*env)->GetBooleanArrayElements(env, _expand, NULL);
	if (expand == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter fill
	fill = (gboolean*) (*env)->GetBooleanArrayElements(env, _fill, NULL);
	if (fill == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter packType
	packType = (GtkPackType*) (*env)->GetIntArrayElements(env, _packType, NULL);
	if (packType == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_notebook_query_tab_label_packing(self, child, expand, fill, packType);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand
	(*env)->ReleaseBooleanArrayElements(env, _expand, (jboolean*)expand, 0);

	// cleanup parameter fill
	(*env)->ReleaseBooleanArrayElements(env, _fill, (jboolean*)fill, 0);

	// cleanup parameter packType
	(*env)->ReleaseIntArrayElements(env, _packType, (jint*)packType, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1label_1packing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _expand,
	jboolean _fill,
	jint _packType
)
{
	GtkNotebook* self;
	GtkWidget* child;
	gboolean expand;
	gboolean fill;
	GtkPackType packType;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter expand
	expand = (gboolean) _expand;

	// convert parameter fill
	fill = (gboolean) _fill;

	// convert parameter packType
	packType = (GtkPackType) _packType;

	// call function
	gtk_notebook_set_tab_label_packing(self, child, expand, fill, packType);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter expand

	// cleanup parameter fill

	// cleanup parameter packType
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1reorder_1child
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _position
)
{
	GtkNotebook* self;
	GtkWidget* child;
	gint position;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_notebook_reorder_child(self, child, position);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter position
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1tab_1reorderable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	gboolean result;
	jboolean _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_tab_reorderable(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1reorderable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _reorderable
)
{
	GtkNotebook* self;
	GtkWidget* child;
	gboolean reorderable;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter reorderable
	reorderable = (gboolean) _reorderable;

	// call function
	gtk_notebook_set_tab_reorderable(self, child, reorderable);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter reorderable
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1get_1tab_1detachable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	gboolean result;
	jboolean _result;
	GtkNotebook* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	result = gtk_notebook_get_tab_detachable(self, child);

	// cleanup parameter self

	// cleanup parameter child

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkNotebook_gtk_1notebook_1set_1tab_1detachable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _detachable
)
{
	GtkNotebook* self;
	GtkWidget* child;
	gboolean detachable;

	// convert parameter self
	self = (GtkNotebook*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter detachable
	detachable = (gboolean) _detachable;

	// call function
	gtk_notebook_set_tab_detachable(self, child, detachable);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter detachable
}
