/*
 * GtkPaned.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkPaned.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1add1
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkPaned* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkPaned*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	gtk_paned_add1(self, child);

	// cleanup parameter self

	// cleanup parameter child
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1add2
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child
)
{
	GtkPaned* self;
	GtkWidget* child;

	// convert parameter self
	self = (GtkPaned*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// call function
	gtk_paned_add2(self, child);

	// cleanup parameter self

	// cleanup parameter child
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1pack1
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _resize,
	jboolean _shrink
)
{
	GtkPaned* self;
	GtkWidget* child;
	gboolean resize;
	gboolean shrink;

	// convert parameter self
	self = (GtkPaned*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter resize
	resize = (gboolean) _resize;

	// convert parameter shrink
	shrink = (gboolean) _shrink;

	// call function
	gtk_paned_pack1(self, child, resize, shrink);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter resize

	// cleanup parameter shrink
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1pack2
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jboolean _resize,
	jboolean _shrink
)
{
	GtkPaned* self;
	GtkWidget* child;
	gboolean resize;
	gboolean shrink;

	// convert parameter self
	self = (GtkPaned*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter resize
	resize = (gboolean) _resize;

	// convert parameter shrink
	shrink = (gboolean) _shrink;

	// call function
	gtk_paned_pack2(self, child, resize, shrink);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter resize

	// cleanup parameter shrink
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1get_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkPaned* self;

	// convert parameter self
	self = (GtkPaned*) _self;

	// call function
	result = gtk_paned_get_position(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1set_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _position
)
{
	GtkPaned* self;
	gint position;

	// convert parameter self
	self = (GtkPaned*) _self;

	// convert parameter position
	position = (gint) _position;

	// call function
	gtk_paned_set_position(self, position);

	// cleanup parameter self

	// cleanup parameter position
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1get_1child1
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkPaned* self;

	// convert parameter self
	self = (GtkPaned*) _self;

	// call function
	result = gtk_paned_get_child1(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPaned_gtk_1paned_1get_1child2
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkPaned* self;

	// convert parameter self
	self = (GtkPaned*) _self;

	// call function
	result = gtk_paned_get_child2(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
