/*
 * GtkPlug.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkPlug.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPlug_gtk_1plug_1construct
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _socketId
)
{
	GtkPlug* self;
	GdkNativeWindow socketId;

	// convert parameter self
	self = (GtkPlug*) _self;

	// convert parameter socketId
	socketId = (GdkNativeWindow) _socketId;

	// call function
	gtk_plug_construct(self, socketId);

	// cleanup parameter self

	// cleanup parameter socketId
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPlug_gtk_1plug_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _socketId
)
{
	GtkWidget* result;
	jlong _result;
	GdkNativeWindow socketId;

	// convert parameter socketId
	socketId = (GdkNativeWindow) _socketId;

	// call function
	result = gtk_plug_new(socketId);

	// cleanup parameter socketId

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPlug_gtk_1plug_1construct_1for_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _display,
	jlong _socketId
)
{
	GtkPlug* self;
	GdkDisplay* display;
	GdkNativeWindow socketId;

	// convert parameter self
	self = (GtkPlug*) _self;

	// convert parameter display
	display = (GdkDisplay*) _display;

	// convert parameter socketId
	socketId = (GdkNativeWindow) _socketId;

	// call function
	gtk_plug_construct_for_display(self, display, socketId);

	// cleanup parameter self

	// cleanup parameter display

	// cleanup parameter socketId
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPlug_gtk_1plug_1get_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkNativeWindow result;
	jlong _result;
	GtkPlug* self;

	// convert parameter self
	self = (GtkPlug*) _self;

	// call function
	result = gtk_plug_get_id(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}
