/*
 * GtkPrintSettings.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkPrintSettings.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkPrintSettings* result;
	jlong _result;

	// call function
	result = gtk_print_settings_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintSettings* result;
	jlong _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1has_1key
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	gboolean result;
	jboolean _result;
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_print_settings_has_key(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = gtk_print_settings_get(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jstring _value
)
{
	GtkPrintSettings* self;
	const gchar* key;
	const gchar* value;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	if (_value == NULL) {
		value = NULL;
	} else {
		value = (const gchar*) (*env)->GetStringUTFChars(env, _value, NULL);
		if (value == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_print_settings_set(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
	if (value != NULL) {
		(*env)->ReleaseStringUTFChars(env, _value, value);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1unset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_unset(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1bool
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	gboolean result;
	jboolean _result;
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_print_settings_get_bool(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1bool
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jboolean _value
)
{
	GtkPrintSettings* self;
	const gchar* key;
	gboolean value;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gboolean) _value;

	// call function
	gtk_print_settings_set_bool(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1double
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  0L; // Java Exception already thrown
	}

	// call function
	result = gtk_print_settings_get_double(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1double_1with_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jdouble _def
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;
	const gchar* key;
	gdouble def;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  0L; // Java Exception already thrown
	}

	// convert parameter def
	def = (gdouble) _def;

	// call function
	result = gtk_print_settings_get_double_with_default(self, key, def);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter def

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1double
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jdouble _value
)
{
	GtkPrintSettings* self;
	const gchar* key;
	gdouble value;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_print_settings_set_double(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jint _unit
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;
	const gchar* key;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  0L; // Java Exception already thrown
	}

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	result = gtk_print_settings_get_length(self, key, unit);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter unit

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1length
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jdouble _value,
	jint _unit
)
{
	GtkPrintSettings* self;
	const gchar* key;
	gdouble value;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gdouble) _value;

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	gtk_print_settings_set_length(self, key, value, unit);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value

	// cleanup parameter unit
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1int
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key
)
{
	gint result;
	jint _result;
	GtkPrintSettings* self;
	const gchar* key;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gtk_print_settings_get_int(self, key);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1int_1with_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jint _def
)
{
	gint result;
	jint _result;
	GtkPrintSettings* self;
	const gchar* key;
	gint def;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return  0; // Java Exception already thrown
	}

	// convert parameter def
	def = (gint) _def;

	// call function
	result = gtk_print_settings_get_int_with_default(self, key, def);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter def

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1int
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jint _value
)
{
	GtkPrintSettings* self;
	const gchar* key;
	gint value;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gint) _value;

	// call function
	gtk_print_settings_set_int(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1printer
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_printer(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1printer
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _printer
)
{
	GtkPrintSettings* self;
	const gchar* printer;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter printer
	printer = (const gchar*) (*env)->GetStringUTFChars(env, _printer, NULL);
	if (printer == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_printer(self, printer);

	// cleanup parameter self

	// cleanup parameter printer
	(*env)->ReleaseStringUTFChars(env, _printer, printer);
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPageOrientation result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_orientation(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _orientation
)
{
	GtkPrintSettings* self;
	GtkPageOrientation orientation;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter orientation
	orientation = (GtkPageOrientation) _orientation;

	// call function
	gtk_print_settings_set_orientation(self, orientation);

	// cleanup parameter self

	// cleanup parameter orientation
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1paper_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPaperSize* result;
	jlong _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_paper_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1paper_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _paperSize
)
{
	GtkPrintSettings* self;
	GtkPaperSize* paperSize;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter paperSize
	paperSize = (GtkPaperSize*) _paperSize;

	// call function
	gtk_print_settings_set_paper_size(self, paperSize);

	// cleanup parameter self

	// cleanup parameter paperSize
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1paper_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _unit
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	result = gtk_print_settings_get_paper_width(self, unit);

	// cleanup parameter self

	// cleanup parameter unit

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1paper_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _width,
	jint _unit
)
{
	GtkPrintSettings* self;
	gdouble width;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter width
	width = (gdouble) _width;

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	gtk_print_settings_set_paper_width(self, width, unit);

	// cleanup parameter self

	// cleanup parameter width

	// cleanup parameter unit
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1paper_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _unit
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	result = gtk_print_settings_get_paper_height(self, unit);

	// cleanup parameter self

	// cleanup parameter unit

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1paper_1height
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _height,
	jint _unit
)
{
	GtkPrintSettings* self;
	gdouble height;
	GtkUnit unit;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter height
	height = (gdouble) _height;

	// convert parameter unit
	unit = (GtkUnit) _unit;

	// call function
	gtk_print_settings_set_paper_height(self, height, unit);

	// cleanup parameter self

	// cleanup parameter height

	// cleanup parameter unit
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1use_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_use_color(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1use_1color
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useColor
)
{
	GtkPrintSettings* self;
	gboolean useColor;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter useColor
	useColor = (gboolean) _useColor;

	// call function
	gtk_print_settings_set_use_color(self, useColor);

	// cleanup parameter self

	// cleanup parameter useColor
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1collate
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_collate(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1collate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _collate
)
{
	GtkPrintSettings* self;
	gboolean collate;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter collate
	collate = (gboolean) _collate;

	// call function
	gtk_print_settings_set_collate(self, collate);

	// cleanup parameter self

	// cleanup parameter collate
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1reverse
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_reverse(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1reverse
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _reverse
)
{
	GtkPrintSettings* self;
	gboolean reverse;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter reverse
	reverse = (gboolean) _reverse;

	// call function
	gtk_print_settings_set_reverse(self, reverse);

	// cleanup parameter self

	// cleanup parameter reverse
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1duplex
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintDuplex result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_duplex(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1duplex
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _duplex
)
{
	GtkPrintSettings* self;
	GtkPrintDuplex duplex;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter duplex
	duplex = (GtkPrintDuplex) _duplex;

	// call function
	gtk_print_settings_set_duplex(self, duplex);

	// cleanup parameter self

	// cleanup parameter duplex
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1quality
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintQuality result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_quality(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1quality
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _quality
)
{
	GtkPrintSettings* self;
	GtkPrintQuality quality;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter quality
	quality = (GtkPrintQuality) _quality;

	// call function
	gtk_print_settings_set_quality(self, quality);

	// cleanup parameter self

	// cleanup parameter quality
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1n_1copies
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_n_copies(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1n_1copies
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _numCopies
)
{
	GtkPrintSettings* self;
	gint numCopies;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter numCopies
	numCopies = (gint) _numCopies;

	// call function
	gtk_print_settings_set_n_copies(self, numCopies);

	// cleanup parameter self

	// cleanup parameter numCopies
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1number_1up
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_number_up(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1number_1up
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _numberUp
)
{
	GtkPrintSettings* self;
	gint numberUp;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter numberUp
	numberUp = (gint) _numberUp;

	// call function
	gtk_print_settings_set_number_up(self, numberUp);

	// cleanup parameter self

	// cleanup parameter numberUp
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1resolution
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_resolution(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1resolution
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _resolution
)
{
	GtkPrintSettings* self;
	gint resolution;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter resolution
	resolution = (gint) _resolution;

	// call function
	gtk_print_settings_set_resolution(self, resolution);

	// cleanup parameter self

	// cleanup parameter resolution
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1scale
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_scale(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1scale
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _scale
)
{
	GtkPrintSettings* self;
	gdouble scale;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter scale
	scale = (gdouble) _scale;

	// call function
	gtk_print_settings_set_scale(self, scale);

	// cleanup parameter self

	// cleanup parameter scale
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1print_1pages
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintPages result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_print_pages(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1print_1pages
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pages
)
{
	GtkPrintSettings* self;
	GtkPrintPages pages;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter pages
	pages = (GtkPrintPages) _pages;

	// call function
	gtk_print_settings_set_print_pages(self, pages);

	// cleanup parameter self

	// cleanup parameter pages
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1page_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPageSet result;
	jint _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_page_set(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1page_1set
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pageSet
)
{
	GtkPrintSettings* self;
	GtkPageSet pageSet;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter pageSet
	pageSet = (GtkPageSet) _pageSet;

	// call function
	gtk_print_settings_set_page_set(self, pageSet);

	// cleanup parameter self

	// cleanup parameter pageSet
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1default_1source
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_default_source(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1default_1source
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _defaultSource
)
{
	GtkPrintSettings* self;
	const gchar* defaultSource;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter defaultSource
	defaultSource = (const gchar*) (*env)->GetStringUTFChars(env, _defaultSource, NULL);
	if (defaultSource == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_default_source(self, defaultSource);

	// cleanup parameter self

	// cleanup parameter defaultSource
	(*env)->ReleaseStringUTFChars(env, _defaultSource, defaultSource);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1media_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_media_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1media_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _mediaType
)
{
	GtkPrintSettings* self;
	const gchar* mediaType;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter mediaType
	mediaType = (const gchar*) (*env)->GetStringUTFChars(env, _mediaType, NULL);
	if (mediaType == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_media_type(self, mediaType);

	// cleanup parameter self

	// cleanup parameter mediaType
	(*env)->ReleaseStringUTFChars(env, _mediaType, mediaType);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1dither
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_dither(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1dither
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _dither
)
{
	GtkPrintSettings* self;
	const gchar* dither;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter dither
	dither = (const gchar*) (*env)->GetStringUTFChars(env, _dither, NULL);
	if (dither == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_dither(self, dither);

	// cleanup parameter self

	// cleanup parameter dither
	(*env)->ReleaseStringUTFChars(env, _dither, dither);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1finishings
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_finishings(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1finishings
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _finishings
)
{
	GtkPrintSettings* self;
	const gchar* finishings;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter finishings
	finishings = (const gchar*) (*env)->GetStringUTFChars(env, _finishings, NULL);
	if (finishings == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_finishings(self, finishings);

	// cleanup parameter self

	// cleanup parameter finishings
	(*env)->ReleaseStringUTFChars(env, _finishings, finishings);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1get_1output_1bin
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintSettings* self;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// call function
	result = gtk_print_settings_get_output_bin(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkPrintSettings_gtk_1print_1settings_1set_1output_1bin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _outputBin
)
{
	GtkPrintSettings* self;
	const gchar* outputBin;

	// convert parameter self
	self = (GtkPrintSettings*) _self;

	// convert parameter outputBin
	outputBin = (const gchar*) (*env)->GetStringUTFChars(env, _outputBin, NULL);
	if (outputBin == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_print_settings_set_output_bin(self, outputBin);

	// cleanup parameter self

	// cleanup parameter outputBin
	(*env)->ReleaseStringUTFChars(env, _outputBin, outputBin);
}
