/*
 * GtkProgressBar.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkProgressBar.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_progress_bar_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1pulse
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	gtk_progress_bar_pulse(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkProgressBar* self;
	const gchar* text;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_progress_bar_set_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1set_1fraction
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _fraction
)
{
	GtkProgressBar* self;
	gdouble fraction;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// convert parameter fraction
	fraction = (gdouble) _fraction;

	// call function
	gtk_progress_bar_set_fraction(self, fraction);

	// cleanup parameter self

	// cleanup parameter fraction
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1set_1pulse_1step
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _fraction
)
{
	GtkProgressBar* self;
	gdouble fraction;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// convert parameter fraction
	fraction = (gdouble) _fraction;

	// call function
	gtk_progress_bar_set_pulse_step(self, fraction);

	// cleanup parameter self

	// cleanup parameter fraction
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1set_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _orientation
)
{
	GtkProgressBar* self;
	GtkProgressBarOrientation orientation;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// convert parameter orientation
	orientation = (GtkProgressBarOrientation) _orientation;

	// call function
	gtk_progress_bar_set_orientation(self, orientation);

	// cleanup parameter self

	// cleanup parameter orientation
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1get_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	result = gtk_progress_bar_get_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1get_1fraction
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	result = gtk_progress_bar_get_fraction(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1get_1pulse_1step
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	result = gtk_progress_bar_get_pulse_step(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1get_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkProgressBarOrientation result;
	jint _result;
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	result = gtk_progress_bar_get_orientation(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1set_1ellipsize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _mode
)
{
	GtkProgressBar* self;
	PangoEllipsizeMode mode;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// convert parameter mode
	mode = (PangoEllipsizeMode) _mode;

	// call function
	gtk_progress_bar_set_ellipsize(self, mode);

	// cleanup parameter self

	// cleanup parameter mode
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkProgressBar_gtk_1progress_1bar_1get_1ellipsize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoEllipsizeMode result;
	jint _result;
	GtkProgressBar* self;

	// convert parameter self
	self = (GtkProgressBar*) _self;

	// call function
	result = gtk_progress_bar_get_ellipsize(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
