/*
 * GtkRadioAction.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRadioAction.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioAction_gtk_1radio_1action_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _label,
	jstring _tooltip,
	jstring _stockId,
	jint _value
)
{
	GtkRadioAction* result;
	jlong _result;
	const gchar* name;
	const gchar* label;
	const gchar* tooltip;
	const gchar* stockId;
	gint value;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter tooltip
	tooltip = (const gchar*) (*env)->GetStringUTFChars(env, _tooltip, NULL);
	if (tooltip == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter value
	value = (gint) _value;

	// call function
	result = gtk_radio_action_new(name, label, tooltip, stockId, value);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// cleanup parameter tooltip
	(*env)->ReleaseStringUTFChars(env, _tooltip, tooltip);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// cleanup parameter value

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRadioAction_gtk_1radio_1action_1set_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _group
)
{
	GtkRadioAction* self;
	GSList* group;

	// convert parameter self
	self = (GtkRadioAction*) _self;

	// convert parameter group
	group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
	if (group == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_radio_action_set_group(self, group);

	// cleanup parameter self

	// cleanup parameter group
	g_slist_free(group);
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkRadioAction_gtk_1radio_1action_1get_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	GtkRadioAction* self;

	// convert parameter self
	self = (GtkRadioAction*) _self;

	// call function
	result = gtk_radio_action_get_group(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRadioAction_gtk_1radio_1action_1get_1current_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkRadioAction* self;

	// convert parameter self
	self = (GtkRadioAction*) _self;

	// call function
	result = gtk_radio_action_get_current_value(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRadioAction_gtk_1radio_1action_1set_1current_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _currentValue
)
{
	GtkRadioAction* self;
	gint currentValue;

	// convert parameter self
	self = (GtkRadioAction*) _self;

	// convert parameter currentValue
	currentValue = (gint) _currentValue;

	// call function
	gtk_radio_action_set_current_value(self, currentValue);

	// cleanup parameter self

	// cleanup parameter currentValue
}
