/*
 * GtkRadioButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRadioButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jlongArray _group
)
{
	GtkWidget* result;
	jlong _result;
	GSList* group;

	// convert parameter group
	if (_group == NULL) {
		group = NULL;
	} else {
		group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
		if (group == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_radio_button_new(group);

	// cleanup parameter group
	if (group != NULL) {
		g_slist_free(group);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new_1from_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _radioGroupMember
)
{
	GtkWidget* result;
	jlong _result;
	GtkRadioButton* radioGroupMember;

	// convert parameter radioGroupMember
	radioGroupMember = (GtkRadioButton*) _radioGroupMember;

	// call function
	result = gtk_radio_button_new_from_widget(radioGroupMember);

	// cleanup parameter radioGroupMember

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new_1with_1label
(
	JNIEnv* env,
	jclass cls,
	jlongArray _group,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	GSList* group;
	const gchar* label;

	// convert parameter group
	if (_group == NULL) {
		group = NULL;
	} else {
		group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
		if (group == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_button_new_with_label(group, label);

	// cleanup parameter group
	if (group != NULL) {
		g_slist_free(group);
	}

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new_1with_1label_1from_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _radioGroupMember,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	GtkRadioButton* radioGroupMember;
	const gchar* label;

	// convert parameter radioGroupMember
	radioGroupMember = (GtkRadioButton*) _radioGroupMember;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_button_new_with_label_from_widget(radioGroupMember, label);

	// cleanup parameter radioGroupMember

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new_1with_1mnemonic
(
	JNIEnv* env,
	jclass cls,
	jlongArray _group,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	GSList* group;
	const gchar* label;

	// convert parameter group
	if (_group == NULL) {
		group = NULL;
	} else {
		group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
		if (group == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_button_new_with_mnemonic(group, label);

	// cleanup parameter group
	if (group != NULL) {
		g_slist_free(group);
	}

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1new_1with_1mnemonic_1from_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _group,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	GtkRadioButton* group;
	const gchar* label;

	// convert parameter group
	group = (GtkRadioButton*) _group;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_button_new_with_mnemonic_from_widget(group, label);

	// cleanup parameter group

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1get_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	GtkRadioButton* self;

	// convert parameter self
	self = (GtkRadioButton*) _self;

	// call function
	result = gtk_radio_button_get_group(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRadioButton_gtk_1radio_1button_1set_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _group
)
{
	GtkRadioButton* self;
	GSList* group;

	// convert parameter self
	self = (GtkRadioButton*) _self;

	// convert parameter group
	group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
	if (group == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_radio_button_set_group(self, group);

	// cleanup parameter self

	// cleanup parameter group
	g_slist_free(group);
}
