/*
 * GtkRadioToolButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRadioToolButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jlongArray _group
)
{
	GtkToolItem* result;
	jlong _result;
	GSList* group;

	// convert parameter group
	group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
	if (group == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_tool_button_new(group);

	// cleanup parameter group
	g_slist_free(group);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jlongArray _group,
	jstring _stockId
)
{
	GtkToolItem* result;
	jlong _result;
	GSList* group;
	const gchar* stockId;

	// convert parameter group
	group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
	if (group == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_tool_button_new_from_stock(group, stockId);

	// cleanup parameter group
	g_slist_free(group);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1new_1from_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _group
)
{
	GtkToolItem* result;
	jlong _result;
	GtkRadioToolButton* group;

	// convert parameter group
	group = (GtkRadioToolButton*) _group;

	// call function
	result = gtk_radio_tool_button_new_from_widget(group);

	// cleanup parameter group

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1new_1with_1stock_1from_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _group,
	jstring _stockId
)
{
	GtkToolItem* result;
	jlong _result;
	GtkRadioToolButton* group;
	const gchar* stockId;

	// convert parameter group
	group = (GtkRadioToolButton*) _group;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_radio_tool_button_new_with_stock_from_widget(group, stockId);

	// cleanup parameter group

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1set_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _group
)
{
	GtkRadioToolButton* self;
	GSList* group;

	// convert parameter self
	self = (GtkRadioToolButton*) _self;

	// convert parameter group
	group = (GSList*) bindings_java_convert_jarray_to_gslist(env, _group);
	if (group == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_radio_tool_button_set_group(self, group);

	// cleanup parameter self

	// cleanup parameter group
	g_slist_free(group);
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkRadioToolButton_gtk_1radio_1tool_1button_1get_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	GtkRadioToolButton* self;

	// convert parameter self
	self = (GtkRadioToolButton*) _self;

	// call function
	result = gtk_radio_tool_button_get_group(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}
