/*
 * GtkRange.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRange.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1update_1policy
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _policy
)
{
	GtkRange* self;
	GtkUpdateType policy;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter policy
	policy = (GtkUpdateType) _policy;

	// call function
	gtk_range_set_update_policy(self, policy);

	// cleanup parameter self

	// cleanup parameter policy
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1update_1policy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkUpdateType result;
	jint _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_update_policy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1adjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkRange* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_range_set_adjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1adjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_adjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1inverted
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkRange* self;
	gboolean setting;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_range_set_inverted(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1inverted
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_inverted(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1increments
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _step,
	jdouble _page
)
{
	GtkRange* self;
	gdouble step;
	gdouble page;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter step
	step = (gdouble) _step;

	// convert parameter page
	page = (gdouble) _page;

	// call function
	gtk_range_set_increments(self, step, page);

	// cleanup parameter self

	// cleanup parameter step

	// cleanup parameter page
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1range
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _min,
	jdouble _max
)
{
	GtkRange* self;
	gdouble min;
	gdouble max;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter min
	min = (gdouble) _min;

	// convert parameter max
	max = (gdouble) _max;

	// call function
	gtk_range_set_range(self, min, max);

	// cleanup parameter self

	// cleanup parameter min

	// cleanup parameter max
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkRange* self;
	gdouble value;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_range_set_value(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_value(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1lower_1stepper_1sensitivity
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _sensitivity
)
{
	GtkRange* self;
	GtkSensitivityType sensitivity;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter sensitivity
	sensitivity = (GtkSensitivityType) _sensitivity;

	// call function
	gtk_range_set_lower_stepper_sensitivity(self, sensitivity);

	// cleanup parameter self

	// cleanup parameter sensitivity
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1lower_1stepper_1sensitivity
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSensitivityType result;
	jint _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_lower_stepper_sensitivity(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1set_1upper_1stepper_1sensitivity
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _sensitivity
)
{
	GtkRange* self;
	GtkSensitivityType sensitivity;

	// convert parameter self
	self = (GtkRange*) _self;

	// convert parameter sensitivity
	sensitivity = (GtkSensitivityType) _sensitivity;

	// call function
	gtk_range_set_upper_stepper_sensitivity(self, sensitivity);

	// cleanup parameter self

	// cleanup parameter sensitivity
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRange_gtk_1range_1get_1upper_1stepper_1sensitivity
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSensitivityType result;
	jint _result;
	GtkRange* self;

	// convert parameter self
	self = (GtkRange*) _self;

	// call function
	result = gtk_range_get_upper_stepper_sensitivity(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
