/*
 * GtkRecentAction.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRecentAction.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentAction_gtk_1recent_1action_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _label,
	jstring _tooltip,
	jstring _stockId
)
{
	GtkAction* result;
	jlong _result;
	const gchar* name;
	const gchar* label;
	const gchar* tooltip;
	const gchar* stockId;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter tooltip
	if (_tooltip == NULL) {
		tooltip = NULL;
	} else {
		tooltip = (const gchar*) (*env)->GetStringUTFChars(env, _tooltip, NULL);
		if (tooltip == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter stockId
	if (_stockId == NULL) {
		stockId = NULL;
	} else {
		stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
		if (stockId == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_recent_action_new(name, label, tooltip, stockId);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// cleanup parameter tooltip
	if (tooltip != NULL) {
		(*env)->ReleaseStringUTFChars(env, _tooltip, tooltip);
	}

	// cleanup parameter stockId
	if (stockId != NULL) {
		(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentAction_gtk_1recent_1action_1new_1for_1manager
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _label,
	jstring _tooltip,
	jstring _stockId,
	jlong _manager
)
{
	GtkAction* result;
	jlong _result;
	const gchar* name;
	const gchar* label;
	const gchar* tooltip;
	const gchar* stockId;
	GtkRecentManager* manager;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter tooltip
	if (_tooltip == NULL) {
		tooltip = NULL;
	} else {
		tooltip = (const gchar*) (*env)->GetStringUTFChars(env, _tooltip, NULL);
		if (tooltip == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter stockId
	if (_stockId == NULL) {
		stockId = NULL;
	} else {
		stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
		if (stockId == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter manager
	manager = (GtkRecentManager*) _manager;

	// call function
	result = gtk_recent_action_new_for_manager(name, label, tooltip, stockId, manager);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// cleanup parameter tooltip
	if (tooltip != NULL) {
		(*env)->ReleaseStringUTFChars(env, _tooltip, tooltip);
	}

	// cleanup parameter stockId
	if (stockId != NULL) {
		(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
	}

	// cleanup parameter manager

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRecentAction_gtk_1recent_1action_1get_1show_1numbers
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkRecentAction* self;

	// convert parameter self
	self = (GtkRecentAction*) _self;

	// call function
	result = gtk_recent_action_get_show_numbers(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentAction_gtk_1recent_1action_1set_1show_1numbers
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showNumbers
)
{
	GtkRecentAction* self;
	gboolean showNumbers;

	// convert parameter self
	self = (GtkRecentAction*) _self;

	// convert parameter showNumbers
	showNumbers = (gboolean) _showNumbers;

	// call function
	gtk_recent_action_set_show_numbers(self, showNumbers);

	// cleanup parameter self

	// cleanup parameter showNumbers
}
