/*
 * GtkRecentChooserDialog.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRecentChooserDialog.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentChooserDialog_gtk_1recent_1chooser_1dialog_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _title,
	jlong _parent,
	jstring _firstButtonText
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* title;
	GtkWindow* parent;
	const gchar* firstButtonText;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter parent
	parent = (GtkWindow*) _parent;

	// convert parameter firstButtonText
	firstButtonText = (const gchar*) (*env)->GetStringUTFChars(env, _firstButtonText, NULL);
	if (firstButtonText == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_chooser_dialog_new(title, parent, firstButtonText, NULL);

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);

	// cleanup parameter parent

	// cleanup parameter firstButtonText
	(*env)->ReleaseStringUTFChars(env, _firstButtonText, firstButtonText);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
