/*
 * GtkRecentFilter.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRecentFilter.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkRecentFilter* result;
	jlong _result;

	// call function
	result = gtk_recent_filter_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1set_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GtkRecentFilter* self;
	const gchar* name;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_recent_filter_set_name(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkRecentFilter* self;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// call function
	result = gtk_recent_filter_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1mime_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _mimeType
)
{
	GtkRecentFilter* self;
	const gchar* mimeType;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter mimeType
	mimeType = (const gchar*) (*env)->GetStringUTFChars(env, _mimeType, NULL);
	if (mimeType == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_recent_filter_add_mime_type(self, mimeType);

	// cleanup parameter self

	// cleanup parameter mimeType
	(*env)->ReleaseStringUTFChars(env, _mimeType, mimeType);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1pattern
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _pattern
)
{
	GtkRecentFilter* self;
	const gchar* pattern;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter pattern
	pattern = (const gchar*) (*env)->GetStringUTFChars(env, _pattern, NULL);
	if (pattern == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_recent_filter_add_pattern(self, pattern);

	// cleanup parameter self

	// cleanup parameter pattern
	(*env)->ReleaseStringUTFChars(env, _pattern, pattern);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1pixbuf_1formats
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkRecentFilter* self;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// call function
	gtk_recent_filter_add_pixbuf_formats(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1application
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _application
)
{
	GtkRecentFilter* self;
	const gchar* application;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter application
	application = (const gchar*) (*env)->GetStringUTFChars(env, _application, NULL);
	if (application == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_recent_filter_add_application(self, application);

	// cleanup parameter self

	// cleanup parameter application
	(*env)->ReleaseStringUTFChars(env, _application, application);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1group
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _group
)
{
	GtkRecentFilter* self;
	const gchar* group;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter group
	group = (const gchar*) (*env)->GetStringUTFChars(env, _group, NULL);
	if (group == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_recent_filter_add_group(self, group);

	// cleanup parameter self

	// cleanup parameter group
	(*env)->ReleaseStringUTFChars(env, _group, group);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1add_1age
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _days
)
{
	GtkRecentFilter* self;
	gint days;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// convert parameter days
	days = (gint) _days;

	// call function
	gtk_recent_filter_add_age(self, days);

	// cleanup parameter self

	// cleanup parameter days
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRecentFilter_gtk_1recent_1filter_1get_1needed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkRecentFilterFlags result;
	jint _result;
	GtkRecentFilter* self;

	// convert parameter self
	self = (GtkRecentFilter*) _self;

	// call function
	result = gtk_recent_filter_get_needed(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
