/*
 * GtkRecentManager.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRecentManager.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkRecentManager* result;
	jlong _result;

	// call function
	result = gtk_recent_manager_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1add_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri
)
{
	gboolean result;
	jboolean _result;
	GtkRecentManager* self;
	const gchar* uri;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_manager_add_item(self, uri);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1remove_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri
)
{
	gboolean result;
	jboolean _result;
	GtkRecentManager* self;
	const gchar* uri;
	GError* error = NULL;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_manager_remove_item(self, uri, &error);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1lookup_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri
)
{
	GtkRecentInfo* result;
	jlong _result;
	GtkRecentManager* self;
	const gchar* uri;
	GError* error = NULL;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_manager_lookup_item(self, uri, &error);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return 0L;
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1has_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri
)
{
	gboolean result;
	jboolean _result;
	GtkRecentManager* self;
	const gchar* uri;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_manager_has_item(self, uri);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1move_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _uri,
	jstring _newUri
)
{
	gboolean result;
	jboolean _result;
	GtkRecentManager* self;
	const gchar* uri;
	const gchar* newUri;
	GError* error = NULL;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter uri
	uri = (const gchar*) (*env)->GetStringUTFChars(env, _uri, NULL);
	if (uri == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter newUri
	newUri = (const gchar*) (*env)->GetStringUTFChars(env, _newUri, NULL);
	if (newUri == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_recent_manager_move_item(self, uri, newUri, &error);

	// cleanup parameter self

	// cleanup parameter uri
	(*env)->ReleaseStringUTFChars(env, _uri, uri);

	// cleanup parameter newUri
	(*env)->ReleaseStringUTFChars(env, _newUri, newUri);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1set_1limit
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _limit
)
{
	GtkRecentManager* self;
	gint limit;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// convert parameter limit
	limit = (gint) _limit;

	// call function
	gtk_recent_manager_set_limit(self, limit);

	// cleanup parameter self

	// cleanup parameter limit
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1get_1limit
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkRecentManager* self;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// call function
	result = gtk_recent_manager_get_limit(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRecentManager_gtk_1recent_1manager_1purge_1items
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkRecentManager* self;
	GError* error = NULL;

	// convert parameter self
	self = (GtkRecentManager*) _self;

	// call function
	result = gtk_recent_manager_purge_items(self, &error);

	// cleanup parameter self

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  0;
	}

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
