/*
 * GtkRuler.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkRuler.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1set_1metric
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _metric
)
{
	GtkRuler* self;
	GtkMetricType metric;

	// convert parameter self
	self = (GtkRuler*) _self;

	// convert parameter metric
	metric = (GtkMetricType) _metric;

	// call function
	gtk_ruler_set_metric(self, metric);

	// cleanup parameter self

	// cleanup parameter metric
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1set_1range
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _lower,
	jdouble _upper,
	jdouble _position,
	jdouble _maxSize
)
{
	GtkRuler* self;
	gdouble lower;
	gdouble upper;
	gdouble position;
	gdouble maxSize;

	// convert parameter self
	self = (GtkRuler*) _self;

	// convert parameter lower
	lower = (gdouble) _lower;

	// convert parameter upper
	upper = (gdouble) _upper;

	// convert parameter position
	position = (gdouble) _position;

	// convert parameter maxSize
	maxSize = (gdouble) _maxSize;

	// call function
	gtk_ruler_set_range(self, lower, upper, position, maxSize);

	// cleanup parameter self

	// cleanup parameter lower

	// cleanup parameter upper

	// cleanup parameter position

	// cleanup parameter maxSize
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1draw_1ticks
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkRuler* self;

	// convert parameter self
	self = (GtkRuler*) _self;

	// call function
	gtk_ruler_draw_ticks(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1draw_1pos
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkRuler* self;

	// convert parameter self
	self = (GtkRuler*) _self;

	// call function
	gtk_ruler_draw_pos(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1get_1metric
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkMetricType result;
	jint _result;
	GtkRuler* self;

	// convert parameter self
	self = (GtkRuler*) _self;

	// call function
	result = gtk_ruler_get_metric(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkRuler_gtk_1ruler_1get_1range
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdoubleArray _lower,
	jdoubleArray _upper,
	jdoubleArray _position,
	jdoubleArray _maxSize
)
{
	GtkRuler* self;
	gdouble* lower;
	gdouble* upper;
	gdouble* position;
	gdouble* maxSize;

	// convert parameter self
	self = (GtkRuler*) _self;

	// convert parameter lower
	lower = (gdouble*) (*env)->GetDoubleArrayElements(env, _lower, NULL);
	if (lower == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter upper
	upper = (gdouble*) (*env)->GetDoubleArrayElements(env, _upper, NULL);
	if (upper == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter position
	position = (gdouble*) (*env)->GetDoubleArrayElements(env, _position, NULL);
	if (position == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter maxSize
	maxSize = (gdouble*) (*env)->GetDoubleArrayElements(env, _maxSize, NULL);
	if (maxSize == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_ruler_get_range(self, lower, upper, position, maxSize);

	// cleanup parameter self

	// cleanup parameter lower
	(*env)->ReleaseDoubleArrayElements(env, _lower, (jdouble*)lower, 0);

	// cleanup parameter upper
	(*env)->ReleaseDoubleArrayElements(env, _upper, (jdouble*)upper, 0);

	// cleanup parameter position
	(*env)->ReleaseDoubleArrayElements(env, _position, (jdouble*)position, 0);

	// cleanup parameter maxSize
	(*env)->ReleaseDoubleArrayElements(env, _maxSize, (jdouble*)maxSize, 0);
}
