/*
 * GtkScaleButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkScaleButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jint _size,
	jdouble _min,
	jdouble _max,
	jdouble _step,
	jobjectArray _icons
)
{
	GtkWidget* result;
	jlong _result;
	GtkIconSize size;
	gdouble min;
	gdouble max;
	gdouble step;
	const gchar** icons;

	// convert parameter size
	size = (GtkIconSize) _size;

	// convert parameter min
	min = (gdouble) _min;

	// convert parameter max
	max = (gdouble) _max;

	// convert parameter step
	step = (gdouble) _step;

	// convert parameter icons
	icons = (const gchar**) bindings_java_convert_strarray_to_gchararray(env, _icons);
	if (icons == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_scale_button_new(size, min, max, step, icons);

	// cleanup parameter size

	// cleanup parameter min

	// cleanup parameter max

	// cleanup parameter step

	// cleanup parameter icons
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)icons, _icons);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1set_1adjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _adjustment
)
{
	GtkScaleButton* self;
	GtkAdjustment* adjustment;

	// convert parameter self
	self = (GtkScaleButton*) _self;

	// convert parameter adjustment
	adjustment = (GtkAdjustment*) _adjustment;

	// call function
	gtk_scale_button_set_adjustment(self, adjustment);

	// cleanup parameter self

	// cleanup parameter adjustment
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1set_1icons
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _icons
)
{
	GtkScaleButton* self;
	const gchar** icons;

	// convert parameter self
	self = (GtkScaleButton*) _self;

	// convert parameter icons
	icons = (const gchar**) bindings_java_convert_strarray_to_gchararray(env, _icons);
	if (icons == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_scale_button_set_icons(self, icons);

	// cleanup parameter self

	// cleanup parameter icons
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)icons, _icons);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1set_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jdouble _value
)
{
	GtkScaleButton* self;
	gdouble value;

	// convert parameter self
	self = (GtkScaleButton*) _self;

	// convert parameter value
	value = (gdouble) _value;

	// call function
	gtk_scale_button_set_value(self, value);

	// cleanup parameter self

	// cleanup parameter value
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1get_1adjustment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAdjustment* result;
	jlong _result;
	GtkScaleButton* self;

	// convert parameter self
	self = (GtkScaleButton*) _self;

	// call function
	result = gtk_scale_button_get_adjustment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jdouble JNICALL
Java_org_gnome_gtk_GtkScaleButton_gtk_1scale_1button_1get_1value
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gdouble result;
	jdouble _result;
	GtkScaleButton* self;

	// convert parameter self
	self = (GtkScaleButton*) _self;

	// call function
	result = gtk_scale_button_get_value(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jdouble) result;

	// and finally
	return _result;
}
