/*
 * GtkSelectionData.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkSelectionData.h"

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1get_1format
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// get field value
	result = self->format;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1set_1format
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _format
)
{
	GtkSelectionData* self;
	gint format;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter format
	format = (gint) _format;

	// set field value
	self->format = format;

	// cleanup parameter self

	// cleanup parameter format
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _str,
	jint _len
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	const gchar* str;
	gint len;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter str
	str = (const gchar*) (*env)->GetStringUTFChars(env, _str, NULL);
	if (str == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter len
	len = (gint) _len;

	// call function
	result = gtk_selection_data_set_text(self, str, len);

	// cleanup parameter self

	// cleanup parameter str
	(*env)->ReleaseStringUTFChars(env, _str, str);

	// cleanup parameter len

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1targets_1include_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	result = gtk_selection_data_targets_include_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSelectionData* result;
	jlong _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	result = gtk_selection_data_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	gtk_selection_data_free(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1set_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	result = gtk_selection_data_set_pixbuf(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1get_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	result = gtk_selection_data_get_pixbuf(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1set_1uris
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _uris
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	gchar** uris;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter uris
	uris = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _uris);
	if (uris == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_selection_data_set_uris(self, uris);

	// cleanup parameter self

	// cleanup parameter uris
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)uris, _uris);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1get_1uris
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar** result;
	jobjectArray _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	result = gtk_selection_data_get_uris(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// cleanup return value
	if (result != NULL) {
		g_strfreev(result);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1targets_1include_1image
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _writable
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	gboolean writable;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter writable
	writable = (gboolean) _writable;

	// call function
	result = gtk_selection_data_targets_include_image(self, writable);

	// cleanup parameter self

	// cleanup parameter writable

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1tree_1set_1row_1drag_1data
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _treeModel,
	jlong _path
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	GtkTreeModel* treeModel;
	GtkTreePath* path;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter treeModel
	treeModel = (GtkTreeModel*) _treeModel;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// call function
	result = gtk_tree_set_row_drag_data(self, treeModel, path);

	// cleanup parameter self

	// cleanup parameter treeModel

	// cleanup parameter path

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1tree_1get_1row_1drag_1data
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _treeModel,
	jlongArray _path
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	GtkTreeModel** treeModel;
	GtkTreePath** path;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter treeModel
	treeModel = (GtkTreeModel**) bindings_java_convert_jarray_to_gpointer(env, _treeModel);
	if (treeModel == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter path
	path = (GtkTreePath**) bindings_java_convert_jarray_to_gpointer(env, _path);
	if (path == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_tree_get_row_drag_data(self, treeModel, path);

	// cleanup parameter self

	// cleanup parameter treeModel
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)treeModel, _treeModel);

	// cleanup parameter path
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)path, _path);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1targets_1include_1rich_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _buffer
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;
	GtkTextBuffer* buffer;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// convert parameter buffer
	buffer = (GtkTextBuffer*) _buffer;

	// call function
	result = gtk_selection_data_targets_include_rich_text(self, buffer);

	// cleanup parameter self

	// cleanup parameter buffer

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkSelectionData_gtk_1selection_1data_1targets_1include_1uri
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSelectionData* self;

	// convert parameter self
	self = (GtkSelectionData*) _self;

	// call function
	result = gtk_selection_data_targets_include_uri(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
