/*
 * GtkSettings.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkSettings.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkSettings_gtk_1settings_1set_1string_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name,
	jstring _vString,
	jstring _origin
)
{
	GtkSettings* self;
	const gchar* name;
	const gchar* vString;
	const gchar* origin;

	// convert parameter self
	self = (GtkSettings*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter vString
	vString = (const gchar*) (*env)->GetStringUTFChars(env, _vString, NULL);
	if (vString == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter origin
	origin = (const gchar*) (*env)->GetStringUTFChars(env, _origin, NULL);
	if (origin == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_settings_set_string_property(self, name, vString, origin);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter vString
	(*env)->ReleaseStringUTFChars(env, _vString, vString);

	// cleanup parameter origin
	(*env)->ReleaseStringUTFChars(env, _origin, origin);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkSettings_gtk_1settings_1set_1long_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name,
	jlong _vLong,
	jstring _origin
)
{
	GtkSettings* self;
	const gchar* name;
	glong vLong;
	const gchar* origin;

	// convert parameter self
	self = (GtkSettings*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter vLong
	vLong = (glong) _vLong;

	// convert parameter origin
	origin = (const gchar*) (*env)->GetStringUTFChars(env, _origin, NULL);
	if (origin == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_settings_set_long_property(self, name, vLong, origin);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter vLong

	// cleanup parameter origin
	(*env)->ReleaseStringUTFChars(env, _origin, origin);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkSettings_gtk_1settings_1set_1double_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name,
	jdouble _vDouble,
	jstring _origin
)
{
	GtkSettings* self;
	const gchar* name;
	gdouble vDouble;
	const gchar* origin;

	// convert parameter self
	self = (GtkSettings*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter vDouble
	vDouble = (gdouble) _vDouble;

	// convert parameter origin
	origin = (const gchar*) (*env)->GetStringUTFChars(env, _origin, NULL);
	if (origin == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_settings_set_double_property(self, name, vDouble, origin);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter vDouble

	// cleanup parameter origin
	(*env)->ReleaseStringUTFChars(env, _origin, origin);
}
