/*
 * GtkStatusIcon.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkStatusIcon.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkStatusIcon* result;
	jlong _result;

	// call function
	result = gtk_status_icon_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1new_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _pixbuf
)
{
	GtkStatusIcon* result;
	jlong _result;
	GdkPixbuf* pixbuf;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	result = gtk_status_icon_new_from_pixbuf(pixbuf);

	// cleanup parameter pixbuf

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1new_1from_1file
(
	JNIEnv* env,
	jclass cls,
	jstring _filename
)
{
	GtkStatusIcon* result;
	jlong _result;
	const gchar* filename;

	// convert parameter filename
	filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_status_icon_new_from_file(filename);

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jstring _stockId
)
{
	GtkStatusIcon* result;
	jlong _result;
	const gchar* stockId;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_status_icon_new_from_stock(stockId);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1new_1from_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jstring _iconName
)
{
	GtkStatusIcon* result;
	jlong _result;
	const gchar* iconName;

	// convert parameter iconName
	iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
	if (iconName == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_status_icon_new_from_icon_name(iconName);

	// cleanup parameter iconName
	(*env)->ReleaseStringUTFChars(env, _iconName, iconName);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	GtkStatusIcon* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_status_icon_set_from_pixbuf(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1from_1file
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _filename
)
{
	GtkStatusIcon* self;
	const gchar* filename;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter filename
	filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_status_icon_set_from_file(self, filename);

	// cleanup parameter self

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId
)
{
	GtkStatusIcon* self;
	const gchar* stockId;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_status_icon_set_from_stock(self, stockId);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1from_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _iconName
)
{
	GtkStatusIcon* self;
	const gchar* iconName;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter iconName
	iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
	if (iconName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_status_icon_set_from_icon_name(self, iconName);

	// cleanup parameter self

	// cleanup parameter iconName
	(*env)->ReleaseStringUTFChars(env, _iconName, iconName);
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1storage_1type
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkImageType result;
	jint _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_storage_type(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_pixbuf(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_stock(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_icon_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1tooltip
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _tooltipText
)
{
	GtkStatusIcon* self;
	const gchar* tooltipText;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter tooltipText
	if (_tooltipText == NULL) {
		tooltipText = NULL;
	} else {
		tooltipText = (const gchar*) (*env)->GetStringUTFChars(env, _tooltipText, NULL);
		if (tooltipText == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_status_icon_set_tooltip(self, tooltipText);

	// cleanup parameter self

	// cleanup parameter tooltipText
	if (tooltipText != NULL) {
		(*env)->ReleaseStringUTFChars(env, _tooltipText, tooltipText);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _visible
)
{
	GtkStatusIcon* self;
	gboolean visible;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter visible
	visible = (gboolean) _visible;

	// call function
	gtk_status_icon_set_visible(self, visible);

	// cleanup parameter self

	// cleanup parameter visible
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1set_1blinking
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _blinking
)
{
	GtkStatusIcon* self;
	gboolean blinking;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter blinking
	blinking = (gboolean) _blinking;

	// call function
	gtk_status_icon_set_blinking(self, blinking);

	// cleanup parameter self

	// cleanup parameter blinking
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1blinking
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_get_blinking(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1is_1embedded
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkStatusIcon* self;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// call function
	result = gtk_status_icon_is_embedded(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkStatusIcon_gtk_1status_1icon_1get_1geometry
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _screen,
	jlong _area,
	jintArray _orientation
)
{
	gboolean result;
	jboolean _result;
	GtkStatusIcon* self;
	GdkScreen** screen;
	GdkRectangle* area;
	GtkOrientation* orientation;

	// convert parameter self
	self = (GtkStatusIcon*) _self;

	// convert parameter screen
	screen = (GdkScreen**) bindings_java_convert_jarray_to_gpointer(env, _screen);
	if (screen == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter area
	area = (GdkRectangle*) _area;

	// convert parameter orientation
	orientation = (GtkOrientation*) (*env)->GetIntArrayElements(env, _orientation, NULL);
	if (orientation == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_status_icon_get_geometry(self, screen, area, orientation);

	// cleanup parameter self

	// cleanup parameter screen
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)screen, _screen);

	// cleanup parameter area

	// cleanup parameter orientation
	(*env)->ReleaseIntArrayElements(env, _orientation, (jint*)orientation, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
