/*
 * GtkStatusbar.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkStatusbar.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_statusbar_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1get_1context_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _contextDescription
)
{
	guint result;
	jint _result;
	GtkStatusbar* self;
	const gchar* contextDescription;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// convert parameter contextDescription
	contextDescription = (const gchar*) (*env)->GetStringUTFChars(env, _contextDescription, NULL);
	if (contextDescription == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gtk_statusbar_get_context_id(self, contextDescription);

	// cleanup parameter self

	// cleanup parameter contextDescription
	(*env)->ReleaseStringUTFChars(env, _contextDescription, contextDescription);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1push
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _contextId,
	jstring _text
)
{
	guint result;
	jint _result;
	GtkStatusbar* self;
	guint contextId;
	const gchar* text;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// convert parameter contextId
	contextId = (guint) _contextId;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gtk_statusbar_push(self, contextId, text);

	// cleanup parameter self

	// cleanup parameter contextId

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1pop
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _contextId
)
{
	GtkStatusbar* self;
	guint contextId;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// convert parameter contextId
	contextId = (guint) _contextId;

	// call function
	gtk_statusbar_pop(self, contextId);

	// cleanup parameter self

	// cleanup parameter contextId
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1remove
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _contextId,
	jint _messageId
)
{
	GtkStatusbar* self;
	guint contextId;
	guint messageId;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// convert parameter contextId
	contextId = (guint) _contextId;

	// convert parameter messageId
	messageId = (guint) _messageId;

	// call function
	gtk_statusbar_remove(self, contextId, messageId);

	// cleanup parameter self

	// cleanup parameter contextId

	// cleanup parameter messageId
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1set_1has_1resize_1grip
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkStatusbar* self;
	gboolean setting;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_statusbar_set_has_resize_grip(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkStatusbar_gtk_1statusbar_1get_1has_1resize_1grip
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkStatusbar* self;

	// convert parameter self
	self = (GtkStatusbar*) _self;

	// call function
	result = gtk_statusbar_get_has_resize_grip(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
