/*
 * GtkTable.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTable.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1new
(
	JNIEnv* env,
	jclass cls,
	jint _nRows,
	jint _nColumns,
	jboolean _homogeneous
)
{
	GtkWidget* result;
	jlong _result;
	guint nRows;
	guint nColumns;
	gboolean homogeneous;

	// convert parameter nRows
	nRows = (guint) _nRows;

	// convert parameter nColumns
	nColumns = (guint) _nColumns;

	// convert parameter homogeneous
	homogeneous = (gboolean) _homogeneous;

	// call function
	result = gtk_table_new(nRows, nColumns, homogeneous);

	// cleanup parameter nRows

	// cleanup parameter nColumns

	// cleanup parameter homogeneous

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _rows,
	jint _columns
)
{
	GtkTable* self;
	guint rows;
	guint columns;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter rows
	rows = (guint) _rows;

	// convert parameter columns
	columns = (guint) _columns;

	// call function
	gtk_table_resize(self, rows, columns);

	// cleanup parameter self

	// cleanup parameter rows

	// cleanup parameter columns
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1attach
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _child,
	jint _leftAttach,
	jint _rightAttach,
	jint _topAttach,
	jint _bottomAttach,
	jint _xoptions,
	jint _yoptions,
	jint _xpadding,
	jint _ypadding
)
{
	GtkTable* self;
	GtkWidget* child;
	guint leftAttach;
	guint rightAttach;
	guint topAttach;
	guint bottomAttach;
	GtkAttachOptions xoptions;
	GtkAttachOptions yoptions;
	guint xpadding;
	guint ypadding;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter child
	child = (GtkWidget*) _child;

	// convert parameter leftAttach
	leftAttach = (guint) _leftAttach;

	// convert parameter rightAttach
	rightAttach = (guint) _rightAttach;

	// convert parameter topAttach
	topAttach = (guint) _topAttach;

	// convert parameter bottomAttach
	bottomAttach = (guint) _bottomAttach;

	// convert parameter xoptions
	xoptions = (GtkAttachOptions) _xoptions;

	// convert parameter yoptions
	yoptions = (GtkAttachOptions) _yoptions;

	// convert parameter xpadding
	xpadding = (guint) _xpadding;

	// convert parameter ypadding
	ypadding = (guint) _ypadding;

	// call function
	gtk_table_attach(self, child, leftAttach, rightAttach, topAttach, bottomAttach, xoptions, yoptions, xpadding, ypadding);

	// cleanup parameter self

	// cleanup parameter child

	// cleanup parameter leftAttach

	// cleanup parameter rightAttach

	// cleanup parameter topAttach

	// cleanup parameter bottomAttach

	// cleanup parameter xoptions

	// cleanup parameter yoptions

	// cleanup parameter xpadding

	// cleanup parameter ypadding
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1attach_1defaults
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _widget,
	jint _leftAttach,
	jint _rightAttach,
	jint _topAttach,
	jint _bottomAttach
)
{
	GtkTable* self;
	GtkWidget* widget;
	guint leftAttach;
	guint rightAttach;
	guint topAttach;
	guint bottomAttach;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter widget
	widget = (GtkWidget*) _widget;

	// convert parameter leftAttach
	leftAttach = (guint) _leftAttach;

	// convert parameter rightAttach
	rightAttach = (guint) _rightAttach;

	// convert parameter topAttach
	topAttach = (guint) _topAttach;

	// convert parameter bottomAttach
	bottomAttach = (guint) _bottomAttach;

	// call function
	gtk_table_attach_defaults(self, widget, leftAttach, rightAttach, topAttach, bottomAttach);

	// cleanup parameter self

	// cleanup parameter widget

	// cleanup parameter leftAttach

	// cleanup parameter rightAttach

	// cleanup parameter topAttach

	// cleanup parameter bottomAttach
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1set_1row_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _row,
	jint _spacing
)
{
	GtkTable* self;
	guint row;
	guint spacing;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter row
	row = (guint) _row;

	// convert parameter spacing
	spacing = (guint) _spacing;

	// call function
	gtk_table_set_row_spacing(self, row, spacing);

	// cleanup parameter self

	// cleanup parameter row

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1get_1row_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _row
)
{
	guint result;
	jint _result;
	GtkTable* self;
	guint row;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter row
	row = (guint) _row;

	// call function
	result = gtk_table_get_row_spacing(self, row);

	// cleanup parameter self

	// cleanup parameter row

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1set_1col_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _column,
	jint _spacing
)
{
	GtkTable* self;
	guint column;
	guint spacing;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter column
	column = (guint) _column;

	// convert parameter spacing
	spacing = (guint) _spacing;

	// call function
	gtk_table_set_col_spacing(self, column, spacing);

	// cleanup parameter self

	// cleanup parameter column

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1get_1col_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _column
)
{
	guint result;
	jint _result;
	GtkTable* self;
	guint column;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter column
	column = (guint) _column;

	// call function
	result = gtk_table_get_col_spacing(self, column);

	// cleanup parameter self

	// cleanup parameter column

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1set_1row_1spacings
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _spacing
)
{
	GtkTable* self;
	guint spacing;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter spacing
	spacing = (guint) _spacing;

	// call function
	gtk_table_set_row_spacings(self, spacing);

	// cleanup parameter self

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1get_1default_1row_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkTable* self;

	// convert parameter self
	self = (GtkTable*) _self;

	// call function
	result = gtk_table_get_default_row_spacing(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1set_1col_1spacings
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _spacing
)
{
	GtkTable* self;
	guint spacing;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter spacing
	spacing = (guint) _spacing;

	// call function
	gtk_table_set_col_spacings(self, spacing);

	// cleanup parameter self

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1get_1default_1col_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkTable* self;

	// convert parameter self
	self = (GtkTable*) _self;

	// call function
	result = gtk_table_get_default_col_spacing(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1set_1homogeneous
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _homogeneous
)
{
	GtkTable* self;
	gboolean homogeneous;

	// convert parameter self
	self = (GtkTable*) _self;

	// convert parameter homogeneous
	homogeneous = (gboolean) _homogeneous;

	// call function
	gtk_table_set_homogeneous(self, homogeneous);

	// cleanup parameter self

	// cleanup parameter homogeneous
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTable_gtk_1table_1get_1homogeneous
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkTable* self;

	// convert parameter self
	self = (GtkTable*) _self;

	// call function
	result = gtk_table_get_homogeneous(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
