/*
 * GtkTextTag.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTextTag.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTextTag_gtk_1text_1tag_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name
)
{
	GtkTextTag* result;
	jlong _result;
	const gchar* name;

	// convert parameter name
	if (_name == NULL) {
		name = NULL;
	} else {
		name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
		if (name == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_text_tag_new(name);

	// cleanup parameter name
	if (name != NULL) {
		(*env)->ReleaseStringUTFChars(env, _name, name);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTextTag_gtk_1text_1tag_1get_1priority
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkTextTag* self;

	// convert parameter self
	self = (GtkTextTag*) _self;

	// call function
	result = gtk_text_tag_get_priority(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTextTag_gtk_1text_1tag_1set_1priority
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _priority
)
{
	GtkTextTag* self;
	gint priority;

	// convert parameter self
	self = (GtkTextTag*) _self;

	// convert parameter priority
	priority = (gint) _priority;

	// call function
	gtk_text_tag_set_priority(self, priority);

	// cleanup parameter self

	// cleanup parameter priority
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTextTag_gtk_1text_1tag_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _eventObject,
	jlong _event,
	jlong _iter
)
{
	gboolean result;
	jboolean _result;
	GtkTextTag* self;
	GObject* eventObject;
	GdkEvent* event;
	const GtkTextIter* iter;

	// convert parameter self
	self = (GtkTextTag*) _self;

	// convert parameter eventObject
	eventObject = (GObject*) _eventObject;

	// convert parameter event
	event = (GdkEvent*) _event;

	// convert parameter iter
	iter = (const GtkTextIter*) _iter;

	// call function
	result = gtk_text_tag_event(self, eventObject, event, iter);

	// cleanup parameter self

	// cleanup parameter eventObject

	// cleanup parameter event

	// cleanup parameter iter

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
