/*
 * GtkTextTagTable.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTextTagTable.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTextTagTable_gtk_1text_1tag_1table_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkTextTagTable* result;
	jlong _result;

	// call function
	result = gtk_text_tag_table_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTextTagTable_gtk_1text_1tag_1table_1add
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _tag
)
{
	GtkTextTagTable* self;
	GtkTextTag* tag;

	// convert parameter self
	self = (GtkTextTagTable*) _self;

	// convert parameter tag
	tag = (GtkTextTag*) _tag;

	// call function
	gtk_text_tag_table_add(self, tag);

	// cleanup parameter self

	// cleanup parameter tag
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTextTagTable_gtk_1text_1tag_1table_1remove
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _tag
)
{
	GtkTextTagTable* self;
	GtkTextTag* tag;

	// convert parameter self
	self = (GtkTextTagTable*) _self;

	// convert parameter tag
	tag = (GtkTextTag*) _tag;

	// call function
	gtk_text_tag_table_remove(self, tag);

	// cleanup parameter self

	// cleanup parameter tag
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTextTagTable_gtk_1text_1tag_1table_1lookup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GtkTextTag* result;
	jlong _result;
	GtkTextTagTable* self;
	const gchar* name;

	// convert parameter self
	self = (GtkTextTagTable*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_text_tag_table_lookup(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTextTagTable_gtk_1text_1tag_1table_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkTextTagTable* self;

	// convert parameter self
	self = (GtkTextTagTable*) _self;

	// call function
	result = gtk_text_tag_table_get_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
