/*
 * GtkToggleAction.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkToggleAction.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _label,
	jstring _tooltip,
	jstring _stockId
)
{
	GtkToggleAction* result;
	jlong _result;
	const gchar* name;
	const gchar* label;
	const gchar* tooltip;
	const gchar* stockId;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter tooltip
	tooltip = (const gchar*) (*env)->GetStringUTFChars(env, _tooltip, NULL);
	if (tooltip == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_toggle_action_new(name, label, tooltip, stockId);

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// cleanup parameter tooltip
	(*env)->ReleaseStringUTFChars(env, _tooltip, tooltip);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1toggled
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkToggleAction* self;

	// convert parameter self
	self = (GtkToggleAction*) _self;

	// call function
	gtk_toggle_action_toggled(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1set_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _isActive
)
{
	GtkToggleAction* self;
	gboolean isActive;

	// convert parameter self
	self = (GtkToggleAction*) _self;

	// convert parameter isActive
	isActive = (gboolean) _isActive;

	// call function
	gtk_toggle_action_set_active(self, isActive);

	// cleanup parameter self

	// cleanup parameter isActive
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1get_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToggleAction* self;

	// convert parameter self
	self = (GtkToggleAction*) _self;

	// call function
	result = gtk_toggle_action_get_active(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1set_1draw_1as_1radio
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _drawAsRadio
)
{
	GtkToggleAction* self;
	gboolean drawAsRadio;

	// convert parameter self
	self = (GtkToggleAction*) _self;

	// convert parameter drawAsRadio
	drawAsRadio = (gboolean) _drawAsRadio;

	// call function
	gtk_toggle_action_set_draw_as_radio(self, drawAsRadio);

	// cleanup parameter self

	// cleanup parameter drawAsRadio
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToggleAction_gtk_1toggle_1action_1get_1draw_1as_1radio
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToggleAction* self;

	// convert parameter self
	self = (GtkToggleAction*) _self;

	// call function
	result = gtk_toggle_action_get_draw_as_radio(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
