/*
 * GtkToggleButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkToggleButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_toggle_button_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1new_1with_1label
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_toggle_button_new_with_label(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1new_1with_1mnemonic
(
	JNIEnv* env,
	jclass cls,
	jstring _label
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* label;

	// convert parameter label
	label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
	if (label == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_toggle_button_new_with_mnemonic(label);

	// cleanup parameter label
	(*env)->ReleaseStringUTFChars(env, _label, label);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1set_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _drawIndicator
)
{
	GtkToggleButton* self;
	gboolean drawIndicator;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// convert parameter drawIndicator
	drawIndicator = (gboolean) _drawIndicator;

	// call function
	gtk_toggle_button_set_mode(self, drawIndicator);

	// cleanup parameter self

	// cleanup parameter drawIndicator
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1get_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToggleButton* self;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// call function
	result = gtk_toggle_button_get_mode(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1set_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _isActive
)
{
	GtkToggleButton* self;
	gboolean isActive;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// convert parameter isActive
	isActive = (gboolean) _isActive;

	// call function
	gtk_toggle_button_set_active(self, isActive);

	// cleanup parameter self

	// cleanup parameter isActive
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1get_1active
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToggleButton* self;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// call function
	result = gtk_toggle_button_get_active(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1toggled
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkToggleButton* self;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// call function
	gtk_toggle_button_toggled(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1set_1inconsistent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	GtkToggleButton* self;
	gboolean setting;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	gtk_toggle_button_set_inconsistent(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToggleButton_gtk_1toggle_1button_1get_1inconsistent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToggleButton* self;

	// convert parameter self
	self = (GtkToggleButton*) _self;

	// call function
	result = gtk_toggle_button_get_inconsistent(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
