/*
 * GtkToolButton.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkToolButton.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _iconWidget,
	jstring _label
)
{
	GtkToolItem* result;
	jlong _result;
	GtkWidget* iconWidget;
	const gchar* label;

	// convert parameter iconWidget
	iconWidget = (GtkWidget*) _iconWidget;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_tool_button_new(iconWidget, label);

	// cleanup parameter iconWidget

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1new_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jstring _stockId
)
{
	GtkToolItem* result;
	jlong _result;
	const gchar* stockId;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_tool_button_new_from_stock(stockId);

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _label
)
{
	GtkToolButton* self;
	const gchar* label;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter label
	if (_label == NULL) {
		label = NULL;
	} else {
		label = (const gchar*) (*env)->GetStringUTFChars(env, _label, NULL);
		if (label == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_tool_button_set_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
	if (label != NULL) {
		(*env)->ReleaseStringUTFChars(env, _label, label);
	}
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_label(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _useUnderline
)
{
	GtkToolButton* self;
	gboolean useUnderline;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter useUnderline
	useUnderline = (gboolean) _useUnderline;

	// call function
	gtk_tool_button_set_use_underline(self, useUnderline);

	// cleanup parameter self

	// cleanup parameter useUnderline
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1use_1underline
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_use_underline(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1stock_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId
)
{
	GtkToolButton* self;
	const gchar* stockId;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter stockId
	if (_stockId == NULL) {
		stockId = NULL;
	} else {
		stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
		if (stockId == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_tool_button_set_stock_id(self, stockId);

	// cleanup parameter self

	// cleanup parameter stockId
	if (stockId != NULL) {
		(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _iconName
)
{
	GtkToolButton* self;
	const gchar* iconName;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter iconName
	if (_iconName == NULL) {
		iconName = NULL;
	} else {
		iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
		if (iconName == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_tool_button_set_icon_name(self, iconName);

	// cleanup parameter self

	// cleanup parameter iconName
	if (iconName != NULL) {
		(*env)->ReleaseStringUTFChars(env, _iconName, iconName);
	}
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_icon_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1stock_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_stock_id(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1icon_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iconWidget
)
{
	GtkToolButton* self;
	GtkWidget* iconWidget;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter iconWidget
	iconWidget = (GtkWidget*) _iconWidget;

	// call function
	gtk_tool_button_set_icon_widget(self, iconWidget);

	// cleanup parameter self

	// cleanup parameter iconWidget
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1icon_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_icon_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1set_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _labelWidget
)
{
	GtkToolButton* self;
	GtkWidget* labelWidget;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// convert parameter labelWidget
	labelWidget = (GtkWidget*) _labelWidget;

	// call function
	gtk_tool_button_set_label_widget(self, labelWidget);

	// cleanup parameter self

	// cleanup parameter labelWidget
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolButton_gtk_1tool_1button_1get_1label_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkToolButton* self;

	// convert parameter self
	self = (GtkToolButton*) _self;

	// call function
	result = gtk_tool_button_get_label_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
