/*
 * GtkToolbar.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkToolbar.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_toolbar_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1insert
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _item,
	jint _pos
)
{
	GtkToolbar* self;
	GtkToolItem* item;
	gint pos;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter item
	item = (GtkToolItem*) _item;

	// convert parameter pos
	pos = (gint) _pos;

	// call function
	gtk_toolbar_insert(self, item, pos);

	// cleanup parameter self

	// cleanup parameter item

	// cleanup parameter pos
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1item_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _item
)
{
	gint result;
	jint _result;
	GtkToolbar* self;
	GtkToolItem* item;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter item
	item = (GtkToolItem*) _item;

	// call function
	result = gtk_toolbar_get_item_index(self, item);

	// cleanup parameter self

	// cleanup parameter item

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1n_1items
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_n_items(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1nth_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _n
)
{
	GtkToolItem* result;
	jlong _result;
	GtkToolbar* self;
	gint n;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter n
	n = (gint) _n;

	// call function
	result = gtk_toolbar_get_nth_item(self, n);

	// cleanup parameter self

	// cleanup parameter n

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1drop_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y
)
{
	gint result;
	jint _result;
	GtkToolbar* self;
	gint x;
	gint y;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	result = gtk_toolbar_get_drop_index(self, x, y);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1set_1drop_1highlight_1item
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _toolItem,
	jint _index
)
{
	GtkToolbar* self;
	GtkToolItem* toolItem;
	gint index;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter toolItem
	toolItem = (GtkToolItem*) _toolItem;

	// convert parameter index
	index = (gint) _index;

	// call function
	gtk_toolbar_set_drop_highlight_item(self, toolItem, index);

	// cleanup parameter self

	// cleanup parameter toolItem

	// cleanup parameter index
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1set_1show_1arrow
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _showArrow
)
{
	GtkToolbar* self;
	gboolean showArrow;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter showArrow
	showArrow = (gboolean) _showArrow;

	// call function
	gtk_toolbar_set_show_arrow(self, showArrow);

	// cleanup parameter self

	// cleanup parameter showArrow
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1show_1arrow
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_show_arrow(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1relief_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkReliefStyle result;
	jint _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_relief_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1set_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _orientation
)
{
	GtkToolbar* self;
	GtkOrientation orientation;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter orientation
	orientation = (GtkOrientation) _orientation;

	// call function
	gtk_toolbar_set_orientation(self, orientation);

	// cleanup parameter self

	// cleanup parameter orientation
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1set_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _style
)
{
	GtkToolbar* self;
	GtkToolbarStyle style;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// convert parameter style
	style = (GtkToolbarStyle) _style;

	// call function
	gtk_toolbar_set_style(self, style);

	// cleanup parameter self

	// cleanup parameter style
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1unset_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	gtk_toolbar_unset_style(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1orientation
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkOrientation result;
	jint _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_orientation(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkToolbarStyle result;
	jint _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkToolbar_gtk_1toolbar_1get_1icon_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkIconSize result;
	jint _result;
	GtkToolbar* self;

	// convert parameter self
	self = (GtkToolbar*) _self;

	// call function
	result = gtk_toolbar_get_icon_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
