/*
 * GtkTooltip.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTooltip.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _markup
)
{
	GtkTooltip* self;
	const gchar* markup;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter markup
	if (_markup == NULL) {
		markup = NULL;
	} else {
		markup = (const gchar*) (*env)->GetStringUTFChars(env, _markup, NULL);
		if (markup == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_tooltip_set_markup(self, markup);

	// cleanup parameter self

	// cleanup parameter markup
	if (markup != NULL) {
		(*env)->ReleaseStringUTFChars(env, _markup, markup);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkTooltip* self;
	const gchar* text;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter text
	if (_text == NULL) {
		text = NULL;
	} else {
		text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
		if (text == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_tooltip_set_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	if (text != NULL) {
		(*env)->ReleaseStringUTFChars(env, _text, text);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	GtkTooltip* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_tooltip_set_icon(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1icon_1from_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId,
	jint _size
)
{
	GtkTooltip* self;
	const gchar* stockId;
	GtkIconSize size;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter stockId
	if (_stockId == NULL) {
		stockId = NULL;
	} else {
		stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
		if (stockId == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// call function
	gtk_tooltip_set_icon_from_stock(self, stockId, size);

	// cleanup parameter self

	// cleanup parameter stockId
	if (stockId != NULL) {
		(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
	}

	// cleanup parameter size
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1custom
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _customWidget
)
{
	GtkTooltip* self;
	GtkWidget* customWidget;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter customWidget
	customWidget = (GtkWidget*) _customWidget;

	// call function
	gtk_tooltip_set_custom(self, customWidget);

	// cleanup parameter self

	// cleanup parameter customWidget
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1trigger_1tooltip_1query
(
	JNIEnv* env,
	jclass cls,
	jlong _display
)
{
	GdkDisplay* display;

	// convert parameter display
	display = (GdkDisplay*) _display;

	// call function
	gtk_tooltip_trigger_tooltip_query(display);

	// cleanup parameter display
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTooltip_gtk_1tooltip_1set_1tip_1area
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _rect
)
{
	GtkTooltip* self;
	GdkRectangle* rect;

	// convert parameter self
	self = (GtkTooltip*) _self;

	// convert parameter rect
	rect = (GdkRectangle*) _rect;

	// call function
	gtk_tooltip_set_tip_area(self, rect);

	// cleanup parameter self

	// cleanup parameter rect
}
