/*
 * GtkTreeModelSort.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTreeModelSort.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1new_1with_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _model
)
{
	GtkTreeModel* result;
	jlong _result;
	GtkTreeModel* model;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// call function
	result = gtk_tree_model_sort_new_with_model(model);

	// cleanup parameter model

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1get_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeModel* result;
	jlong _result;
	GtkTreeModelSort* self;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// call function
	result = gtk_tree_model_sort_get_model(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1convert_1child_1path_1to_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _childPath
)
{
	GtkTreePath* result;
	jlong _result;
	GtkTreeModelSort* self;
	GtkTreePath* childPath;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// convert parameter childPath
	childPath = (GtkTreePath*) _childPath;

	// call function
	result = gtk_tree_model_sort_convert_child_path_to_path(self, childPath);

	// cleanup parameter self

	// cleanup parameter childPath

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1convert_1child_1iter_1to_1iter
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _sortIter,
	jlong _childIter
)
{
	GtkTreeModelSort* self;
	GtkTreeIter* sortIter;
	GtkTreeIter* childIter;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// convert parameter sortIter
	sortIter = (GtkTreeIter*) _sortIter;

	// convert parameter childIter
	childIter = (GtkTreeIter*) _childIter;

	// call function
	gtk_tree_model_sort_convert_child_iter_to_iter(self, sortIter, childIter);

	// cleanup parameter self

	// cleanup parameter sortIter

	// cleanup parameter childIter
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1convert_1path_1to_1child_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _sortedPath
)
{
	GtkTreePath* result;
	jlong _result;
	GtkTreeModelSort* self;
	GtkTreePath* sortedPath;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// convert parameter sortedPath
	sortedPath = (GtkTreePath*) _sortedPath;

	// call function
	result = gtk_tree_model_sort_convert_path_to_child_path(self, sortedPath);

	// cleanup parameter self

	// cleanup parameter sortedPath

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1convert_1iter_1to_1child_1iter
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _childIter,
	jlong _sortedIter
)
{
	GtkTreeModelSort* self;
	GtkTreeIter* childIter;
	GtkTreeIter* sortedIter;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// convert parameter childIter
	childIter = (GtkTreeIter*) _childIter;

	// convert parameter sortedIter
	sortedIter = (GtkTreeIter*) _sortedIter;

	// call function
	gtk_tree_model_sort_convert_iter_to_child_iter(self, childIter, sortedIter);

	// cleanup parameter self

	// cleanup parameter childIter

	// cleanup parameter sortedIter
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1reset_1default_1sort_1func
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeModelSort* self;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// call function
	gtk_tree_model_sort_reset_default_sort_func(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreeModelSort_gtk_1tree_1model_1sort_1iter_1is_1valid
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter
)
{
	gboolean result;
	jboolean _result;
	GtkTreeModelSort* self;
	GtkTreeIter* iter;

	// convert parameter self
	self = (GtkTreeModelSort*) _self;

	// convert parameter iter
	iter = (GtkTreeIter*) _iter;

	// call function
	result = gtk_tree_model_sort_iter_is_valid(self, iter);

	// cleanup parameter self

	// cleanup parameter iter

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
