/*
 * GtkTreePath.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTreePath.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkTreePath* result;
	jlong _result;

	// call function
	result = gtk_tree_path_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1new_1from_1string
(
	JNIEnv* env,
	jclass cls,
	jstring _path
)
{
	GtkTreePath* result;
	jlong _result;
	gchar* path;

	// convert parameter path
	path = (gchar*) (*env)->GetStringUTFChars(env, _path, NULL);
	if (path == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_tree_path_new_from_string(path);

	// cleanup parameter path
	(*env)->ReleaseStringUTFChars(env, _path, path);

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1to_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_to_string(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1append_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index
)
{
	GtkTreePath* self;
	gint index;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// convert parameter index
	index = (gint) _index;

	// call function
	gtk_tree_path_append_index(self, index);

	// cleanup parameter self

	// cleanup parameter index
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1prepend_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index
)
{
	GtkTreePath* self;
	gint index;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// convert parameter index
	index = (gint) _index;

	// call function
	gtk_tree_path_prepend_index(self, index);

	// cleanup parameter self

	// cleanup parameter index
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1get_1depth
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_get_depth(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jintArray JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1get_1indices
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint* result;
	jintArray _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_get_indices(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jintArray) NULL;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	gtk_tree_path_free(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* result;
	jlong _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1compare
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _b
)
{
	gint result;
	jint _result;
	GtkTreePath* self;
	const GtkTreePath* b;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// convert parameter b
	b = (const GtkTreePath*) _b;

	// call function
	result = gtk_tree_path_compare(self, b);

	// cleanup parameter self

	// cleanup parameter b

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1next
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	gtk_tree_path_next(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1prev
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_prev(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1up
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	result = gtk_tree_path_up(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1down
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* self;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// call function
	gtk_tree_path_down(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1is_1ancestor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _descendant
)
{
	gboolean result;
	jboolean _result;
	GtkTreePath* self;
	GtkTreePath* descendant;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// convert parameter descendant
	descendant = (GtkTreePath*) _descendant;

	// call function
	result = gtk_tree_path_is_ancestor(self, descendant);

	// cleanup parameter self

	// cleanup parameter descendant

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreePath_gtk_1tree_1path_1is_1descendant
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _ancestor
)
{
	gboolean result;
	jboolean _result;
	GtkTreePath* self;
	GtkTreePath* ancestor;

	// convert parameter self
	self = (GtkTreePath*) _self;

	// convert parameter ancestor
	ancestor = (GtkTreePath*) _ancestor;

	// call function
	result = gtk_tree_path_is_descendant(self, ancestor);

	// cleanup parameter self

	// cleanup parameter ancestor

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
