/*
 * GtkTreeRowReference.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTreeRowReference.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _model,
	jlong _path
)
{
	GtkTreeRowReference* result;
	jlong _result;
	GtkTreeModel* model;
	GtkTreePath* path;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// call function
	result = gtk_tree_row_reference_new(model, path);

	// cleanup parameter model

	// cleanup parameter path

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1new_1proxy
(
	JNIEnv* env,
	jclass cls,
	jlong _proxy,
	jlong _model,
	jlong _path
)
{
	GtkTreeRowReference* result;
	jlong _result;
	GObject* proxy;
	GtkTreeModel* model;
	GtkTreePath* path;

	// convert parameter proxy
	proxy = (GObject*) _proxy;

	// convert parameter model
	model = (GtkTreeModel*) _model;

	// convert parameter path
	path = (GtkTreePath*) _path;

	// call function
	result = gtk_tree_row_reference_new_proxy(proxy, model, path);

	// cleanup parameter proxy

	// cleanup parameter model

	// cleanup parameter path

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1get_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreePath* result;
	jlong _result;
	GtkTreeRowReference* self;

	// convert parameter self
	self = (GtkTreeRowReference*) _self;

	// call function
	result = gtk_tree_row_reference_get_path(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1get_1model
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeModel* result;
	jlong _result;
	GtkTreeRowReference* self;

	// convert parameter self
	self = (GtkTreeRowReference*) _self;

	// call function
	result = gtk_tree_row_reference_get_model(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1valid
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkTreeRowReference* self;

	// convert parameter self
	self = (GtkTreeRowReference*) _self;

	// call function
	result = gtk_tree_row_reference_valid(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeRowReference* result;
	jlong _result;
	GtkTreeRowReference* self;

	// convert parameter self
	self = (GtkTreeRowReference*) _self;

	// call function
	result = gtk_tree_row_reference_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeRowReference_gtk_1tree_1row_1reference_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeRowReference* self;

	// convert parameter self
	self = (GtkTreeRowReference*) _self;

	// call function
	gtk_tree_row_reference_free(self);

	// cleanup parameter self
}
