/*
 * GtkTreeSortable.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkTreeSortable.h"

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeSortable_gtk_1tree_1sortable_1sort_1column_1changed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTreeSortable* self;

	// convert parameter self
	self = (GtkTreeSortable*) _self;

	// call function
	gtk_tree_sortable_sort_column_changed(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreeSortable_gtk_1tree_1sortable_1get_1sort_1column_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _sortColumnId,
	jintArray _order
)
{
	gboolean result;
	jboolean _result;
	GtkTreeSortable* self;
	gint* sortColumnId;
	GtkSortType* order;

	// convert parameter self
	self = (GtkTreeSortable*) _self;

	// convert parameter sortColumnId
	sortColumnId = (gint*) (*env)->GetIntArrayElements(env, _sortColumnId, NULL);
	if (sortColumnId == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter order
	order = (GtkSortType*) (*env)->GetIntArrayElements(env, _order, NULL);
	if (order == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_tree_sortable_get_sort_column_id(self, sortColumnId, order);

	// cleanup parameter self

	// cleanup parameter sortColumnId
	(*env)->ReleaseIntArrayElements(env, _sortColumnId, (jint*)sortColumnId, 0);

	// cleanup parameter order
	(*env)->ReleaseIntArrayElements(env, _order, (jint*)order, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkTreeSortable_gtk_1tree_1sortable_1set_1sort_1column_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _sortColumnId,
	jint _order
)
{
	GtkTreeSortable* self;
	gint sortColumnId;
	GtkSortType order;

	// convert parameter self
	self = (GtkTreeSortable*) _self;

	// convert parameter sortColumnId
	sortColumnId = (gint) _sortColumnId;

	// convert parameter order
	order = (GtkSortType) _order;

	// call function
	gtk_tree_sortable_set_sort_column_id(self, sortColumnId, order);

	// cleanup parameter self

	// cleanup parameter sortColumnId

	// cleanup parameter order
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkTreeSortable_gtk_1tree_1sortable_1has_1default_1sort_1func
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkTreeSortable* self;

	// convert parameter self
	self = (GtkTreeSortable*) _self;

	// call function
	result = gtk_tree_sortable_has_default_sort_func(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
