/*
 * GtkWidget.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_gtk_GtkWidget.h"

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1check_1threshold
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _startX,
	jint _startY,
	jint _currentX,
	jint _currentY
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	gint startX;
	gint startY;
	gint currentX;
	gint currentY;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter startX
	startX = (gint) _startX;

	// convert parameter startY
	startY = (gint) _startY;

	// convert parameter currentX
	currentX = (gint) _currentX;

	// convert parameter currentY
	currentY = (gint) _currentY;

	// call function
	result = gtk_drag_check_threshold(self, startX, startY, currentX, currentY);

	// cleanup parameter self

	// cleanup parameter startX

	// cleanup parameter startY

	// cleanup parameter currentX

	// cleanup parameter currentY

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1highlight
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_highlight(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1unhighlight
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_unhighlight(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1set_1proxy
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _proxyWindow,
	jint _protocol,
	jboolean _useCoordinates
)
{
	GtkWidget* self;
	GdkWindow* proxyWindow;
	GdkDragProtocol protocol;
	gboolean useCoordinates;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter proxyWindow
	proxyWindow = (GdkWindow*) _proxyWindow;

	// convert parameter protocol
	protocol = (GdkDragProtocol) _protocol;

	// convert parameter useCoordinates
	useCoordinates = (gboolean) _useCoordinates;

	// call function
	gtk_drag_dest_set_proxy(self, proxyWindow, protocol, useCoordinates);

	// cleanup parameter self

	// cleanup parameter proxyWindow

	// cleanup parameter protocol

	// cleanup parameter useCoordinates
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1unset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_dest_unset(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1unset
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_source_unset(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1set_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colormap,
	jlong _pixmap,
	jlong _mask
)
{
	GtkWidget* self;
	GdkColormap* colormap;
	GdkPixmap* pixmap;
	GdkBitmap* mask;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter colormap
	colormap = (GdkColormap*) _colormap;

	// convert parameter pixmap
	pixmap = (GdkPixmap*) _pixmap;

	// convert parameter mask
	mask = (GdkBitmap*) _mask;

	// call function
	gtk_drag_source_set_icon(self, colormap, pixmap, mask);

	// cleanup parameter self

	// cleanup parameter colormap

	// cleanup parameter pixmap

	// cleanup parameter mask
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1set_1icon_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pixbuf
)
{
	GtkWidget* self;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_drag_source_set_icon_pixbuf(self, pixbuf);

	// cleanup parameter self

	// cleanup parameter pixbuf
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1set_1icon_1stock
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId
)
{
	GtkWidget* self;
	const gchar* stockId;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_drag_source_set_icon_stock(self, stockId);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1set_1icon_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _iconName
)
{
	GtkWidget* self;
	const gchar* iconName;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter iconName
	iconName = (const gchar*) (*env)->GetStringUTFChars(env, _iconName, NULL);
	if (iconName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_drag_source_set_icon_name(self, iconName);

	// cleanup parameter self

	// cleanup parameter iconName
	(*env)->ReleaseStringUTFChars(env, _iconName, iconName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1add_1text_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_dest_add_text_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1add_1image_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_dest_add_image_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1add_1uri_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_dest_add_uri_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1add_1text_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_source_add_text_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1add_1image_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_source_add_image_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1source_1add_1uri_1targets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_drag_source_add_uri_targets(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1grab_1add
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_grab_add(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1grab_1remove
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_grab_remove(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1propagate_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _event
)
{
	GtkWidget* self;
	GdkEvent* event;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter event
	event = (GdkEvent*) _event;

	// call function
	gtk_propagate_event(self, event);

	// cleanup parameter self

	// cleanup parameter event
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1menu_1get_1for_1attach_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GList* result;
	jlongArray _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_menu_get_for_attach_widget(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_glist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1rc_1get_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkStyle* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_rc_get_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1selection_1remove_1all
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_selection_remove_all(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1destroy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_destroy(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1destroyed
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlongArray _widgetPointer
)
{
	GtkWidget* self;
	GtkWidget** widgetPointer;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter widgetPointer
	widgetPointer = (GtkWidget**) bindings_java_convert_jarray_to_gpointer(env, _widgetPointer);
	if (widgetPointer == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_destroyed(self, widgetPointer);

	// cleanup parameter self

	// cleanup parameter widgetPointer
	bindings_java_convert_gpointer_to_jarray(env, (gpointer*)widgetPointer, _widgetPointer);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1unparent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_unparent(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1show
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_show(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1show_1now
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_show_now(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1hide
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_hide(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1show_1all
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_show_all(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1hide_1all
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_hide_all(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1no_1show_1all
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _noShowAll
)
{
	GtkWidget* self;
	gboolean noShowAll;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter noShowAll
	noShowAll = (gboolean) _noShowAll;

	// call function
	gtk_widget_set_no_show_all(self, noShowAll);

	// cleanup parameter self

	// cleanup parameter noShowAll
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1no_1show_1all
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_no_show_all(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1map
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_map(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1unmap
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_unmap(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1realize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_realize(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1unrealize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_unrealize(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1queue_1draw
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_queue_draw(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1queue_1draw_1area
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y,
	jint _width,
	jint _height
)
{
	GtkWidget* self;
	gint x;
	gint y;
	gint width;
	gint height;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gtk_widget_queue_draw_area(self, x, y, width, height);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1queue_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_queue_resize(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1queue_1resize_1no_1redraw
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_queue_resize_no_redraw(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1size_1request
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _requisition
)
{
	GtkWidget* self;
	GtkRequisition* requisition;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter requisition
	requisition = (GtkRequisition*) _requisition;

	// call function
	gtk_widget_size_request(self, requisition);

	// cleanup parameter self

	// cleanup parameter requisition
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1size_1allocate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _allocation
)
{
	GtkWidget* self;
	GtkAllocation* allocation;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter allocation
	allocation = (GtkAllocation*) _allocation;

	// call function
	gtk_widget_size_allocate(self, allocation);

	// cleanup parameter self

	// cleanup parameter allocation
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1child_1requisition
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _requisition
)
{
	GtkWidget* self;
	GtkRequisition* requisition;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter requisition
	requisition = (GtkRequisition*) _requisition;

	// call function
	gtk_widget_get_child_requisition(self, requisition);

	// cleanup parameter self

	// cleanup parameter requisition
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1add_1accelerator
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _accelSignal,
	jlong _accelGroup,
	jint _accelKey,
	jint _accelMods,
	jint _accelFlags
)
{
	GtkWidget* self;
	const gchar* accelSignal;
	GtkAccelGroup* accelGroup;
	guint accelKey;
	GdkModifierType accelMods;
	GtkAccelFlags accelFlags;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter accelSignal
	accelSignal = (const gchar*) (*env)->GetStringUTFChars(env, _accelSignal, NULL);
	if (accelSignal == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter accelGroup
	accelGroup = (GtkAccelGroup*) _accelGroup;

	// convert parameter accelKey
	accelKey = (guint) _accelKey;

	// convert parameter accelMods
	accelMods = (GdkModifierType) _accelMods;

	// convert parameter accelFlags
	accelFlags = (GtkAccelFlags) _accelFlags;

	// call function
	gtk_widget_add_accelerator(self, accelSignal, accelGroup, accelKey, accelMods, accelFlags);

	// cleanup parameter self

	// cleanup parameter accelSignal
	(*env)->ReleaseStringUTFChars(env, _accelSignal, accelSignal);

	// cleanup parameter accelGroup

	// cleanup parameter accelKey

	// cleanup parameter accelMods

	// cleanup parameter accelFlags
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1remove_1accelerator
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _accelGroup,
	jint _accelKey,
	jint _accelMods
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkAccelGroup* accelGroup;
	guint accelKey;
	GdkModifierType accelMods;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter accelGroup
	accelGroup = (GtkAccelGroup*) _accelGroup;

	// convert parameter accelKey
	accelKey = (guint) _accelKey;

	// convert parameter accelMods
	accelMods = (GdkModifierType) _accelMods;

	// call function
	result = gtk_widget_remove_accelerator(self, accelGroup, accelKey, accelMods);

	// cleanup parameter self

	// cleanup parameter accelGroup

	// cleanup parameter accelKey

	// cleanup parameter accelMods

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1accel_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _accelPath,
	jlong _accelGroup
)
{
	GtkWidget* self;
	const gchar* accelPath;
	GtkAccelGroup* accelGroup;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter accelPath
	if (_accelPath == NULL) {
		accelPath = NULL;
	} else {
		accelPath = (const gchar*) (*env)->GetStringUTFChars(env, _accelPath, NULL);
		if (accelPath == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter accelGroup
	accelGroup = (GtkAccelGroup*) _accelGroup;

	// call function
	gtk_widget_set_accel_path(self, accelPath, accelGroup);

	// cleanup parameter self

	// cleanup parameter accelPath
	if (accelPath != NULL) {
		(*env)->ReleaseStringUTFChars(env, _accelPath, accelPath);
	}

	// cleanup parameter accelGroup
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1can_1activate_1accel
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _signalId
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	guint signalId;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter signalId
	signalId = (guint) _signalId;

	// call function
	result = gtk_widget_can_activate_accel(self, signalId);

	// cleanup parameter self

	// cleanup parameter signalId

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1mnemonic_1activate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _groupCycling
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	gboolean groupCycling;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter groupCycling
	groupCycling = (gboolean) _groupCycling;

	// call function
	result = gtk_widget_mnemonic_activate(self, groupCycling);

	// cleanup parameter self

	// cleanup parameter groupCycling

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1event
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _event
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GdkEvent* event;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter event
	event = (GdkEvent*) _event;

	// call function
	result = gtk_widget_event(self, event);

	// cleanup parameter self

	// cleanup parameter event

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1send_1expose
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _event
)
{
	gint result;
	jint _result;
	GtkWidget* self;
	GdkEvent* event;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter event
	event = (GdkEvent*) _event;

	// call function
	result = gtk_widget_send_expose(self, event);

	// cleanup parameter self

	// cleanup parameter event

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1activate
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_activate(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1scroll_1adjustments
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _hadjustment,
	jlong _vadjustment
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkAdjustment* hadjustment;
	GtkAdjustment* vadjustment;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter hadjustment
	hadjustment = (GtkAdjustment*) _hadjustment;

	// convert parameter vadjustment
	vadjustment = (GtkAdjustment*) _vadjustment;

	// call function
	result = gtk_widget_set_scroll_adjustments(self, hadjustment, vadjustment);

	// cleanup parameter self

	// cleanup parameter hadjustment

	// cleanup parameter vadjustment

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1reparent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _newParent
)
{
	GtkWidget* self;
	GtkWidget* newParent;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter newParent
	newParent = (GtkWidget*) _newParent;

	// call function
	gtk_widget_reparent(self, newParent);

	// cleanup parameter self

	// cleanup parameter newParent
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1intersect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _area,
	jlong _intersection
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GdkRectangle* area;
	GdkRectangle* intersection;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter area
	area = (GdkRectangle*) _area;

	// convert parameter intersection
	intersection = (GdkRectangle*) _intersection;

	// call function
	result = gtk_widget_intersect(self, area, intersection);

	// cleanup parameter self

	// cleanup parameter area

	// cleanup parameter intersection

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1region_1intersect
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _region
)
{
	GdkRegion* result;
	jlong _result;
	GtkWidget* self;
	GdkRegion* region;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter region
	region = (GdkRegion*) _region;

	// call function
	result = gtk_widget_region_intersect(self, region);

	// cleanup parameter self

	// cleanup parameter region

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1freeze_1child_1notify
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_freeze_child_notify(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1child_1notify
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _childProperty
)
{
	GtkWidget* self;
	const gchar* childProperty;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter childProperty
	childProperty = (const gchar*) (*env)->GetStringUTFChars(env, _childProperty, NULL);
	if (childProperty == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_child_notify(self, childProperty);

	// cleanup parameter self

	// cleanup parameter childProperty
	(*env)->ReleaseStringUTFChars(env, _childProperty, childProperty);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1thaw_1child_1notify
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_thaw_child_notify(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1is_1focus
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_is_focus(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1grab_1focus
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_grab_focus(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1grab_1default
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_grab_default(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GtkWidget* self;
	const gchar* name;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_set_name(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1state
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state
)
{
	GtkWidget* self;
	GtkStateType state;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter state
	state = (GtkStateType) _state;

	// call function
	gtk_widget_set_state(self, state);

	// cleanup parameter self

	// cleanup parameter state
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1sensitive
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _sensitive
)
{
	GtkWidget* self;
	gboolean sensitive;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter sensitive
	sensitive = (gboolean) _sensitive;

	// call function
	gtk_widget_set_sensitive(self, sensitive);

	// cleanup parameter self

	// cleanup parameter sensitive
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1app_1paintable
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _appPaintable
)
{
	GtkWidget* self;
	gboolean appPaintable;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter appPaintable
	appPaintable = (gboolean) _appPaintable;

	// call function
	gtk_widget_set_app_paintable(self, appPaintable);

	// cleanup parameter self

	// cleanup parameter appPaintable
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1double_1buffered
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _doubleBuffered
)
{
	GtkWidget* self;
	gboolean doubleBuffered;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter doubleBuffered
	doubleBuffered = (gboolean) _doubleBuffered;

	// call function
	gtk_widget_set_double_buffered(self, doubleBuffered);

	// cleanup parameter self

	// cleanup parameter doubleBuffered
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1redraw_1on_1allocate
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _redrawOnAllocate
)
{
	GtkWidget* self;
	gboolean redrawOnAllocate;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter redrawOnAllocate
	redrawOnAllocate = (gboolean) _redrawOnAllocate;

	// call function
	gtk_widget_set_redraw_on_allocate(self, redrawOnAllocate);

	// cleanup parameter self

	// cleanup parameter redrawOnAllocate
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1parent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _parent
)
{
	GtkWidget* self;
	GtkWidget* parent;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter parent
	parent = (GtkWidget*) _parent;

	// call function
	gtk_widget_set_parent(self, parent);

	// cleanup parameter self

	// cleanup parameter parent
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1parent_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _parentWindow
)
{
	GtkWidget* self;
	GdkWindow* parentWindow;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter parentWindow
	parentWindow = (GdkWindow*) _parentWindow;

	// call function
	gtk_widget_set_parent_window(self, parentWindow);

	// cleanup parameter self

	// cleanup parameter parentWindow
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1child_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _isVisible
)
{
	GtkWidget* self;
	gboolean isVisible;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter isVisible
	isVisible = (gboolean) _isVisible;

	// call function
	gtk_widget_set_child_visible(self, isVisible);

	// cleanup parameter self

	// cleanup parameter isVisible
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1child_1visible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_child_visible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1parent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_parent(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1parent_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_parent_window(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1child_1focus
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _direction
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkDirectionType direction;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter direction
	direction = (GtkDirectionType) _direction;

	// call function
	result = gtk_widget_child_focus(self, direction);

	// cleanup parameter self

	// cleanup parameter direction

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1size_1request
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width,
	jint _height
)
{
	GtkWidget* self;
	gint width;
	gint height;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter width
	width = (gint) _width;

	// convert parameter height
	height = (gint) _height;

	// call function
	gtk_widget_set_size_request(self, width, height);

	// cleanup parameter self

	// cleanup parameter width

	// cleanup parameter height
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1size_1request
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	GtkWidget* self;
	gint* width;
	gint* height;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter width
	width = (gint*) (*env)->GetIntArrayElements(env, _width, NULL);
	if (width == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter height
	height = (gint*) (*env)->GetIntArrayElements(env, _height, NULL);
	if (height == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_get_size_request(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);

	// cleanup parameter height
	(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _events
)
{
	GtkWidget* self;
	gint events;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter events
	events = (gint) _events;

	// call function
	gtk_widget_set_events(self, events);

	// cleanup parameter self

	// cleanup parameter events
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1add_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _events
)
{
	GtkWidget* self;
	gint events;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter events
	events = (gint) _events;

	// call function
	gtk_widget_add_events(self, events);

	// cleanup parameter self

	// cleanup parameter events
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1extension_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _mode
)
{
	GtkWidget* self;
	GdkExtensionMode mode;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter mode
	mode = (GdkExtensionMode) _mode;

	// call function
	gtk_widget_set_extension_events(self, mode);

	// cleanup parameter self

	// cleanup parameter mode
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1extension_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkExtensionMode result;
	jint _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_extension_events(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1toplevel
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_toplevel(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkColormap* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_colormap(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1visual
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkVisual* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_visual(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkScreen* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1has_1screen
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_has_screen(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1display
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkDisplay* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_display(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1root_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GdkWindow* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_root_window(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1settings
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSettings* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_settings(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1accessible
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	AtkObject* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_accessible(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1colormap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _colormap
)
{
	GtkWidget* self;
	GdkColormap* colormap;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter colormap
	colormap = (GdkColormap*) _colormap;

	// call function
	gtk_widget_set_colormap(self, colormap);

	// cleanup parameter self

	// cleanup parameter colormap
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1events
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_events(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1pointer
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _x,
	jintArray _y
)
{
	GtkWidget* self;
	gint* x;
	gint* y;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter x
	x = (gint*) (*env)->GetIntArrayElements(env, _x, NULL);
	if (x == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter y
	y = (gint*) (*env)->GetIntArrayElements(env, _y, NULL);
	if (y == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_get_pointer(self, x, y);

	// cleanup parameter self

	// cleanup parameter x
	(*env)->ReleaseIntArrayElements(env, _x, (jint*)x, 0);

	// cleanup parameter y
	(*env)->ReleaseIntArrayElements(env, _y, (jint*)y, 0);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1is_1ancestor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _ancestor
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkWidget* ancestor;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter ancestor
	ancestor = (GtkWidget*) _ancestor;

	// call function
	result = gtk_widget_is_ancestor(self, ancestor);

	// cleanup parameter self

	// cleanup parameter ancestor

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1translate_1coordinates
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _destWidget,
	jint _srcX,
	jint _srcY,
	jintArray _destX,
	jintArray _destY
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkWidget* destWidget;
	gint srcX;
	gint srcY;
	gint* destX;
	gint* destY;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter destWidget
	destWidget = (GtkWidget*) _destWidget;

	// convert parameter srcX
	srcX = (gint) _srcX;

	// convert parameter srcY
	srcY = (gint) _srcY;

	// convert parameter destX
	destX = (gint*) (*env)->GetIntArrayElements(env, _destX, NULL);
	if (destX == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter destY
	destY = (gint*) (*env)->GetIntArrayElements(env, _destY, NULL);
	if (destY == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_widget_translate_coordinates(self, destWidget, srcX, srcY, destX, destY);

	// cleanup parameter self

	// cleanup parameter destWidget

	// cleanup parameter srcX

	// cleanup parameter srcY

	// cleanup parameter destX
	(*env)->ReleaseIntArrayElements(env, _destX, (jint*)destX, 0);

	// cleanup parameter destY
	(*env)->ReleaseIntArrayElements(env, _destY, (jint*)destY, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1hide_1on_1delete
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_hide_on_delete(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _style
)
{
	GtkWidget* self;
	GtkStyle* style;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter style
	style = (GtkStyle*) _style;

	// call function
	gtk_widget_set_style(self, style);

	// cleanup parameter self

	// cleanup parameter style
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1ensure_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_ensure_style(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkStyle* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _style
)
{
	GtkWidget* self;
	GtkRcStyle* style;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter style
	style = (GtkRcStyle*) _style;

	// call function
	gtk_widget_modify_style(self, style);

	// cleanup parameter self

	// cleanup parameter style
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1modifier_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkRcStyle* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_modifier_style(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1fg
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state,
	jlong _color
)
{
	GtkWidget* self;
	GtkStateType state;
	GdkColor* color;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter state
	state = (GtkStateType) _state;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_widget_modify_fg(self, state, color);

	// cleanup parameter self

	// cleanup parameter state

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1bg
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state,
	jlong _color
)
{
	GtkWidget* self;
	GtkStateType state;
	GdkColor* color;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter state
	state = (GtkStateType) _state;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_widget_modify_bg(self, state, color);

	// cleanup parameter self

	// cleanup parameter state

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state,
	jlong _color
)
{
	GtkWidget* self;
	GtkStateType state;
	GdkColor* color;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter state
	state = (GtkStateType) _state;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_widget_modify_text(self, state, color);

	// cleanup parameter self

	// cleanup parameter state

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1base
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _state,
	jlong _color
)
{
	GtkWidget* self;
	GtkStateType state;
	GdkColor* color;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter state
	state = (GtkStateType) _state;

	// convert parameter color
	color = (GdkColor*) _color;

	// call function
	gtk_widget_modify_base(self, state, color);

	// cleanup parameter self

	// cleanup parameter state

	// cleanup parameter color
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1font
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _fontDesc
)
{
	GtkWidget* self;
	PangoFontDescription* fontDesc;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter fontDesc
	fontDesc = (PangoFontDescription*) _fontDesc;

	// call function
	gtk_widget_modify_font(self, fontDesc);

	// cleanup parameter self

	// cleanup parameter fontDesc
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1create_1pango_1context
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoContext* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_create_pango_context(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1pango_1context
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoContext* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_pango_context(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1create_1pango_1layout
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	PangoLayout* result;
	jlong _result;
	GtkWidget* self;
	const gchar* text;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_widget_create_pango_layout(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1render_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _stockId,
	jint _size,
	jstring _detail
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkWidget* self;
	const gchar* stockId;
	GtkIconSize size;
	const gchar* detail;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter stockId
	stockId = (const gchar*) (*env)->GetStringUTFChars(env, _stockId, NULL);
	if (stockId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter size
	size = (GtkIconSize) _size;

	// convert parameter detail
	if (_detail == NULL) {
		detail = NULL;
	} else {
		detail = (const gchar*) (*env)->GetStringUTFChars(env, _detail, NULL);
		if (detail == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_widget_render_icon(self, stockId, size, detail);

	// cleanup parameter self

	// cleanup parameter stockId
	(*env)->ReleaseStringUTFChars(env, _stockId, stockId);

	// cleanup parameter size

	// cleanup parameter detail
	if (detail != NULL) {
		(*env)->ReleaseStringUTFChars(env, _detail, detail);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1composite_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	GtkWidget* self;
	const gchar* name;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_set_composite_name(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1composite_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_composite_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1reset_1rc_1styles
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_reset_rc_styles(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1style_1get_1property
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _propertyName,
	jlong _value
)
{
	GtkWidget* self;
	const gchar* propertyName;
	GValue* value;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter propertyName
	propertyName = (const gchar*) (*env)->GetStringUTFChars(env, _propertyName, NULL);
	if (propertyName == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (GValue*) _value;

	// call function
	gtk_widget_style_get_property(self, propertyName, value);

	// cleanup parameter self

	// cleanup parameter propertyName
	(*env)->ReleaseStringUTFChars(env, _propertyName, propertyName);

	// cleanup parameter value
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1style_1get
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _firstPropertyName
)
{
	GtkWidget* self;
	const gchar* firstPropertyName;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter firstPropertyName
	firstPropertyName = (const gchar*) (*env)->GetStringUTFChars(env, _firstPropertyName, NULL);
	if (firstPropertyName == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_style_get(self, firstPropertyName, NULL);

	// cleanup parameter self

	// cleanup parameter firstPropertyName
	(*env)->ReleaseStringUTFChars(env, _firstPropertyName, firstPropertyName);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1direction
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _dir
)
{
	GtkWidget* self;
	GtkTextDirection dir;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter dir
	dir = (GtkTextDirection) _dir;

	// call function
	gtk_widget_set_direction(self, dir);

	// cleanup parameter self

	// cleanup parameter dir
}

JNIEXPORT jint JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1direction
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkTextDirection result;
	jint _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_direction(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1shape_1combine_1mask
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _shapeMask,
	jint _offsetX,
	jint _offsetY
)
{
	GtkWidget* self;
	GdkBitmap* shapeMask;
	gint offsetX;
	gint offsetY;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter shapeMask
	shapeMask = (GdkBitmap*) _shapeMask;

	// convert parameter offsetX
	offsetX = (gint) _offsetX;

	// convert parameter offsetY
	offsetY = (gint) _offsetY;

	// call function
	gtk_widget_shape_combine_mask(self, shapeMask, offsetX, offsetY);

	// cleanup parameter self

	// cleanup parameter shapeMask

	// cleanup parameter offsetX

	// cleanup parameter offsetY
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1reset_1shapes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_reset_shapes(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _pathLength,
	jobjectArray _path,
	jobjectArray _pathReversed
)
{
	GtkWidget* self;
	guint* pathLength;
	gchar** path;
	gchar** pathReversed;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter pathLength
	pathLength = (guint*) (*env)->GetIntArrayElements(env, _pathLength, NULL);
	if (pathLength == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter path
	path = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _path);
	if (path == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter pathReversed
	pathReversed = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _pathReversed);
	if (pathReversed == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_path(self, pathLength, path, pathReversed);

	// cleanup parameter self

	// cleanup parameter pathLength
	(*env)->ReleaseIntArrayElements(env, _pathLength, (jint*)pathLength, 0);

	// cleanup parameter path
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)path, _path);

	// cleanup parameter pathReversed
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)pathReversed, _pathReversed);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1class_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _pathLength,
	jobjectArray _path,
	jobjectArray _pathReversed
)
{
	GtkWidget* self;
	guint* pathLength;
	gchar** path;
	gchar** pathReversed;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter pathLength
	pathLength = (guint*) (*env)->GetIntArrayElements(env, _pathLength, NULL);
	if (pathLength == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter path
	path = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _path);
	if (path == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter pathReversed
	pathReversed = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _pathReversed);
	if (pathReversed == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_class_path(self, pathLength, path, pathReversed);

	// cleanup parameter self

	// cleanup parameter pathLength
	(*env)->ReleaseIntArrayElements(env, _pathLength, (jint*)pathLength, 0);

	// cleanup parameter path
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)path, _path);

	// cleanup parameter pathReversed
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)pathReversed, _pathReversed);
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1add_1mnemonic_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _label
)
{
	GtkWidget* self;
	GtkWidget* label;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter label
	label = (GtkWidget*) _label;

	// call function
	gtk_widget_add_mnemonic_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1remove_1mnemonic_1label
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _label
)
{
	GtkWidget* self;
	GtkWidget* label;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter label
	label = (GtkWidget*) _label;

	// call function
	gtk_widget_remove_mnemonic_label(self, label);

	// cleanup parameter self

	// cleanup parameter label
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkAction* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_action(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1set_1track_1motion
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _trackMotion
)
{
	GtkWidget* self;
	gboolean trackMotion;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter trackMotion
	trackMotion = (gboolean) _trackMotion;

	// call function
	gtk_drag_dest_set_track_motion(self, trackMotion);

	// cleanup parameter self

	// cleanup parameter trackMotion
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1drag_1dest_1get_1track_1motion
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_drag_dest_get_track_motion(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1is_1composited
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_is_composited(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1input_1shape_1combine_1mask
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _shapeMask,
	jint _offsetX,
	jint _offsetY
)
{
	GtkWidget* self;
	GdkBitmap* shapeMask;
	gint offsetX;
	gint offsetY;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter shapeMask
	shapeMask = (GdkBitmap*) _shapeMask;

	// convert parameter offsetX
	offsetX = (gint) _offsetX;

	// convert parameter offsetY
	offsetY = (gint) _offsetY;

	// call function
	gtk_widget_input_shape_combine_mask(self, shapeMask, offsetX, offsetY);

	// cleanup parameter self

	// cleanup parameter shapeMask

	// cleanup parameter offsetX

	// cleanup parameter offsetY
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1tooltip_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_tooltip_markup(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1tooltip_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _markup
)
{
	GtkWidget* self;
	const gchar* markup;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter markup
	if (_markup == NULL) {
		markup = NULL;
	} else {
		markup = (const gchar*) (*env)->GetStringUTFChars(env, _markup, NULL);
		if (markup == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_widget_set_tooltip_markup(self, markup);

	// cleanup parameter self

	// cleanup parameter markup
	if (markup != NULL) {
		(*env)->ReleaseStringUTFChars(env, _markup, markup);
	}
}

JNIEXPORT jstring JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1tooltip_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_tooltip_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1tooltip_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text
)
{
	GtkWidget* self;
	const gchar* text;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter text
	text = (const gchar*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_widget_set_tooltip_text(self, text);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1tooltip_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWindow* result;
	jlong _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_tooltip_window(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1tooltip_1window
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _customWindow
)
{
	GtkWidget* self;
	GtkWindow* customWindow;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter customWindow
	customWindow = (GtkWindow*) _customWindow;

	// call function
	gtk_widget_set_tooltip_window(self, customWindow);

	// cleanup parameter self

	// cleanup parameter customWindow
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1get_1has_1tooltip
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	result = gtk_widget_get_has_tooltip(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1set_1has_1tooltip
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _hasTooltip
)
{
	GtkWidget* self;
	gboolean hasTooltip;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter hasTooltip
	hasTooltip = (gboolean) _hasTooltip;

	// call function
	gtk_widget_set_has_tooltip(self, hasTooltip);

	// cleanup parameter self

	// cleanup parameter hasTooltip
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1trigger_1tooltip_1query
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_trigger_tooltip_query(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1error_1bell
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkWidget* self;

	// convert parameter self
	self = (GtkWidget*) _self;

	// call function
	gtk_widget_error_bell(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1keynav_1failed
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _direction
)
{
	gboolean result;
	jboolean _result;
	GtkWidget* self;
	GtkDirectionType direction;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter direction
	direction = (GtkDirectionType) _direction;

	// call function
	result = gtk_widget_keynav_failed(self, direction);

	// cleanup parameter self

	// cleanup parameter direction

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_gtk_GtkWidget_gtk_1widget_1modify_1cursor
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _primary,
	jlong _secondary
)
{
	GtkWidget* self;
	const GdkColor* primary;
	const GdkColor* secondary;

	// convert parameter self
	self = (GtkWidget*) _self;

	// convert parameter primary
	primary = (const GdkColor*) _primary;

	// convert parameter secondary
	secondary = (const GdkColor*) _secondary;

	// call function
	gtk_widget_modify_cursor(self, primary, secondary);

	// cleanup parameter self

	// cleanup parameter primary

	// cleanup parameter secondary
}
