/*
 * PangoAttrList.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoAttrList.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1new
(
	JNIEnv* env,
	jclass cls
)
{
	PangoAttrList* result;
	jlong _result;

	// call function
	result = pango_attr_list_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1ref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAttrList* self;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// call function
	pango_attr_list_ref(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1unref
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAttrList* self;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// call function
	pango_attr_list_unref(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAttrList* result;
	jlong _result;
	PangoAttrList* self;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// call function
	result = pango_attr_list_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1insert
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _attr
)
{
	PangoAttrList* self;
	PangoAttribute* attr;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// convert parameter attr
	attr = (PangoAttribute*) _attr;

	// call function
	pango_attr_list_insert(self, attr);

	// cleanup parameter self

	// cleanup parameter attr
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1insert_1before
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _attr
)
{
	PangoAttrList* self;
	PangoAttribute* attr;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// convert parameter attr
	attr = (PangoAttribute*) _attr;

	// call function
	pango_attr_list_insert_before(self, attr);

	// cleanup parameter self

	// cleanup parameter attr
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1change
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _attr
)
{
	PangoAttrList* self;
	PangoAttribute* attr;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// convert parameter attr
	attr = (PangoAttribute*) _attr;

	// call function
	pango_attr_list_change(self, attr);

	// cleanup parameter self

	// cleanup parameter attr
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1splice
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _other,
	jint _pos,
	jint _len
)
{
	PangoAttrList* self;
	PangoAttrList* other;
	gint pos;
	gint len;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// convert parameter other
	other = (PangoAttrList*) _other;

	// convert parameter pos
	pos = (gint) _pos;

	// convert parameter len
	len = (gint) _len;

	// call function
	pango_attr_list_splice(self, other, pos, len);

	// cleanup parameter self

	// cleanup parameter other

	// cleanup parameter pos

	// cleanup parameter len
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoAttrList_pango_1attr_1list_1get_1iterator
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAttrIterator* result;
	jlong _result;
	PangoAttrList* self;

	// convert parameter self
	self = (PangoAttrList*) _self;

	// call function
	result = pango_attr_list_get_iterator(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}
