/*
 * PangoColor.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoColor.h"

JNIEXPORT jchar JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1get_1red
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// get field value
	result = self->red;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1set_1red
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _red
)
{
	PangoColor* self;
	guint16 red;

	// convert parameter self
	self = (PangoColor*) _self;

	// convert parameter red
	red = (guint16) _red;

	// set field value
	self->red = red;

	// cleanup parameter self

	// cleanup parameter red
}

JNIEXPORT jchar JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1get_1green
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// get field value
	result = self->green;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1set_1green
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _green
)
{
	PangoColor* self;
	guint16 green;

	// convert parameter self
	self = (PangoColor*) _self;

	// convert parameter green
	green = (guint16) _green;

	// set field value
	self->green = green;

	// cleanup parameter self

	// cleanup parameter green
}

JNIEXPORT jchar JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1get_1blue
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint16 result;
	jchar _result;
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// get field value
	result = self->blue;

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jchar) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1set_1blue
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jchar _blue
)
{
	PangoColor* self;
	guint16 blue;

	// convert parameter self
	self = (PangoColor*) _self;

	// convert parameter blue
	blue = (guint16) _blue;

	// set field value
	self->blue = blue;

	// cleanup parameter self

	// cleanup parameter blue
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoColor* result;
	jlong _result;
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// call function
	result = pango_color_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// call function
	pango_color_free(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1parse
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _spec
)
{
	gboolean result;
	jboolean _result;
	PangoColor* self;
	const char* spec;

	// convert parameter self
	self = (PangoColor*) _self;

	// convert parameter spec
	spec = (const char*) (*env)->GetStringUTFChars(env, _spec, NULL);
	if (spec == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = pango_color_parse(self, spec);

	// cleanup parameter self

	// cleanup parameter spec
	(*env)->ReleaseStringUTFChars(env, _spec, spec);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_pango_PangoColor_pango_1color_1to_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar* result;
	jstring _result;
	PangoColor* self;

	// convert parameter self
	self = (PangoColor*) _self;

	// call function
	result = pango_color_to_string(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// cleanup return value
	if (result != NULL) {
		g_free(result);
	}

	// and finally
	return _result;
}
