/*
 * PangoFont.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoFont.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFont_pango_1font_1describe
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoFontDescription* result;
	jlong _result;
	PangoFont* self;

	// convert parameter self
	self = (PangoFont*) _self;

	// call function
	result = pango_font_describe(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFont_pango_1font_1find_1shaper
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _language,
	jint _ch
)
{
	PangoEngineShape* result;
	jlong _result;
	PangoFont* self;
	PangoLanguage* language;
	guint32 ch;

	// convert parameter self
	self = (PangoFont*) _self;

	// convert parameter language
	language = (PangoLanguage*) _language;

	// convert parameter ch
	ch = (guint32) _ch;

	// call function
	result = pango_font_find_shaper(self, language, ch);

	// cleanup parameter self

	// cleanup parameter language

	// cleanup parameter ch

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFont_pango_1font_1get_1metrics
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _language
)
{
	PangoFontMetrics* result;
	jlong _result;
	PangoFont* self;
	PangoLanguage* language;

	// convert parameter self
	self = (PangoFont*) _self;

	// convert parameter language
	language = (PangoLanguage*) _language;

	// call function
	result = pango_font_get_metrics(self, language);

	// cleanup parameter self

	// cleanup parameter language

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFont_pango_1font_1get_1font_1map
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoFontMap* result;
	jlong _result;
	PangoFont* self;

	// convert parameter self
	self = (PangoFont*) _self;

	// call function
	result = pango_font_get_font_map(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
