/*
 * PangoFontMap.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoFontMap.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFontMap_pango_1font_1map_1load_1font
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _context,
	jlong _desc
)
{
	PangoFont* result;
	jlong _result;
	PangoFontMap* self;
	PangoContext* context;
	const PangoFontDescription* desc;

	// convert parameter self
	self = (PangoFontMap*) _self;

	// convert parameter context
	context = (PangoContext*) _context;

	// convert parameter desc
	desc = (const PangoFontDescription*) _desc;

	// call function
	result = pango_font_map_load_font(self, context, desc);

	// cleanup parameter self

	// cleanup parameter context

	// cleanup parameter desc

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoFontMap_pango_1font_1map_1load_1fontset
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _context,
	jlong _desc,
	jlong _language
)
{
	PangoFontset* result;
	jlong _result;
	PangoFontMap* self;
	PangoContext* context;
	const PangoFontDescription* desc;
	PangoLanguage* language;

	// convert parameter self
	self = (PangoFontMap*) _self;

	// convert parameter context
	context = (PangoContext*) _context;

	// convert parameter desc
	desc = (const PangoFontDescription*) _desc;

	// convert parameter language
	language = (PangoLanguage*) _language;

	// call function
	result = pango_font_map_load_fontset(self, context, desc, language);

	// cleanup parameter self

	// cleanup parameter context

	// cleanup parameter desc

	// cleanup parameter language

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
