/*
 * PangoLanguage.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoLanguage.h"

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLanguage_pango_1language_1includes_1script
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _script
)
{
	gboolean result;
	jboolean _result;
	PangoLanguage* self;
	PangoScript script;

	// convert parameter self
	self = (PangoLanguage*) _self;

	// convert parameter script
	script = (PangoScript) _script;

	// call function
	result = pango_language_includes_script(self, script);

	// cleanup parameter self

	// cleanup parameter script

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLanguage_pango_1language_1from_1string
(
	JNIEnv* env,
	jclass cls,
	jstring _language
)
{
	PangoLanguage* result;
	jlong _result;
	const char* language;

	// convert parameter language
	language = (const char*) (*env)->GetStringUTFChars(env, _language, NULL);
	if (language == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = pango_language_from_string(language);

	// cleanup parameter language
	(*env)->ReleaseStringUTFChars(env, _language, language);

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLanguage_pango_1language_1matches
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _rangeList
)
{
	gboolean result;
	jboolean _result;
	PangoLanguage* self;
	const char* rangeList;

	// convert parameter self
	self = (PangoLanguage*) _self;

	// convert parameter rangeList
	rangeList = (const char*) (*env)->GetStringUTFChars(env, _rangeList, NULL);
	if (rangeList == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = pango_language_matches(self, rangeList);

	// cleanup parameter self

	// cleanup parameter rangeList
	(*env)->ReleaseStringUTFChars(env, _rangeList, rangeList);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_pango_PangoLanguage_pango_1language_1to_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const char* result;
	jstring _result;
	PangoLanguage* self;

	// convert parameter self
	self = (PangoLanguage*) _self;

	// call function
	result = pango_language_to_string(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}
