/*
 * PangoLayout.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoLayout.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _context
)
{
	PangoLayout* result;
	jlong _result;
	PangoContext* context;

	// convert parameter context
	context = (PangoContext*) _context;

	// call function
	result = pango_layout_new(context);

	// cleanup parameter context

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1cairo_1create_1layout
(
	JNIEnv* env,
	jclass cls,
	jlong _context
)
{
	PangoLayout* result;
	jlong _result;
	cairo_t* context;

	// convert parameter context
	context = (cairo_t*) _context;

	// call function
	result = pango_cairo_create_layout(context);

	// cleanup parameter context

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoLayout* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1context
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoContext* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_context(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1attributes
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _attrs
)
{
	PangoLayout* self;
	PangoAttrList* attrs;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter attrs
	attrs = (PangoAttrList*) _attrs;

	// call function
	pango_layout_set_attributes(self, attrs);

	// cleanup parameter self

	// cleanup parameter attrs
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1attributes
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAttrList* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_attributes(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _text,
	jint _length
)
{
	PangoLayout* self;
	const char* text;
	int length;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter text
	text = (const char*) (*env)->GetStringUTFChars(env, _text, NULL);
	if (text == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter length
	length = (int) _length;

	// call function
	pango_layout_set_text(self, text, length);

	// cleanup parameter self

	// cleanup parameter text
	(*env)->ReleaseStringUTFChars(env, _text, text);

	// cleanup parameter length
}

JNIEXPORT jstring JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1text
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const char* result;
	jstring _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_text(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1markup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _markup,
	jint _length
)
{
	PangoLayout* self;
	const char* markup;
	int length;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter markup
	markup = (const char*) (*env)->GetStringUTFChars(env, _markup, NULL);
	if (markup == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter length
	length = (int) _length;

	// call function
	pango_layout_set_markup(self, markup, length);

	// cleanup parameter self

	// cleanup parameter markup
	(*env)->ReleaseStringUTFChars(env, _markup, markup);

	// cleanup parameter length
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1font_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _desc
)
{
	PangoLayout* self;
	const PangoFontDescription* desc;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter desc
	desc = (const PangoFontDescription*) _desc;

	// call function
	pango_layout_set_font_description(self, desc);

	// cleanup parameter self

	// cleanup parameter desc
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1font_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const PangoFontDescription* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_font_description(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width
)
{
	PangoLayout* self;
	int width;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter width
	width = (int) _width;

	// call function
	pango_layout_set_width(self, width);

	// cleanup parameter self

	// cleanup parameter width
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1wrap
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _wrap
)
{
	PangoLayout* self;
	PangoWrapMode wrap;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter wrap
	wrap = (PangoWrapMode) _wrap;

	// call function
	pango_layout_set_wrap(self, wrap);

	// cleanup parameter self

	// cleanup parameter wrap
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1wrap
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoWrapMode result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_wrap(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1is_1wrapped
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_is_wrapped(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1indent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _indent
)
{
	PangoLayout* self;
	int indent;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter indent
	indent = (int) _indent;

	// call function
	pango_layout_set_indent(self, indent);

	// cleanup parameter self

	// cleanup parameter indent
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1indent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_indent(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _spacing
)
{
	PangoLayout* self;
	int spacing;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter spacing
	spacing = (int) _spacing;

	// call function
	pango_layout_set_spacing(self, spacing);

	// cleanup parameter self

	// cleanup parameter spacing
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1spacing
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_spacing(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1justify
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _justify
)
{
	PangoLayout* self;
	gboolean justify;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter justify
	justify = (gboolean) _justify;

	// call function
	pango_layout_set_justify(self, justify);

	// cleanup parameter self

	// cleanup parameter justify
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1justify
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_justify(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1auto_1dir
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _autoDir
)
{
	PangoLayout* self;
	gboolean autoDir;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter autoDir
	autoDir = (gboolean) _autoDir;

	// call function
	pango_layout_set_auto_dir(self, autoDir);

	// cleanup parameter self

	// cleanup parameter autoDir
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1auto_1dir
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_auto_dir(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _alignment
)
{
	PangoLayout* self;
	PangoAlignment alignment;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter alignment
	alignment = (PangoAlignment) _alignment;

	// call function
	pango_layout_set_alignment(self, alignment);

	// cleanup parameter self

	// cleanup parameter alignment
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1alignment
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoAlignment result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_alignment(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _tabs
)
{
	PangoLayout* self;
	PangoTabArray* tabs;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter tabs
	tabs = (PangoTabArray*) _tabs;

	// call function
	pango_layout_set_tabs(self, tabs);

	// cleanup parameter self

	// cleanup parameter tabs
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoTabArray* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_tabs(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1single_1paragraph_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _setting
)
{
	PangoLayout* self;
	gboolean setting;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter setting
	setting = (gboolean) _setting;

	// call function
	pango_layout_set_single_paragraph_mode(self, setting);

	// cleanup parameter self

	// cleanup parameter setting
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1single_1paragraph_1mode
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_single_paragraph_mode(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1set_1ellipsize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _ellipsize
)
{
	PangoLayout* self;
	PangoEllipsizeMode ellipsize;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter ellipsize
	ellipsize = (PangoEllipsizeMode) _ellipsize;

	// call function
	pango_layout_set_ellipsize(self, ellipsize);

	// cleanup parameter self

	// cleanup parameter ellipsize
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1ellipsize
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoEllipsizeMode result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_ellipsize(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1is_1ellipsized
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_is_ellipsized(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1unknown_1glyphs_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_unknown_glyphs_count(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1context_1changed
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	pango_layout_context_changed(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1index_1to_1pos
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index,
	jlong _pos
)
{
	PangoLayout* self;
	int index;
	PangoRectangle* pos;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter index
	index = (int) _index;

	// convert parameter pos
	pos = (PangoRectangle*) _pos;

	// call function
	pango_layout_index_to_pos(self, index, pos);

	// cleanup parameter self

	// cleanup parameter index

	// cleanup parameter pos
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1cursor_1pos
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _index,
	jlong _strongPos,
	jlong _weakPos
)
{
	PangoLayout* self;
	int index;
	PangoRectangle* strongPos;
	PangoRectangle* weakPos;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter index
	index = (int) _index;

	// convert parameter strongPos
	strongPos = (PangoRectangle*) _strongPos;

	// convert parameter weakPos
	weakPos = (PangoRectangle*) _weakPos;

	// call function
	pango_layout_get_cursor_pos(self, index, strongPos, weakPos);

	// cleanup parameter self

	// cleanup parameter index

	// cleanup parameter strongPos

	// cleanup parameter weakPos
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1move_1cursor_1visually
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _strong,
	jint _oldIndex,
	jint _oldTrailing,
	jint _direction,
	jintArray _newIndex,
	jintArray _newTrailing
)
{
	PangoLayout* self;
	gboolean strong;
	int oldIndex;
	int oldTrailing;
	int direction;
	int* newIndex;
	int* newTrailing;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter strong
	strong = (gboolean) _strong;

	// convert parameter oldIndex
	oldIndex = (int) _oldIndex;

	// convert parameter oldTrailing
	oldTrailing = (int) _oldTrailing;

	// convert parameter direction
	direction = (int) _direction;

	// convert parameter newIndex
	newIndex = (int*) (*env)->GetIntArrayElements(env, _newIndex, NULL);
	if (newIndex == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter newTrailing
	newTrailing = (int*) (*env)->GetIntArrayElements(env, _newTrailing, NULL);
	if (newTrailing == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	pango_layout_move_cursor_visually(self, strong, oldIndex, oldTrailing, direction, newIndex, newTrailing);

	// cleanup parameter self

	// cleanup parameter strong

	// cleanup parameter oldIndex

	// cleanup parameter oldTrailing

	// cleanup parameter direction

	// cleanup parameter newIndex
	(*env)->ReleaseIntArrayElements(env, _newIndex, (jint*)newIndex, 0);

	// cleanup parameter newTrailing
	(*env)->ReleaseIntArrayElements(env, _newTrailing, (jint*)newTrailing, 0);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1xy_1to_1index
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _x,
	jint _y,
	jintArray _index,
	jintArray _trailing
)
{
	gboolean result;
	jboolean _result;
	PangoLayout* self;
	int x;
	int y;
	int* index;
	int* trailing;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter x
	x = (int) _x;

	// convert parameter y
	y = (int) _y;

	// convert parameter index
	index = (int*) (*env)->GetIntArrayElements(env, _index, NULL);
	if (index == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter trailing
	trailing = (int*) (*env)->GetIntArrayElements(env, _trailing, NULL);
	if (trailing == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = pango_layout_xy_to_index(self, x, y, index, trailing);

	// cleanup parameter self

	// cleanup parameter x

	// cleanup parameter y

	// cleanup parameter index
	(*env)->ReleaseIntArrayElements(env, _index, (jint*)index, 0);

	// cleanup parameter trailing
	(*env)->ReleaseIntArrayElements(env, _trailing, (jint*)trailing, 0);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1extents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _inkRect,
	jlong _logicalRect
)
{
	PangoLayout* self;
	PangoRectangle* inkRect;
	PangoRectangle* logicalRect;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter inkRect
	inkRect = (PangoRectangle*) _inkRect;

	// convert parameter logicalRect
	logicalRect = (PangoRectangle*) _logicalRect;

	// call function
	pango_layout_get_extents(self, inkRect, logicalRect);

	// cleanup parameter self

	// cleanup parameter inkRect

	// cleanup parameter logicalRect
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1pixel_1extents
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _inkRect,
	jlong _logicalRect
)
{
	PangoLayout* self;
	PangoRectangle* inkRect;
	PangoRectangle* logicalRect;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter inkRect
	inkRect = (PangoRectangle*) _inkRect;

	// convert parameter logicalRect
	logicalRect = (PangoRectangle*) _logicalRect;

	// call function
	pango_layout_get_pixel_extents(self, inkRect, logicalRect);

	// cleanup parameter self

	// cleanup parameter inkRect

	// cleanup parameter logicalRect
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	PangoLayout* self;
	int* width;
	int* height;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter width
	if (_width == NULL) {
		width = NULL;
	} else {
		width = (int*) (*env)->GetIntArrayElements(env, _width, NULL);
		if (width == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter height
	if (_height == NULL) {
		height = NULL;
	} else {
		height = (int*) (*env)->GetIntArrayElements(env, _height, NULL);
		if (height == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	pango_layout_get_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	if (width != NULL) {
		(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);
	}

	// cleanup parameter height
	if (height != NULL) {
		(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
	}
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1pixel_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jintArray _width,
	jintArray _height
)
{
	PangoLayout* self;
	int* width;
	int* height;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter width
	if (_width == NULL) {
		width = NULL;
	} else {
		width = (int*) (*env)->GetIntArrayElements(env, _width, NULL);
		if (width == NULL) {
			return; // Java Exception already thrown
		}
	}

	// convert parameter height
	if (_height == NULL) {
		height = NULL;
	} else {
		height = (int*) (*env)->GetIntArrayElements(env, _height, NULL);
		if (height == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	pango_layout_get_pixel_size(self, width, height);

	// cleanup parameter self

	// cleanup parameter width
	if (width != NULL) {
		(*env)->ReleaseIntArrayElements(env, _width, (jint*)width, 0);
	}

	// cleanup parameter height
	if (height != NULL) {
		(*env)->ReleaseIntArrayElements(env, _height, (jint*)height, 0);
	}
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1line_1count
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_line_count(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1line
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _line
)
{
	PangoLayoutLine* result;
	jlong _result;
	PangoLayout* self;
	int line;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter line
	line = (int) _line;

	// call function
	result = pango_layout_get_line(self, line);

	// cleanup parameter self

	// cleanup parameter line

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1line_1readonly
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _line
)
{
	PangoLayoutLine* result;
	jlong _result;
	PangoLayout* self;
	int line;

	// convert parameter self
	self = (PangoLayout*) _self;

	// convert parameter line
	line = (int) _line;

	// call function
	result = pango_layout_get_line_readonly(self, line);

	// cleanup parameter self

	// cleanup parameter line

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1lines
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_lines(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlongArray JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1lines_1readonly
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GSList* result;
	jlongArray _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_lines_readonly(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlongArray) bindings_java_convert_gslist_to_jarray(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1iter
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoLayoutIter* result;
	jlong _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_iter(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoLayout_pango_1layout_1get_1baseline
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	int result;
	jint _result;
	PangoLayout* self;

	// convert parameter self
	self = (PangoLayout*) _self;

	// call function
	result = pango_layout_get_baseline(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}
