/*
 * PangoTabArray.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_pango_PangoTabArray.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1new
(
	JNIEnv* env,
	jclass cls,
	jint _initialSize,
	jboolean _positionsInPixels
)
{
	PangoTabArray* result;
	jlong _result;
	gint initialSize;
	gboolean positionsInPixels;

	// convert parameter initialSize
	initialSize = (gint) _initialSize;

	// convert parameter positionsInPixels
	positionsInPixels = (gboolean) _positionsInPixels;

	// call function
	result = pango_tab_array_new(initialSize, positionsInPixels);

	// cleanup parameter initialSize

	// cleanup parameter positionsInPixels

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1new_1with_1positions
(
	JNIEnv* env,
	jclass cls,
	jint _size,
	jboolean _positionsInPixels,
	jint _firstAlignment,
	jint _firstPosition
)
{
	PangoTabArray* result;
	jlong _result;
	gint size;
	gboolean positionsInPixels;
	PangoTabAlign firstAlignment;
	gint firstPosition;

	// convert parameter size
	size = (gint) _size;

	// convert parameter positionsInPixels
	positionsInPixels = (gboolean) _positionsInPixels;

	// convert parameter firstAlignment
	firstAlignment = (PangoTabAlign) _firstAlignment;

	// convert parameter firstPosition
	firstPosition = (gint) _firstPosition;

	// call function
	result = pango_tab_array_new_with_positions(size, positionsInPixels, firstAlignment, firstPosition, NULL);

	// cleanup parameter size

	// cleanup parameter positionsInPixels

	// cleanup parameter firstAlignment

	// cleanup parameter firstPosition

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1copy
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoTabArray* result;
	jlong _result;
	PangoTabArray* self;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// call function
	result = pango_tab_array_copy(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1free
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	PangoTabArray* self;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// call function
	pango_tab_array_free(self);

	// cleanup parameter self
}

JNIEXPORT jint JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1get_1size
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	PangoTabArray* self;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// call function
	result = pango_tab_array_get_size(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1resize
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _newSize
)
{
	PangoTabArray* self;
	gint newSize;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// convert parameter newSize
	newSize = (gint) _newSize;

	// call function
	pango_tab_array_resize(self, newSize);

	// cleanup parameter self

	// cleanup parameter newSize
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1set_1tab
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _tabIndex,
	jint _alignment,
	jint _location
)
{
	PangoTabArray* self;
	gint tabIndex;
	PangoTabAlign alignment;
	gint location;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// convert parameter tabIndex
	tabIndex = (gint) _tabIndex;

	// convert parameter alignment
	alignment = (PangoTabAlign) _alignment;

	// convert parameter location
	location = (gint) _location;

	// call function
	pango_tab_array_set_tab(self, tabIndex, alignment, location);

	// cleanup parameter self

	// cleanup parameter tabIndex

	// cleanup parameter alignment

	// cleanup parameter location
}

JNIEXPORT void JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1get_1tab
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _tabIndex,
	jintArray _alignment,
	jintArray _location
)
{
	PangoTabArray* self;
	gint tabIndex;
	PangoTabAlign* alignment;
	gint* location;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// convert parameter tabIndex
	tabIndex = (gint) _tabIndex;

	// convert parameter alignment
	alignment = (PangoTabAlign*) (*env)->GetIntArrayElements(env, _alignment, NULL);
	if (alignment == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter location
	location = (gint*) (*env)->GetIntArrayElements(env, _location, NULL);
	if (location == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	pango_tab_array_get_tab(self, tabIndex, alignment, location);

	// cleanup parameter self

	// cleanup parameter tabIndex

	// cleanup parameter alignment
	(*env)->ReleaseIntArrayElements(env, _alignment, (jint*)alignment, 0);

	// cleanup parameter location
	(*env)->ReleaseIntArrayElements(env, _location, (jint*)location, 0);
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_pango_PangoTabArray_pango_1tab_1array_1get_1positions_1in_1pixels
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	PangoTabArray* self;

	// convert parameter self
	self = (PangoTabArray*) _self;

	// call function
	result = pango_tab_array_get_positions_in_pixels(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
