/*
 * ScreenshotCapture.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include "bindings_java.h"
#include "org_gnome_screenshot_ScreenshotCapture.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_screenshot_ScreenshotCapture_gnome_1screenshot_1capture
(
	JNIEnv* env,
	jclass cls,
	jboolean _windowOnly,
	jboolean _includeBorder,
	jstring _borderEffect
)
{
	GdkPixbuf* result;
	jlong _result;
	gboolean windowOnly;
	gboolean includeBorder;
	const gchar* borderEffect;

	// convert parameter windowOnly
	windowOnly = (gboolean) _windowOnly;

	// convert parameter includeBorder
	includeBorder = (gboolean) _includeBorder;

	// convert parameter borderEffect
	borderEffect = (const gchar*) (*env)->GetStringUTFChars(env, _borderEffect, NULL);
	if (borderEffect == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gnome_screenshot_capture(windowOnly, includeBorder, borderEffect);

	// cleanup parameter windowOnly

	// cleanup parameter includeBorder

	// cleanup parameter borderEffect
	(*env)->ReleaseStringUTFChars(env, _borderEffect, borderEffect);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
