/*
 * GtkPageSetupUnixDialog.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtk/gtkunixprint.h>
#include "bindings_java.h"
#include "org_gnome_unixprint_GtkPageSetupUnixDialog.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPageSetupUnixDialog_gtk_1page_1setup_1unix_1dialog_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _title,
	jlong _parent
)
{
	GtkWidget* result;
	jlong _result;
	const gchar* title;
	GtkWindow* parent;

	// convert parameter title
	if (_title == NULL) {
		title = NULL;
	} else {
		title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
		if (title == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter parent
	parent = (GtkWindow*) _parent;

	// call function
	result = gtk_page_setup_unix_dialog_new(title, parent);

	// cleanup parameter title
	if (title != NULL) {
		(*env)->ReleaseStringUTFChars(env, _title, title);
	}

	// cleanup parameter parent

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_unixprint_GtkPageSetupUnixDialog_gtk_1page_1setup_1unix_1dialog_1set_1page_1setup
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _pageSetup
)
{
	GtkPageSetupUnixDialog* self;
	GtkPageSetup* pageSetup;

	// convert parameter self
	self = (GtkPageSetupUnixDialog*) _self;

	// convert parameter pageSetup
	pageSetup = (GtkPageSetup*) _pageSetup;

	// call function
	gtk_page_setup_unix_dialog_set_page_setup(self, pageSetup);

	// cleanup parameter self

	// cleanup parameter pageSetup
}

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPageSetupUnixDialog_gtk_1page_1setup_1unix_1dialog_1get_1page_1setup
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPageSetup* result;
	jlong _result;
	GtkPageSetupUnixDialog* self;

	// convert parameter self
	self = (GtkPageSetupUnixDialog*) _self;

	// call function
	result = gtk_page_setup_unix_dialog_get_page_setup(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_unixprint_GtkPageSetupUnixDialog_gtk_1page_1setup_1unix_1dialog_1set_1print_1settings
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _printSettings
)
{
	GtkPageSetupUnixDialog* self;
	GtkPrintSettings* printSettings;

	// convert parameter self
	self = (GtkPageSetupUnixDialog*) _self;

	// convert parameter printSettings
	printSettings = (GtkPrintSettings*) _printSettings;

	// call function
	gtk_page_setup_unix_dialog_set_print_settings(self, printSettings);

	// cleanup parameter self

	// cleanup parameter printSettings
}

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPageSetupUnixDialog_gtk_1page_1setup_1unix_1dialog_1get_1print_1settings
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintSettings* result;
	jlong _result;
	GtkPageSetupUnixDialog* self;

	// convert parameter self
	self = (GtkPageSetupUnixDialog*) _self;

	// call function
	result = gtk_page_setup_unix_dialog_get_print_settings(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
