/*
 * GtkPrintJob.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtk/gtkunixprint.h>
#include "bindings_java.h"
#include "org_gnome_unixprint_GtkPrintJob.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _title,
	jlong _printer,
	jlong _settings,
	jlong _pageSetup
)
{
	GtkPrintJob* result;
	jlong _result;
	const gchar* title;
	GtkPrinter* printer;
	GtkPrintSettings* settings;
	GtkPageSetup* pageSetup;

	// convert parameter title
	title = (const gchar*) (*env)->GetStringUTFChars(env, _title, NULL);
	if (title == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter printer
	printer = (GtkPrinter*) _printer;

	// convert parameter settings
	settings = (GtkPrintSettings*) _settings;

	// convert parameter pageSetup
	pageSetup = (GtkPageSetup*) _pageSetup;

	// call function
	result = gtk_print_job_new(title, printer, settings, pageSetup);

	// cleanup parameter title
	(*env)->ReleaseStringUTFChars(env, _title, title);

	// cleanup parameter printer

	// cleanup parameter settings

	// cleanup parameter pageSetup

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1settings
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintSettings* result;
	jlong _result;
	GtkPrintJob* self;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_settings(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1printer
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrinter* result;
	jlong _result;
	GtkPrintJob* self;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_printer(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1title
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkPrintJob* self;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_title(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jint JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1status
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkPrintStatus result;
	jint _result;
	GtkPrintJob* self;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_status(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1set_1source_1file
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _filename
)
{
	gboolean result;
	jboolean _result;
	GtkPrintJob* self;
	const gchar* filename;
	GError* error = NULL;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// convert parameter filename
	filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
	if (filename == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = gtk_print_job_set_source_file(self, filename, &error);

	// cleanup parameter self

	// cleanup parameter filename
	(*env)->ReleaseStringUTFChars(env, _filename, filename);

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1surface
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	cairo_surface_t* result;
	jlong _result;
	GtkPrintJob* self;
	GError* error = NULL;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_surface(self, &error);

	// cleanup parameter self

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return 0L;
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1set_1track_1print_1status
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _trackStatus
)
{
	GtkPrintJob* self;
	gboolean trackStatus;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// convert parameter trackStatus
	trackStatus = (gboolean) _trackStatus;

	// call function
	gtk_print_job_set_track_print_status(self, trackStatus);

	// cleanup parameter self

	// cleanup parameter trackStatus
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_unixprint_GtkPrintJob_gtk_1print_1job_1get_1track_1print_1status
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkPrintJob* self;

	// convert parameter self
	self = (GtkPrintJob*) _self;

	// call function
	result = gtk_print_job_get_track_print_status(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
